2009-08-11  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (missingPackagesAndExecutables):
	Accept a filter of "-" (Ubuntu #411376).

2009-06-23  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Don't log
	non-fatal traceback messages if we cannot connect to the IPP
	printer (bug #507629).

2009-06-23  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckPrinterSanity.py (CheckPrinterSanity.display):
	Parse nmblookup failures correctly (from bug #507442).

2009-06-19  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Call "hp-info" with the "-x" option.
	Then it works also when there is no CUPS queue for the URI.

	* cupshelpers/ppds.py: Support for the new CUPS Raster driver of HPLIP
	(hpcups). Use it preferably.

2009-05-13  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py (NewPrinterGUI.fetchJockeyDriver):
	While waiting for Jockey to download a driver from OpenPrinting,
	check whether the CUPS connection stays stable and re-establish it
	if it gets lost. Sometimes the installation of a driver package
	breaks down the connection to CUPS (probably due to the restart of
	CUPS).

2009-04-29  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Compare make and model names
	case-insensitively when positioning the cursor in the make/model
	selection list (Ubuntu bug #365329).
	Made sure that print queue name suggestion is always generated
	(Ubuntu bug #363522, comment 6).

	* cupshelpers/ppds.py: Let the getPPDNameFromDeviceID() function
	always output which PPD got selected.

2009-04-28  Tim Waugh  <twaugh@redhat.com>

	* glade/NewPrinterWindow.glade: Adjusted border padding for New
	Printer window (bug #493862).

2009-04-20  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Made call of hp-plugin also working with
	HPLIP 3.9.2.

2009-04-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_btnIPPVerify_clicked): Fixed URI parsing.

2009-04-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Set relaxed PPD conformance (trac #159).
	* applet.py (NewPrinterNotification.NewPrinter): Likewise.

2009-04-01  Till Kamppeter  <till.kamppeter@gmail.com>

	* cupshelpers/cupshelpers.py (_expand_flags): Do not use
	locale.setlocale() to only convert uppercase to lowercase letters in
	pure ASCII text. With many locales Python bugs get be triggered by
	that. Define a simple case-conversion function which does not use
	any locale-dependent constant or function (Ubuntu #340932).

	* applet.py, glade.py, glade/PrintersWindow.glade, jobviewer.py,
	system-config-printer.py: Added support for notfication daemons which
	do not support action buttons in the notification bubbles. Now the
	capabilities of the notification server are checked and if needed,
	alternative notifications are used (Ubuntu #328604, #339847). Thanks to
	David Barth and Ken VanDine (both from Ubuntu) to make the patch.

2009-03-20  Till Kamppeter  <till.kamppeter@gmail.com>

	* cupshelpers/ppds.py: Improved identification of detected printers:
	   o HP's PPD files in HPLIP 3.9.2 have totally broken device IDs, all
	     lowercase and underscores instead of spaces, not really what
	     the printer reports. Added workarounds to match them with the
	     real device IDs (Ubuntu #306301).
	   o Match the model names of the PPDs case-insensitive with the
	     model names of the detected printer. Some printers, like the
	     HP DeskJet 895C report an all-uppercase model name
	     (Ubuntu #306301).

2009-03-17  Till Kamppeter  <till.kamppeter@gmail.com>

	* cupshelpers/ppds.py: Improved identification of detected printers:
	   o HP introduced a lot of abbreviations (like LJ, DJ, OJ, PS, ...)
	     in the model names of their PPDs in HPLIP 3.9.2. These
	     abbreviations are not used in device IDs. Now we expand the
	     abbreviations in ppdMakeModelSplit() and take them also into
	     account when we have to guess a missing manufacturer name.
	   o Let ppdMakeModelSplit() also truncate the model name on the
	     string "hpijs", from HPLIP 3.9.2 on there is no "Foomatic" in
	     the NickNames of the PPDs any more.
	   o Make guessing of manufacturer names in ppdMakeModelSplit() also
	     working if there is whitespace in the beginning of the input
	     string.
           o Protect the manufacturer/model lists from being messed up by
	     TurboPrint PPDs. They have manufacturer and model being stuffed
	     into the manufacturer field, so each printer appeared as its own
	     manufacturer (ppdMakeModelSplit()).
	   o Make TurboPrint PPDs lowest priority, as this is a non-free
	     third-party driver (_getDriverType()).
	   o If no manufacturer name is supplied to the
	     getPPDNameFromDeviceID() function (broken device ID from network
	     CUPS backend), call ppdMakeModelSplit() to find out the 
	     manufacturer via the model name.

2009-03-16  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.__init__): Initialise update_timer to
	prevent tracebacks if the connection fails (Ubuntu #343387).

2009-03-10  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py (ppdMakeModelSplit): Strip " hpijs" from PPD
	names.
	(ppdMakeModelSplit.strip_suffix): Removed dead code.

2009-03-10  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py (PPDs.getPPDNameFromDeviceID): Better PPD
	fallback searching.

2009-03-10  Till Kamppeter  <till.kamppeter@gmail.com>

	* newprinternotification.conf: Adapted D-Bus policy file to the
	new D-Bus defaults (Ubuntu #318776).

2009-03-10  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py (PPDs._findBestMatchPPDs): Don't try search
	for a model series if there are no digits in the model name.

2009-03-09  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (Printer._expand_flags): Use
	setlocale() to save current LC_CTYPE value, not getlocale() (bug
	#489313).

2009-03-03  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckPrinterSanity.py (CheckPrinterSanity.display):
	Include local printer attributes in diagnostic output.

2009-03-02  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDeviceURIs_cursor_changed): Clear LPD
	drop-down list.

2009-02-25  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDeviceURIs_cursor_changed): Set initial
	sensitivity of LPD probe button.
	(NewPrinterGUI.on_cmbentNPTLpdHost_changed): Adjust button
	sensitivity when hostname is changed.

2009-02-18  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (Printer._expand_flags): Perform
	lowercase operations in locale-independent manner (trac #151).

2009-02-16  Till Kamppeter  <till.kamppeter@gmail.com>

	* applet.py: Fixed switch between the notification for the case that
	a queue got created and the case that no queue got created.

2009-02-13  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py (get_hpfax_device_id): Return None
	if the "fax-type" is 0, this means that fax is not available
	on the given printer.

2009-02-13  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py, troubleshoot/CheckPrinterSanity.py:
	Fixed "hp-info" calls: There should be no space between "-d" and
	the "URI" to work around HPLIP option parsing bug.

2009-02-15  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Added functionality to automatically
	recognize whether the proprietary plug-in of HPLIP is useful or
	even required and to aks the user whether he want to download and
	install it. This way the setup of HP printers which require the
	plugin (especially the printers requiring firmware, as LaserJet
	1000, 1005, 1018, 1020) is intuitive and the user does not end up
	with non-working queues (fixes long-standing Ubuntu bug LP: #96454).
	To achieve maximum compatibility with Ubuntu, an hp-plugin call
	failing due to PyQt not installed is caught and then the text mode
	version of hp-plugin is called in a terminal window.

2009-02-12  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Skip selection of manufacturer, model,
	and driver in the new-printer wizard if an exact driver match has 
	been found (trac #141).

2009-02-11  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py, applet.py: Support for auto-detection
	of printers vis hal-cups-utils without hal-cups-utils creating a
	queue, especially if there is no driver specifically assigned to
	the detected printer. This way the user does not get confused by a
	non-working queue when he ignores the notifications of the applet.
	In such a case hal-cups-utils sends the CUPS URI resulting from
	the auto-detection in the place of the queue name. the applet does
	an appropriate notification then and if the user clicks the
	button, system-config-printer is started with the new-printer
	wizard direcly opening, but skipping the device selection step.

2009-02-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.setDataButtonState): Don't allow
	PPD changes when there are conflicts (trac #144).

2009-02-11  Tim Waugh  <twaugh@redhat.com>

	* optionwidgets.py (Option.checkConflicts): Check constraints in
	reverse as well, so that constraint checking is symmetrical.

2009-02-11  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Don't display a
	notification when authentication is required, just go straight to
	the authentication dialog.  Don't grab keyboard and pointer for
	that dialog and instead let the window manager prevent keyboard
	input accidentally going to the wrong window.

2009-02-11  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection._perform_authentication): Don't grab
	keyboard and pointer when displaying authentication dialog.
	Instead let the window manager prevent keyboard input accidentally
	going to the wrong window.

2009-02-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.on_btnNPApply_clicked):
	Don't show wait window when adding a new printer, as that may	
	require an authentication dialog and we don't want them competing
	for focus (bug #484960).

2009-02-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.getNPPPD): Fixed
	indentation.

2009-02-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.getJockeyDriver_thread):
	Handle D-Bus failures when connecting to the session bus (bug
	#484402).

2009-02-04  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.set_statusicon_visibility): Fixed typo.
	(JobViewer.job_added): Only add this job to the active set if it
	is active; otherwise, remove it from the set if it is there.
	(JobViewer.job_event): If the emptiness of the active set has
	changed, update the status icon (trac #140).

2009-02-04  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.set_statusicon_visibility): Don't
	display status icon for completed jobs (trac #140).

2009-01-27  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_troubleshoot_activate): Don't
	make the troubleshooter window transient for the main window (bug
	#481505).

2009-01-27  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/PrintTestPage.py (PrintTestPage): Use authenticated
	connection, except when printing the test page.

2009-01-27  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.get_hpfax_device_id):
	Fixed traceback while fetching hpfax device ID (Ubuntu #321139).

2009-01-27  Tim Waugh  <twaugh@redhat.com>

	* newprinternotification.conf: Specify both send_destination and
	send_interface for allow/deny rules.

2009-01-26  Tim Waugh  <twaugh@redhat.com>

	* optionwidgets.py: Find parent window to set Conflicts dialog
	transient for.
	* system-config-printer.glade: Distinct response ID for
	Conflicts button.
	* system-config-printer.py: Fixed conflicts button.

2009-01-26  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.fillMakeList): Use
	set_cursor (trac #142).
	(NewPrinterGUI.fillModelList): Likewise.

2009-01-22  Tim Waugh  <twaugh@redhat.com>

	* glade/JobsWindow.glade: Better default height for jobs window.

2009-01-16  Tim Waugh  <twaugh@redhat.com>

	* AdvancedServerSettings.py
	(AdvancedServerSettingsDialog.on_response): Give a callback on
	apply.
	* system-config-printer.py (GUI.on_adv_server_settings_apply):
	Refresh server settings when the advanced server settings dialog
	has finished (trac #133).

2009-01-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Prevent traceback.
	(NewPrinterGUI.device_row_activated): Collapse/expand device rows
	on activation.

2009-01-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillPrinterTab): Avoid traceback
	with raw queues.

2009-01-13  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDownloadableDrivers_cursor_changed): Fixed
	traceback (Ubuntu #316828).

2009-01-13  Tim Waugh  <twaugh@redhat.com>

	* glade/ConnectDialog.glade, glade/NewPrinterWindow.glade,
	glade/PrinterPropertiesDialog.glade: Added accessibility
	relations, patch from Ghee Teo (trac #136).

2009-01-12  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.on_btnNPApply_clicked):
	Treat classes the same as printers after adding them: enable them
	and set them accepting jobs (trac #132).

2009-01-12  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.__init__): Handle exception from
	dbus.SystemBus() (bug #479534).
	(Monitor.cleanup): Only remove the D-Bus signal receiver if we
	managed to add it in the first place.

2009-01-08  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.dests_iconview_item_activated):
	Use set_cursor here to match change introduced when fixing
	Ubuntu #282634.

2009-01-08  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.now_connected): Handle notification
	closure for re-connected printers correctly.

2009-01-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Advertise correct
	defaults for page-left, page-right, page-top and page-bottom job
	options (bug #468553).

2009-01-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPMakes_cursor_changed): Use get_cursor here.
	(NewPrinterGUI.on_tvNPModels_cursor_changed): Likewise (Ubuntu
	#299724).
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Likewise.

2008-12-19  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.in: Set prefix environment variable here,
	partially reverting earlier change.
	* system-config-printer-applet.in: Likewise.
	* my-default-printer.in: Likewise.

2008-12-19  Tim Waugh  <twaugh@redhat.com>

	* PhysicalDevice.py (PhysicalDevice.get_info): The hpfax backend
	wants to tell us that the device make and model is "HP Fax", so
	ignore that useless field and use the device-info field instead.

2008-12-19  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Prevent
	traceback when adding a printer driven by HPLIP (bug #477107).

2008-12-16  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (EXTRA_DIST): Ship config.py.in.
	(DISTCLEANFILES): Clean config.py.

2008-12-15  Till Kamppeter  <till.kamppeter@gmail.com>

	* cupshelpers/openprinting.py (OpenPrinting.searchPrinters):
	The search term must be submitted with the query as the "printer"
	argument and not as the "make" argument.

2008-12-15  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.refresh): Use getPrinters instead of
	getDests to avoid character encoding problems.

2008-12-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.on_btnNPApply_clicked):
	Convert name of new printer to unicode (trac #124).

2008-12-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.browse_ipp_queues_thread): Split port out from host
	string if required (bug #476396).

2008-12-13  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(GUI.on_tvPrinterProperties_cursor_changed): Use get_cursor here
	(Ubuntu #282634).

2008-12-13  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.on_btnNPApply_clicked):
	Check we have a real PPD before trying to copy options (Ubuntu
	#285133).

2008-12-13  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnPrintTestPage_clicked):
	Display an error dialog if unable to connect to server (Ubuntu
	#286943).

2008-12-13  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py (PPDs._findBestMatchPPDs): Handle model
	names with more than one set of digits (Ubuntu #251244).

2008-12-12  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/__init__.py (Troubleshooter.is_moving_backwards):
	Allow troubleshooter pages to know the direction we're going.

	* troubleshoot/DeviceListed.py (DeviceListed.display): Don't
	perform expensive operation if we're moving backwards and this
	page will not be displayed.

2008-12-11  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/ErrorLogCheckpoint.py
	(ErrorLogCheckpoint.enable_clicked): Reconnect after adjusting
	server settings.
	* troubleshoot/ErrorLogFetch.py (ErrorLogFetch.button_clicked):
	Likewise.

2008-12-11  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/ErrorLogCheckpoint.py
	(ErrorLogCheckpoint.enable_clicked): Handle values like '1m' for
	MaxLogSize.

2008-12-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.server_settings_response): Reload
	server settings after advanced server settings dialog has
	finished.

2008-12-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.populateList): Allow prompting
	again even if we disallowed it for one operation.

2008-12-04  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillPrinterTab): Localize a copy
	of the PPD, retaining the original in-memory representation.
	(GUI.fillPrinterOptions): Use the localized PPD for widget labels,
	and the original PPD for value writebacks.
	(NewPrinterGUI.getNPPPD): Don't localize PPDs here.
	(NewPrinterGUI.on_btnNPApply_clicked): Likewise.

2008-12-04  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (Printer.__init__, Printer.getPPD):
	Cache the temporary PPD filename instead of the in-memory
	representation, to allow for a separate localized in-memory copy.
	(Printer.__del__): Remove the temporary PPD file.

2008-11-27  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.fillDeviceTab): Removed
	some dead code.

2008-11-26  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/ErrorLogCheckpoint.py
	(ErrorLogCheckpoint.collect_answer): Make sure to use
	authenticated connection here.

2008-11-26  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/DeviceListed.py (DeviceListed.display): Avoid
	traceback if getDevices fails.

2008-11-24  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckLocalServerPublishing.py
	(CheckLocalServerPublishing.__init__): Fixed option description
	(bug #462934).

2008-11-24  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/ErrorLogCheckpoint.py
	(ErrorLogCheckpoint.collect_answer): Prevent exception when
	getFile fails.
	* troubleshoot/ErrorLogFetch.py (ErrorLogFetch.display): Likewise.
	* troubleshoot/PrintTestPage.py (PrintTestPage.print_clicked):
	Likewise for printTestPage.

2008-11-24  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.maintenance_command): Remove
	temporary file.

2008-11-24  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py
	(missingPackagesAndExecutables): Don't leak file descriptors, and
	clean up temporary files.

2008-11-21  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.add_job): Update job creation times.

2008-11-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.setDataButtonState): Avoid
	use-before-set traceback (trac #111).

2008-11-21  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.__init__): Remember which user to connect as.
	(Monitor.cleanup): Connect as correct user (trac #110).
	(Monitor.get_notifications): Likewise.
	(Monitor.refresh): Likewise.
	(Monitor.fetch_jobs): Likewise.

2008-11-21  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (Device.__cmp__): Sort usb devices
	before hal devices (trac #109).

2008-11-19  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection._perform_authentication): If we get
	IPP_FORBIDDEN, switch to asking for the root password.

2008-11-19  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.getNPPPD): Localize the
	PPD.
	(NewPrinterGUI.on_btnNPApply_clicked): Likewise.
	* cupshelpers/cupshelpers.py (Printer.getPPD): Likewise.

2008-11-19  Tim Waugh  <twaugh@redhat.com>

	* glade/ConnectDialog.glade: Pressing Return in the Connect
	dialog activates the Connect... button.

2008-11-18  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py
	(PPDs.orderPPDNamesByPreference.sort_ppdnames.is_C_locale): Catch
	exceptions when examining file names (Ubuntu #299074).

2008-11-13  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.init): Fetch PPDs in a
	background thread, again.

2008-11-13  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.cleanup): Remove any pending timers.

2008-11-13  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection._authloop): Remember the distinction
	between a canceled dialog and an authentication we've given up
	on.
	* errordialogs.py (show_IPP_Error): Only show IPP error dialog for
	errors not caused by a canceled authentication dialog.

2008-11-12  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.queryDevices,
	NewPrinterGUI.getDevices_thread): Removed.
	(NewPrinterGUI.fetchDevices): Run in the main thread instead of
	starting a new one.  This is necessary because the default
	configuration of CUPS 1.4 is to require an authenticated system
	user, and to do that we may need to present an authentication
	dialog.
	* PhysicalDevice.py (PhysicalDevice): Use authconn.Connection in
	case we need to present an authentication dialog.
	* troubleshoot/DeviceListed.py (DeviceListed.display): Likewise.

2008-11-07  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection._perform_authentication): Grab keyboard
	and mouse when showing authentication dialog.
	* pysmb.py (AuthContext.perform_authentication): Likewise.
	* jobviewer.py (JobViewer.display_auth_info_dialog): Likewise.
	(JobViewer.auth_info_dialog_response): Ungrab them.

2008-11-07  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.auth_info_dialog_response): Don't leak
	AuthDialog.

2008-11-06  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckNetworkServerSanity.py
	(CheckNetworkServerSanity.display): Use strictly correct smb URI.

2008-11-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDownloadableDrivers_cursor_changed): Fixed
	traceback in downloadable driver dialog.

2008-10-06  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py, glade/NewPrinterWindow.glade: Display
	more driver info for downloadable drivers from OpenPrinting:
	Manufacturer/third-party-supplied? Free software? Patent issues?
	Recommended? Functionality, support contacts. The license text
	will now always be shown if available, but the user will only
	asked whether he accepts it in the case of a non-free license or
	patentissues.

2008-11-06  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (Printer.setAsDefault): Removed
	old reconnect call which caused a traceback.  Return a boolean
	indicating whether reconnection is necessary.
	* system-config-printer.py (GUI.set_default_printer): Reload only
	if necessary.
	(GUI.rename_printer): Likewise.
	
2008-11-05  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 1.0.10.

2008-11-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.reconnect): Sleep before
	reconnection attempt, not after.  The CUPS server doesn't
	necessarily re-start immediately.

2008-11-05  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckNetworkServerSanity.py
	(CheckNetworkServerSanity.display): Prevent traceback.

2008-11-05  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckPPDSanity.py: Use gpk-install-package-name
	instead of system-install-packages.

2008-11-05  Tim Waugh  <twaugh@redhat.com>

	* applet.py (NewPrinterNotification): Use gpk-install-package-name
	instead of system-install-packages.
	* system-config-printer.py (NewPrinterGUI.checkDriverExists):
	Likewise.

2008-11-04  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Don't set the
	IconView's item_width as that causes problem.  Set the column and
	row spacing instead.

2008-11-04  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.fetch_jobs): Apply specific_dests filter to
	fetched jobs.

2008-11-04  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.update_connecting_devices): Only call
	still_connecting once, not repeatedly.

2008-11-04  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.get_notifications): Prevent timer callbacks
	while we handle client callbacks.
	(Monitor.refresh): Likewise.

2008-11-04  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.refresh): Reverted recent change inverting
	order of calls.  The current_printers_and_jobs callback must be
	called first.
	(Monitor.set_process_pending): Control whether pending events may
	be processed.
	(Monitor.__init__): Initially they can.
	(Monitor.check_still_connecting): Defer timer callback if pending
	events are held.
	(Monitor.get_notifications): Likewise.
	(Monitor.fetch_jobs): Skip callback if events are held.

2008-11-03  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.current_printers_and_jobs): Don't
	process pending events while processing new jobs list.

2008-11-03  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.set_process_pending): Control whether
	pending events may be processed.
	(JobViewer.__init__): Initially they can.
	(JobViewer.set_statusicon_visibility): Only process pending events
	if allowed to.

2008-11-03  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Make sure the notification
	is still valid after letting the status icon show itself.
	(JobViewer.on_auth_notification_closed): Mark notification as
	closed.
	(JobViewer.job_removed): Likewise.

2008-11-03  Tim Waugh  <twaugh@redhat.com>

	* glade/statusicon_popupmenu.glade: Added a 'Configure Printers'
	entry to the pop-up menu.
	* jobviewer.py (JobViewer.on_icon_configure_printers_activate):
	New method.  Launch system-config-printer.
	(JobViewer.poll_subprocess): New method.  Collect exit status.
	Fixes trac #96.

2008-11-03  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Restored compatibility code
	for pycups < 1.9.40 when connecting to CUPS and requesting
	specific job attributes.

2008-11-03  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.cleanup): Close open notifications on
	exit (trac #106).

2008-11-03  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.refresh): Fixed race condition causing stale
	jobs (trac #107).

2008-11-03  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Already set status icon
	visibility here.

2008-11-02  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.fetch_jobs): Better logic for job trimming.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.current_printers_and_jobs): Better
	debugging.
	(JobViewer.job_event): Likewise.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.job_event): Remove job-hold-until from
	provided job data unless it was also provided as part of the
	notification.  Call update_job earlier to make sure all required
	attributes are present.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.add_job): Use iter while it's fresh.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Delete auth notification
	after closing it, otherwise we'll never show the notification for
	this job again.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.set_statusicon_visibility): Let the icon
	show/hide itself before continuing.
	(JobViewer.notify_new_printer): No longer need to do that here.
	(JobViewer.notify_printer_state_reason): Likewise.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Set status icon visibility
	before making auth notification visible.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.add_job): Moved fetch of required job
	attributes...
	(JobViewer.update_job): ...here so that job event handling has
	access to all the attributes it requires.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.set_statusicon_visibility): Count auth
	notifications as reasons to keep the status icon visible.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.job_removed): Close outstanding auth
	notifications when the job is removed.

2008-10-31  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.fetch_jobs): Trim the remaining jobs after
	the last job is returned.

2008-10-29  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.on_state_reason_notification_closed):
	Set 'closed' data for notification instead of removing the object
	from the state_reason_notifications dict.
	(JobViewer.set_statusicon_visibility): Skip closed notifications
	when counting how many open notifications there are.
	(JobViewer.notify_printer_state_reason): No need to set
	'printer-state-reason' data on object any more.
	(JobViewer.state_reason_removed): Don't try closing notification
	if it was already closed.  Remove the notification from the
	state_reasons_notification dict now that the reason is cleared.
	Adjust statusicon visibility appropriately.

2008-10-29  Tim Waugh  <twaugh@redhat.com>

	* my-default-printer.py (Dialog.__init__): Set default window icon
	(Ubuntu #290469).

2008-10-28  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.current_printers_and_jobs): Moved fetch
	of required job attributes...
	* jobviewer.py (JobViewer.add_job): ...here.  This is needed
	because all jobs are added via add_job now, even pre-existing
	ones.

2008-10-28  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Set up policy
	comboboxes to separate IPP string from its presentable value.
	(GUI.on_printer_changed): Updated.
	(GUI.save_printer): Likewise.
	(GUI.fillComboBox): Likewise.

2008-10-28  Tim Waugh  <twaugh@redhat.com>

	* ppdippstr.py: New module holding translations for common IPP and
	PPD strings (trac #103).
	* Makefile.am (nobase_pkgdata_DATA): Ship it.
	* po/POTFILES.in: Translate it.
	* optionwidgets.py (OptionBool.__init__, OptionPickOne.__init__):
	Use it to translate PPD option names and values.
	* system-config-printer.py (GUI.fillComboBox): Use it to translate
	job sheet, printer operation and printer error policies.
	(GUI.fillPrinterOptions): Use it to translate PPD group names.

2008-10-17  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.get_icon_pixbuf): Use printer-printing
	icon when appropriate (trac #86).

2008-10-16  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.save_printer): Prevent traceback
	when printer has been deleted.
	* system-config-printer.py (GUI.populateList): Cancel properties
	dialog if the printer we're editing has been deleted.
	Fixes Ubuntu #284444.

2008-10-16  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Set the item width for
	the icon view, for a nicer appearance.

2008-10-16  Tim Waugh  <twaugh@redhat.com>

	* debug.py (debugprint): Send debug output to stderr to work
	around the samba bug (#5805) that closes stdout.

2008-10-16  Tim Waugh  <twaugh@redhat.com>

	* pysmb.py (AuthContext.perform_authentication): Fixed the SMB
	authentication dialog's cancel button (bug #467127).

2008-10-15  Tim Waugh  <twaugh@redhat.com>

	* pysmb.py (AuthContext.perform_authentication): Don't destroy
	authentication dialog until after we've fetched the details (bug
	#464003).

2008-10-15  Tim Waugh  <twaugh@redhat.com>

	* pysmb.py: Import gettext.

2008-10-15  Tim Waugh  <twaugh@redhat.com>

	* smburi.py (SMBURI._construct): Don't construct URIs containing
	"@/".

2008-10-15  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py (PPDs.getInfoFromModel): Restrict URI in
	debugging output.

2008-10-15  Tim Waugh  <twaugh@redhat.com>

	* pysmb.py (AuthContext.perform_authentication): Show an error
	dialog if the password was incorrect (bug #465407).
	* po/POTFILES.in: Translate pysmb.py (no new translatable
	strings).

2008-10-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_btnSMBVerify_clicked): Don't show an error
	dialog if the SMB authentication dialog is cancelled by the
	user (bug #465407).

2008-10-15  Tim Waugh  <twaugh@redhat.com>

	* print-applet.desktop.in (NotShowIn): Don't show the applet in
	KDE, as that provides its own version (bug #466945).

2008-10-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(GUI.__init__.UnobtrusiveButton.__init__): Don't use a LinkButton
	for the 'Problems?' button (bug #465407).

2008-10-10  Tim Waugh  <twaugh@redhat.com>

	* glade/PrinterPropertiesDialog.glade: Don't set non-zero page
	size for SpinButtons.

2008-10-10  Tim Waugh  <twaugh@redhat.com>

	* errordialogs.py (show_IPP_Error): Don't show an error dialog if
	an IPP operation's authentication dialog is cancelled by the
	user (bug #465407).
	* authconn.py: Show an error dialog if the password was
	incorrect (bug #465407).

2008-10-09  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Use message "Searching for
	downloadable drivers" in the wait window when polling OpenPrinting
	database vis Jockey.

2008-10-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Renamed server_settings to
	server_settings_menu_entry to avoid naming collision.
	* system-config-printer.py (GUI.setConnected): Set Server
	Settings... menu entry sensitive depending on whether we are
	connected to a server (Ubuntu #280736).

2008-09-26  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.fetchJockeyDriver):
	Make this translatable string the same as another to avoid
	breaking the Fedora string freeze.

2008-09-25  Till Kamppeter  <till.kamppeter@gmail.com>

	* applet.py, cupshelpers/ppds.py, system-config-printer.py: Added
	support for automatic printer driver download from OpenPrinting
	via Jockey. If no exactly matching driver for a new printer is
	found, Jockey is asked for a driver via D-Bus. If Jockey actually
	downloads a driver this way, the PPD list is rebuilt and if one of
	the new PPDs installed by the driver package matches the printer,
	it is suggested with priority.

	If hal-cups-utils reports a newly generated queue with a driver
	which does not match exactly, we capture the device ID now so that
	we can ask Jockey.

	If Jockey is not installed or too old, the Jockey queries fail
	gracefully and a locally installed driver is chosen.
	
	* cupshelpers/openprinting.py: When querying a driver entry from the
	OpenPrinting database, add also the fields 
         - thirdpartysupplied
         - manufacturersupplied
         - supportcontacts
	to the data structure (Ubuntu #269454).

2008-09-08  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.server_settings_response): If the
	advanced server settings dialog raises an exception, catch it
	(Ubuntu #267557).

2008-09-03  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py (PPDs.getInfoFromModel): Try 'Lexmark'
	instead of 'Lexmark International' when matching.

2008-09-03  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py (_self_test): Fixed testing for a specific
	IEEE 1284 Device ID.

2008-09-01  Tim Waugh  <twaugh@redhat.com>

	* glade/NewPrinterWindow.glade: Avoid display problem with
	installable options.  We now have a label where the options table
	will go, rather than starting the vbox empty.

2008-09-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Use
	modelName string from custom PPD file to suggest name for new
	queue if no Device ID is available (trac #97).

2008-09-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Rearranged
	code for suggesting an appropriate name for a new printer.

2008-08-30  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection._authloop): Handle IPP_FORBIDDEN (bug
	#460670).

2008-08-30  Tim Waugh  <twaugh@redhat.com>

	* GroupsPane.py (GroupsPane.on_group_name_edited): Fixed
	translatable string.
	(GroupsPane.delete_selected_group): Likewise.

	* GroupsPaneModel.py (FavouritesItem.__init__): Use US spelling
	here, ready for translation.

2008-08-30  Tim Waugh  <twaugh@redhat.com>

	* po/POTFILES.in: Translate GroupsPane.py, GroupsPaneModel.py
	and ToolbarSearchEntry.py.
	* Makefile.am: Ship them.
	* Makefile.am: Ship HIG.py, SearchCriterion.py and
	XmlHelper.py.

2008-08-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Require pycups >= 1.9.42.

	* AdvancedServerSettings.py
	(AdvancedServerSettingsDialog.on_response): Removed legacy pycups
	code.

	* applet.py (any_jobs): Removed legacy pycups code.

	* monitor.py (Monitor.fetch_jobs): Removed legacy pycups code.
	(Monitor.fetch_jobs): Likewise.

	* jobviewer.py (JobViewer.current_printers_and_jobs): Removed
	legacy pycups code.
	(JobViewer.job_event): Likewise.

2008-08-28  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.refresh): New parameter refresh_all.
	(Monitor.fetch_jobs): Skip over jobs we already know about unless
	refresh_all is True.

	* jobviewer.py (JobViewer.on_show_completed_jobs_activate): Don't
	refresh all jobs, just completed ones.

2008-08-28  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.get_notifications): Don't call job_removed
	if we are interested in completed jobs.

2008-08-28  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.current_printers_and_jobs): Only fetch
	missing job attributes we require.
	(JobViewer.job_event): Likewise.

2008-08-27  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.setNPButtons): Hide Back
	button on first page of New Class dialog.

2008-08-28  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.fetch_jobs): Fixed bad merge.  The old
	update() method is now called update_jobs().

2008-08-26  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.fetch_jobs): Handle job fetching in parts on
	a timer (trac #93).
	(Monitor.refresh): Start timer.

2008-08-26  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.refresh): Allow which_jobs to be specified
	when refreshing.
	* jobviewer.py (JobViewer.on_show_completed_jobs_activate): Give
	new which_jobs value to monitor.refresh().

2008-08-26  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.add_job): Efficiency improvement.

2008-08-26  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.__init__): Removed self.which_jobs as
	not used.

2008-08-26  Tim Waugh  <twaugh@redhat.com>

	* applet.py: Catch exceptions when printing non-fatal messages to
	stderr.

2008-08-23  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.on_delete_activate): HIG
	fixes. Only delete printers if we really have a positive
	response.

2008-08-23  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.dests_iconview_key_press_event):
	Handle "standard" key shortcuts to delete and rename printers.

2008-08-22  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.get_notifications): Handle job completion
	when the state changes to 'completed'; don't wait for the
	job-completed event.

2008-08-22  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.refresh): Don't request job-progress
	events.

2008-08-22  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.check_state_reasons): Efficiency
	improvement when not running in debug mode.
	(Monitor.get_notifications): Likewise.

2008-08-22  Tim Waugh  <twaugh@redhat.com>

	* applet.py (show_version.any_jobs): Don't fetch all jobs to see
	if there are jobs; just one is sufficient (trac #92).

2008-08-22  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane.__init__):
	* GroupsPane.py (GroupsPane.on_drag_*):
	* system-config-printer.py (GUI.__init__):
	* system-config-printer.py (GUI.dests_iconview_drag_data_get):
	Uncomment and rework the DnD signal handlers to finally provide
	working DnD from the icon view to a static icon group.

2008-08-22  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane.n_groups): New method to get the
	number of groups.
	* system-config-printer.py (GUI.__init__): Use it instead of
	checking only the static groups to decide about wether the groups
	pane should start visible.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Don't set View
	Discovered Printers menu item insensitive.
	(GUI.populateList): Filter out discovered printers if necessary.
	(GUI.on_view_discovered_printers_activate): New method.  Redraw
	the printer list when View Discovered Printers is changed.
	Fixes trac #15.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.init): No need to start
	a devices query here.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.init): No need to load
	PPDs while changing the device.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.init): No need to load
	PPDs before changing the device.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.fillDeviceTab): Merge
	current device into detected physical device if possible.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.setNPButtons): Avoid
	traceback when no device has been selected yet.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.fetchDevices): Cache
	device list (trac #36).

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.fillDeviceTab): Cache
	device list (trac #36).

2008-08-18  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* XmlHelper.py (XmlHelper): Remove 'ospm' from the filename of the
	xml printer group file.

2008-08-18  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane.on_group_name_edited): Use
	gtk.BUTTONS_OK instead of gtk.BUTTONS_CLOSE to comply with HIG.

2008-08-12  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane.__init__): Load search groups from the
	xml file.
	* GroupsPane.py (GroupsPane._create_new_group_common): Share some
	code between...
	* GroupsPane.py (GroupsPane.create_new_search_group): ... this new
	method...
	* GroupsPane.py (GroupsPane.create_new_group): ... and this one.
	* GroupsPaneModel.py (SavedSearchGroupItem.__init__): Implemented
	search group saving and loading from xml.
	* SearchCriterion.py (SearchCriterion): New class with the
	necessary definitions to put in the search group xml serialization
	and be compatible with Project Presto's ospm.
	* XmlHelper.py (XmlHelper.get_search_groups): New method.
	* system-config-printer.py (GUI.__init__): Added a search entry
	popdown menu item to save a search group.
	* system-config-printer.py (GUI.on_search_entry_search): Set the
	previous menu item sensitivity.
	* system-config-printer.py (GUI.on_groups_pane_item_activated):
	Clear the search entry when changing groups and fill the search
	entry when a search group has been selected.
	* system-config-printer.py (GUI.populateList): Handle search
	groups like AllPrinters since it's only the filtering that makes
	the difference.
	* system-config-printer.py (GUI.on_save_as_search_group_activate):
	New method.

2008-08-10  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.__init__):
	* system-config-printer.py (GUI.on_filter_criterion_changed):
	* system-config-printer.py (GUI.populateList): Add UI and code to
	filter printers by name, description/location or
	manufacturer/model.

2008-08-01  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane.on_new_group_activate):
	* GroupsPane.py (GroupsPane.on_new_group_from_selection_activate):
	Redefine these methods in terms of...
	* GroupsPane.py (GroupsPane.create_new_group): ... this new, more
	general, one.
	* ToolbarSearchEntry.py (ToolbarSearchEntry.__init__): Create a
	clickable icon to drop a menu.
	* ToolbarSearchEntry.py (ToolbarSearchEntry.set_drop_down_menu):
	New method to set the drop down menu.
	* ToolbarSearchEntry.py (ToolbarSearchEntry.on_icon_pressed): New
	method to show the menu.
	* system-config-printer.py (GUI.__init__): New action to save the
	filtered printer queues as a static group. Also, create and set the
	search entry drop down menu.
	* system-config-printer.py (GUI.on_search_entry_search): Set the
	save-as-group action sensitivity.
	* system-config-printer.py (GUI.on_save_as_group_activate): Save
	the currently displayed printer queues as a static group.

2008-07-30  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.populateList): Remove no longer
	existing printer queues from the currently selected static
	group. It seems the cleanliest way to do this, even if a bit too
	lazy. Both the user removing the printer in All Printers and the
	auto discovered printers going away should be covered.
	Also, reverted these points from commit
	7e7cf4188fc790f705c3e837e1ef69699133b145:

		* system-config-printer.py (GUI.populateList): Use an
		unreadable emblem on printer icons for queues which are no
		longer available.
		* system-config-printer.py (GUI): Protect several
		potential NoneType object accesses. Certainly there are a
		lot more.

	since they are no longer needed with this change.

2008-07-28  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPaneModel.py (GroupsPaneModel.get): This function can be
	used with either a TreeIter or a path thanks to the gtk.ListStore
	implementors. Use this function all over GroupsPane.py where it
	saves us from doing path-to-iter and iter-to-path conversions.

2008-07-27  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPaneModel.py (StaticGroupItem.add_queues): Removed bogus
	code to check if a static group xml node has a child called
	"queues". We make sure that always happens anyway. Better error
	handling for the XML handling code can be done later.
	* GroupsPaneModel.py (StaticGroupItem.remove_queues): New method.
	* system-config-printer.py (GUI.populateList): Change the
	delete-printer action's label to "Remove from Group" when a static
	group is active.
	* system-config-printer.py (GUI.delete_selected_printer_queues):
	New method with the old contents of...
	* system-config-printer.py (GUI.on_delete_activate): ...this. Now
	this method handles the remove from static group case and calls
	the previously mentioned one when in the All Printers view.

2008-07-26  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane): New signal "items-changed".
	* GroupsPane.py (GroupsPane.on_group_name_edited):
	* GroupsPane.py (GroupsPane.on_delete_selected_group_response):
	* GroupsPane.py (GroupsPane.on_new_group_activate):
	* GroupsPane.py (GroupsPane.on_new_group_from_selection_activate):
	Emit it.
	* GroupsPane.py (GroupsPane.get_static_groups): New method.
	* system-config-printer.py (GUI.__init__): New action "add-to-group".
	* system-config-printer.py
	(GUI.on_add_to_group_menu_item_activate): Add selected
	printer queues to a group.
	* system-config-printer.py (GUI.update_add_to_group_menu): Build
	the add-to-group submenu.
	* system-config-printer.py (GUI.on_groups_pane_items_changed):
	Handle group items changes.

2008-07-17  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane.__init__): Build the groups menu on
	__init__().
	* system-config-printer.py (GUI.__init__): Use the groups popup
	menu as the menubar's Group menu.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: New expander in the New Printer
	dialog on the Select Device page, for selecting a connection.
	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDeviceURIs_cursor_changed): New method.
	Update the description depending on the selected connection.
	(NewPrinterGUI.on_expNPDeviceURIs_expanded): New method.  Adjust
	the expander's packing depending on its expanded state.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.fillDeviceTab): Let the
	PhysicalDevice class handle duplicate merging.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* PhysicalDevice.py: New module.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.fillDeviceTab): More
	efficient algorithm for deleting duplicates.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py (ppdMakeModelSplit): The canonical name for
	Hewlett-Packard is HP.

2008-08-21  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (nobase_pkgdata_DATA): Ship Locale troubleshooter
	module (Ubuntu #259926).

2008-08-20  Tim Waugh  <twaugh@redhat.com>

	* glade/NewPrinterWindow.glade: Better layout for the new printer
	dialog.

2008-08-17  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* authconn.py (Connection._perform_authentication): Destroy the
	AuthDialog after run() since a new one is always created. Handle
	response == gtk.RESPONSE_DELETE_EVENT as gtk.RESPONSE_CANCEL.

2008-08-19  Tim Waugh  <twaugh@redhat.com>

	* pysmb.py (AuthContext.perform_authentication): Destroy this
	dialog instead of hiding it.

2008-08-19  Tim Waugh  <twaugh@redhat.com>

	* errordialogs.py (show_dialog): Destroy these dialogs instead of
	hiding them.

2008-08-19  Tim Waugh  <twaugh@redhat.com>

	* userdefault.py (UserDefaultPrompt.on_response): Destroy this
	dialog instead of hiding it so that we avoid leaking it.

2008-08-19  Tim Waugh  <twaugh@redhat.com>

	* AdvancedServerSettings.py
	(AdvancedServerSettingsDialog.__del__): Destroy this dialog
	instead of hiding it so that we avoid leaking it.

2008-08-18  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* errordialogs.py (show_dialog): Use gtk.MessageDialog instead of
	gtk.Dialog as it saves us a lot of code and already complies with
	the HIG. Also, destroy the dialog after running it.

2008-08-18  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.on_connect_activate): Make
	pressing Enter on the combo box's entry activate the default
	dialog widget.

2008-08-17  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* glade/ServerSettingsDialog.glade: Add border width. Remove
	resizable and has_separator properties. Add mnemonics to the
	check boxes' labels.

2008-08-17  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* authconn.py (Connection._perform_authentication): Destroy the
	AuthDialog after run() since a new one is always created. Handle
	response == gtk.RESPONSE_DELETE_EVENT as gtk.RESPONSE_CANCEL.

2008-08-17  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* glade/ConnectingDialog.glade: HIG fixes. Added a progress bar.
	* system-config-printer.py (GUI.__init__): The delete-event
	handler for ConnectingDialog must act as if the cancel button was
	pressed.
	* system-config-printer.py (GUI.on_connectingdialog_delete): New
	method to call the cancel button's click handler on delete-event
	and avoid dialog destruction.
	* system-config-printer.py (GUI.on_connect_activate): Changed
	lblConnecting to use a markup string. Call...
	* system-config-printer.py (GUI.update_connecting_pbar): ... this
	to update the progress bar.

2008-08-19  Till Kamppeter  <till.kamppeter@gmail.com>

	* cupshelpers/ppds.py (ppdMakeModelSplit): Replace the
	manufacturer name "Okidata" by "Oki". Remove empty parentheses and
	trailing slashes from cleaned model names (they appear when "PS"
	or "PostScript") is removed from the names).

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.__init__): Remember current host, port,
	encryption settings.
	(JobViewer.display_auth_info_dialog): Use them when making new
	connections.
	(JobViewer.auth_info_dialog_response): Likewise.
	(JobViewer.on_job_cancel_activate): Likewise.
	(JobViewer.on_job_hold_activate): Likewise.
	(JobViewer.on_job_release_activate): Likewise.
	(JobViewer.on_job_reprint_activate): Likewise.
	(JobViewer.current_printers_and_jobs): Likewise.
	(JobViewer.job_event): Likewise.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.on_job_cancel_activate): Ask user if
	they are sure they want to cancel the job.
	(JobViewer.on_job_cancel_prompt_delete): Handle delete-event for
	the dialog.
	(JobViewer.on_job_cancel_prompt_response): Handle response for the
	dialog.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.on_job_cancel_activate): Set current
	operation.
	(JobViewer.on_job_hold_activate): Likewise.
	(JobViewer.on_job_release_activate): Likewise.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Require pycups >= 1.9.40.
	(GUI.populateList): Removed pycups compatibility code.
	(GUI.connect): Likewise.
	(NewPrinterGUI.getPPDs_thread): Likewise.
	(NewPrinterGUI.nextNPTab): Likewise.
	(NewPrinterGUI.getDevices_thread): Likewise.
	(NewPrinterGUI.on_btnIPPVerify_clicked): Likewise.
	(NewPrinterGUI.browse_ipp_queues_thread): Likewise.
	(NewPrinterGUI.getNPPPD): Likewise.

	* AdvancedServerSettings.py
	(AdvancedServerSettingsDialog.on_response): Removed pycups
	compatibility code for pycups < 1.9.40.

	* my-default-printer.py (Server.getSystemDefault): Removed pycups
	compatibility code.

	* monitor.py (collect_printer_state_reasons): Removed pycups
	compatibility code.
	(Monitor.cleanup): Likewise.
	(Monitor.get_notifications): Likewise.
	(Monitor.refresh): Likewise.

	* authconn.py (Connection._connect): Removed pycups compatibility
	code.

	* jobviewer.py (PrinterURIIndex.lookup): Removed pycups
	compatibility code.
	(JobViewer.display_auth_info_dialog): Likewise.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Initialise
	connect_encrypt.

	* system-config-printer.py (GUI.connect): Use parameters to
	Connection() when possible.
	(GUI.on_btnPrintTestPage_clicked): Likewise.  Make sure to restore
	cups user.
	(NewPrinterGUI.getPPDs_thread): Use parameter to Connection() when
	possible.
	(NewPrinterGUI.nextNPTab): Likewise.
	(NewPrinterGUI.getDevices_thread): Likewise.
	(NewPrinterGUI.on_btnIPPVerify_clicked): Likewise.  Restore
	current server afterwards.
	(NewPrinterGUI.browse_ipp_queues_thread): Likewise.

	* authconn.py (Connection.__init__): New parameters host, port,
	encryption.
	(Connection._connect): Use them.  Use parameters to Connection()
	when possible.

	* monitor.py (Monitor.__init__): New parameters host, port,
	encryption.
	(Monitor.cleanup): Use them for new connections.  Use parameters
	to Connection() when possible.
	(Monitor.get_notifications): Likewise.
	(Monitor.refresh): Likewise.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.save_printer): Allow caller to set
	parent window.
	(GUI.copy_printer): Set parent window so that error dialogs are
	transient for the main window.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.save_printer): Set current
	operation.
	(GUI.set_default_printer): Likewise.
	(GUI.on_btnPrintTestPage_clicked): Likewise.
	(GUI.maintenance_command): Likewise.
	(GUI.copy_printer): Likewise.
	(GUI.rename_printer): Likewise.
	(GUI.on_delete_activate): Likewise.
	(GUI.on_enabled_activate): Likewise.
	(GUI.on_shared_activate): Likewise.
	(GUI.fillServerTab): Likewise.
	(GUI.save_serversettings): Likewise.
	(NewPrinterGUI.on_btnNPApply_clicked): Likewise.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.populateList): Set current
	operation.
	(GUI.save_printer): Likewise.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection._begin_operation): New method.
	(Connection._end_operation): New method.
	(Connection._perform_authentication): Display current operation in
	the dialog window title.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.display_auth_info_dialog): Fixed widget
	name.  JobsWindow was MainWindow in the branch this change was
	merged from.
	* system-config-printer.py (GUI.is_rename_possible): Fixed widget
	name.  PrintersWindow was MainWindow in the branch this change was
	merged from.
	(GUI.rename_printer): Likewise.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_shared_activate): Handle IPP
	errors while setting shared status.

2008-08-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.rename_printer): Handle IPP errors
	while setting original printer to reject jobs.

2008-08-15  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* glade/ConnectDialog.glade: Adjusted spacing. Removed
	separator. Changed cancel/connect button ordering. The
	GtkAlignment widgets aren't needed, removed. Added mnemonics to
	the labels.

2008-08-15  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.display_auth_info_dialog): Allow more
	than one authentication dialog at a time.

2008-08-15  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.current_printers_and_jobs): Reset jobs
	dict to keep it in synchronisation with the jobiters dict.  This
	prevents a traceback after releasing a held job.

2008-08-15  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (_PrintersConf.fetch): Clean up
	temporary file in case of error.

2008-08-15  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.auth_info_dialog_delete): Handle
	delete-event.
	(JobViewer.display_auth_info_dialog): Connect to signal.

2008-08-14  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/openprinting.py
	(OpenPrinting.listDrivers.parse_result): OpenPrinting API change:
	freesoftware -> nonfreesoftware (trac #74).
	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDownloadableDrivers_cursor_changed):
	Likewise.

2008-08-14  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.on_new_printer_notification_closed):
	Optional reason parameter to handle newer libnotify signal
	interface.
	(JobViewer.on_state_reason_notification_closed): Likewise.
	(JobViewer.on_auth_notification_closed): Likewise.

2008-08-14  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Display a notification when
	a job requires authentication (trac #91).
	(JobViewer.on_auth_notification_authenticate): New method.
	Display an authentication dialog when the notification's
	authenticate action is triggered.
	(JobViewer.on_auth_notification_closed): New method.  Handle an
	auth notification being closed.

2008-08-14  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Moved code for displaying
	authentication dialog...
	(JobViewer.display_auth_info_dialog): ...here.  New method.

2008-08-14  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.__init__):
	* system-config-printer.py (NewPrinterGUI.__init__): Since some
	dialogs are reused we can't let the delete-event's default handler
	destroy them.
	* system-config-printer.py (on_delete_just_hide): This method is
	connected to those dialog's delete-event (trac #88).

2008-08-14  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): When a job is held for
	authentication, say so in the status column.

2008-08-14  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Show authentication dialog
	in the middle of the screen (trac #90).

2008-08-13  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection._authloop): Re-bind to the named method
	on reconnection.  Handle HTTP_FORBIDDEN (trac #89).
	(Connection._failed): New optional parameter forbidden.  Remember
	whether we saw HTTP_FORBIDDEN.
	(Connection._perform_authentication): Initialise self._forbidden.
	Use it to decide whether to try as root.  Don't call setUser()
	here; _connect() will do that.

2008-08-12  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.update_job): Pre-fill the username field
	when asking for authentication for the job (trac #87).

2008-08-02  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.openprinting_printers_found): Fix selection of
	printer model from query result.  We'd been using the index in the
	list before sorting instead of after sorting.

2008-08-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.browse_smb_hosts): If
	the user has specified a URI before clicking Browse, add that
	server at the top-level and expand it (trac #66).

2008-08-01  Tim Waugh  <twaugh@redhat.com>

	* smburi.py (SMBURI._construct): Construct minimal URI so that
	typing in a complete URI works without it becoming disrupted.
	(SMBURI.separate): If no hostname is present, use the empty string
	instead of 'localhost'.

2008-08-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.is_rename_possible): New method to
	determine whether a rename can go ahead and display an error
	dialog if not.
	(GUI.rename_printer): Use it.
	(GUI.on_rename_activate): Likewise (trac #78).

2008-08-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.rename_printer): Restore original
	accepting/rejecting state if copying the printer fails.

2008-08-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.rename_printer): Fixed typo.

2008-08-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.updatePrinterProperties): Include
	printer-state-message next to printer state, so that reasons such
	as 'unplugged or turned off' are shown when the printer is
	stopped (trac #85).

2008-07-31  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Don't load
	PPDs if we are creating an explicit queue for a remote CUPS
	queue (trac #72).

2008-07-31  Tim Waugh  <twaugh@redhat.com>

	* options.py (OptionAlwaysShown.get_widget_value): Prevent
	traceback when editing the text of a SpinButton widget (e.g. when
	the box is empty).

2008-07-31  Till Kamppeter  <till.kamppeter@gmail.com>

	* options.py (get_widget_value): Work around broken get_value()
	method in gtk.SpinButton class of pygtk. get_value() does not
	return an updated value when only typing in the input field, it
	only gives the updated value when clicking the spin arrows or
	switching to another widget. This leads to the "Apply" button
	staying gray when typing into the input field of the
	spinbox. Replaced get_value() by the get_text() method inherited
	from gtk.Entry class to solve the problem (trac #83).
	
	* ppds.py: Case-insensitive sorting of printer model list.

2008-07-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Preserve
	server and port settings while fetching IPP attributes of remote
	printer.

2008-07-29  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection.__init__): Note current settings for
	CUPS user, server and port.
	(Connection._connect): Reset user, server and port settings before
	connection (trac #79).

2008-07-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.printer_properties_response):
	Re-read the PPD after applying changes (trac #76).

2008-07-29  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.on_job_cancel_activate): Ask the monitor
	to update after cancelling a job.
	(JobViewer.on_job_hold_activate): Likewise for held jobs.
	(JobViewer.on_job_release_activate): Likewise for released jobs.
	(JobViewer.on_job_reprint_activate): Likewise for reprinted jobs.

2008-07-29  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.on_job_cancel_activate): Don't display
	an error dialog if a job to cancel has already been cancelled.
	(JobViewer.on_job_hold_activate): Likewise for held jobs.
	(JobViewer.on_job_release_activate): Likewise for released jobs.

2008-07-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.__init__): If pysmbc is
	not available, set Browse button tooltip to explain why browsing
	is disabled (trac #81).

2008-07-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(GUI.dests_iconview_button_release_event): Set the cursor to the
	pointed-to icon if not already selected.

2008-07-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.rename_printer.jobs_error):
	Display an error dialog if the operation cannot go ahead due to
	jobs being in the queue (trac #78).

2008-07-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Guard against shares
	being found instead of servers.  In this case, only use printer
	shares.

2008-07-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvSMBBrowser_row_activated): Removed
	USE_OLD_CODE check.
	(NewPrinterGUI.on_tvSMBBrowser_cursor_changed): Likewise.
	(NewPrinterGUI.on_btnSMBBrowseOk_clicked): Likewise.

2008-07-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_btnSMBBrowseOk_clicked): Fixed typos.

2008-07-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvSMBBrowser_cursor_changed): Prevent
	traceback.

2008-07-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvSMBBrowser_row_activated): Use smbc_type to
	determine how to act rather than the tree depth.
	(NewPrinterGUI.on_tvSMBBrowser_cursor_changed): Likewise.
	(NewPrinterGUI.on_btnSMBBrowseOk_clicked): Likewise.
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Examine smbc_type of
	opendir results.
	(NewPrinterGUI.on_btnSMBBrowseOk_clicked): Workgroup may not be
	available, so use the empty string in that case.

2008-07-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.browse_smb_hosts): Allow
	servers to be shown at the top level.
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Use smbc_type to
	determine how to act, rather than the tree depth.
	Fixes trac #45.

2008-07-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_shared_activate): Can't use
	self.monitor.update() here because CUPS doesn't give us an IPP
	notification for this.  Defer a call to populateList() instead.

2008-07-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_enabled_activate): Tell the
	monitor to check for updates.
	(GUI.on_shared_activate): Likewise.
	(GUI.save_printer): Likewise.
	(GUI.rename_printer): Likewise.
	(GUI.on_copy_activate): Likewise.
	(GUI.on_delete_activate): Likewise.

2008-07-15  Tim Waugh  <twaugh@redhat.com>

	* monitor.py (Monitor.update): Renamed...
	(Monitor.update_jobs): ...to this.
	(Monitor.get_notifications): Track name change.
	(Monitor.refresh): Likewise.
	(Monitor.update): New method for queuing an update (i.e. a call to
	get_notifications).
	(Monitor.handle_dbus_signal): Use it.

2008-07-15  Tim Waugh  <twaugh@redhat.com>

	* po/POTFILES.in: Don't try to translate
	glade/printer_context_menu.glade since that has been removed.

2008-07-15  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.__init__): Call ensure_update() on
	the UIManager to get rid of the warning about not being able to
	create an accelerator label.

2008-07-14  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.on_enabled_activate): Call
	populateList() on an idle callback. This is a workaround for an
	endless loop that was occuring with the previous commit.
	* system-config-printer.py (GUI.on_edit_activate): Add a dummy
	parameter to comply with the signal handler signature.

2008-07-12  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* Makefile.am (nobase_pkgdata_DATA): Remove contextmenu.py and
	glade/printer_context_menu.glade.
	* glade/printer_context_menu.glade: Removed.
	* glade/PrintersWindow.glade: Remove the Printer menu
	definition. It's handled in system-config-printer.py now. Glade
	added some GtkImage id noise.
	* system-config-printer.py
	(GUI.dests_iconview_button_press_event): Popup the context menu on
	button-press-event instead of on button-release-event like other
	menus.
	* system-config-printer.py (GUI): The Printer menubar item and the
	iconview's menu is now the same and a proxy to a set of
	gtk.Actions grouped on a gtk.UIManager instance.

2008-07-14  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (nobase_pkgdata_DATA): Ship new module.
	* po/POTFILES.in: Translate it.

2008-07-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.server_settings_response): Display
	Advanced Server Settings dialog when Advanced is clicked in the
	Server Settings dialog.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* glade/ServerSettingsDialog.glade: Added 'Advanced...' button to
	server settings dialog.

2008-07-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Connect the response
	signal from the server settings dialog to a handler for it.
	(GUI.on_server_settings_activate): Don't call run() here, just
	display the dialog.  The response signal will call...
	(GUI.server_settings_response): ...this new handler.

2008-07-11  Tim Waugh  <twaugh@redhat.com>

	* errordialogs.py (show_HTTP_Error): Fixed traceback.

2008-07-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Use URI exactly as
	specified in libsmbclient man page.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): When adding
	an IPP printer, pre-fill the info and location fields from the
	remote queue (trac #37).

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckPPDSanity.py (CheckPPDSanity.display): Report
	PPD option defaults.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/Locale.py: New module.
	* troubleshoot/__init__.py (Troubleshooter._collect_answer): Run
	it (trac #38).

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckNetworkServerSanity.py
	(CheckNetworkServerSanity.display): Look for SMB shares (trac
	#47).

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/base.py: Make _ a public name for this module.
	* troubleshoot/*.py: Don't explicitly import _.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.openprinting_printers_found): More descriptive
	'select model' text.  Part of trac #25.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.openprinting_printers_found): If an exact match is
	found, pre-select it.  Part of trac #25.

2008-07-15  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane.on_button_press_event): Pop up the
	menu on button-press-event to be consistent with how most context
	menus work.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/openprinting.py: Moved top-level test code...
	(_simple_gui): ...here.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py: Removed self_test from public interface.
	It can still be called during 'make check'.
	(PPDs.self_test): Renamed so that it starts with an underscore.
	* Makefile.am (test-ppd-module.sh): Track name change.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.init): Clear text entry
	fields before filling devices list, so that when
	self.on_tvNPDevices_cursor_changed() pre-fills the location field
	it doesn't get reset afterwards.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Fixed location
	pre-fill.

2008-07-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.dests_iconview_selection_changed):
	Factored out get_model() from this loop.

2008-07-08  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Added 'Close' button to printer
	properties dialog.
	* system-config-printer.py (GUI.__init__): Fetch 'Close' button
	widget.
	(GUI.dests_iconview_item_activated): Show Close button only when
	the printer is a discovered one, and Apply/Cancel/OK otherwise.
	Fixes trac #61.

2008-07-08  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.browse_smb_hosts):
	Increase smbc debugging level.
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Likewise.
	(NewPrinterGUI.on_btnSMBVerify_clicked): Likewise.

2008-07-07  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.unset_special_statusicon): Set status
	icon visibility.  We might need to hide the icon at this point.

2008-07-07  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/ppds.py (PPDs.__init__): Removed unneeded debugging
	output.

2008-07-07  Tim Waugh  <twaugh@redhat.com>

	* setup.py: New module.  Configuration for distutils.
	* Makefile.am (EXTRA_DIST): Ship it.
	(.stamp-distutils-in-builddir): Convince distutils to work when
	srcdir is different to builddir.
	(all-local): Build cupshelpers module using distutils.
	(install-exec-local): Install it using distutils.
	(clean-local): Clean using distutils.
	(uninstall-local): Remove installed module.

2008-07-07  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/__init__.py (__all__): Define public names.
	* cupshelpers/openprinting.py (__all__): Likewise.
	* cupshelpers/ppds.py (__all__): Likewise.

2008-07-04  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_cmbNPDownloadableDriverFoundPrinters_changed):
	Only download PPD files, not drivers.

2008-07-04  Tim Waugh  <twaugh@redhat.com>

	* glade/PrintersWindow.glade: Moved Ctrl+N accelerator from
	'New', which has a sub-menu, to New->Printer (trac #55).

2008-06-20  Till Kamppeter  <till.kamppeter@gmail.com>

	* cupshelpers/ppds.py: Made PostScript printers reliably be used
	with the manufacturer's PPD file. The manufacturer's PPD appeared
	as a separate model (at least for HP) and so got never used.
	Made SpliX and Gutenprint PPDs also be recognized as such if the
	drivers are downloaded from OpenPrinting (as LSB driver packages).

2008-07-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Use uname call
	instead of parsing /bin/hostname output (trac #52).

2008-07-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Added 'Apply' button to printer
	properties dialog.
	* system-config-printer.py (GUI.__init__): Fetch Apply button
	widget.
	(GUI.setDataButtonState): Set Apply button sensitibity.
	(GUI.dests_iconview_item_activated): Set data button state.
	(GUI.printer_properties_response): Handle APPLY response.
	Fixes trac #54.

2008-07-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Limit the initial size
	of the window (trac #53).

2008-07-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): No need to adjust width
	here.

2008-06-30  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (Printer.__repr__): New method.
	(Device.__repr__): New method.

2008-06-26  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/Shrug.py: Hide the diagnostic output in an
	expander, and remove the copy-to-clipboard function.
	Fixes https://fedorahosted.org/system-config-printer/ticket/41.

2008-06-26  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/openprinting.py
	(OpenPrinting.listDrivers.parse_result): Use _normalize_space
	instead of normalize_space.

2008-06-26  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/__init__.py (set_debugprint_fn): New function to set
	debugging hook.

	* cupshelpers/cupshelpers.py: Don't import debug.
	Use _debugprint instead of debugprint throughout.

	* cupshelpers/ppds.py: Import _debugprint from the main
	cupshelpers module.  Use _debugprint throughout.

	Fixes https://fedorahosted.org/system-config-printer/ticket/50.

2008-06-26  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.getNetworkPrinterMakeModel): Use subprocess module
	instead of os.popen.
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Likewise.
	(NewPrinterGUI.getNPPPD): Likewise.
	Fixes https://fedorahosted.org/system-config-printer/ticket/44.

2008-06-25  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.get_hpfax_device_id):
	Use subprocess module instead of os.popen.
	(NewPrinterGUI.get_hplip_uri_for_network_printer): Likewise.

2008-06-25  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.get_hpfax_device_id):
	Prevent hp-info from accessing X display.

2008-06-25  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.get_hpfax_device_id):
	Run hp-info in the C locale.

2008-06-25  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckPrinterSanity.py (CheckPrinterSanity.display):
	Prevent hp-info from accessing X display, so that it does not
	start the HPLIP systray applet (bug #452371 comment #4).

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (nobase_pkgdata_SCRIPTS): No need to install
	exported modules in pkgdatadir now.
	(EXTRA_DIST): Ship exported modules.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* openprinting.py: Moved...
	* cupshelpers/openprinting.py: ...here.
	* cupshelpers/__init__.py: Import it.
	* Makefile.am (EXPORT_MODULES): Export openprinting.
	* system-config-printer.py (NewPrinterGUI.__init__): Updated.
	Fixes https://fedorahosted.org/system-config-printer/ticket/34.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* openprinting.py (normalize_space): This function has private
	scope.
	(QueryThread): This class has private scope.
	Better docstrings throughout.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (main): This function has private
	scope.
	(iteratePPDOptions): Likewise.
	(getPPDGroupOptions): Likewise.
	(PrintersConf): This class has private scope.
	Better docstrings throughout.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers/cupshelpers.py (Printer.printer_states): Moved...
	* system-config-printer.py (GUI.printer_states): ...here.
	(GUI.updatePrinterProperties): Updated.
	* cupshelpers/cupshelpers.py (Printer): Removed instance variable
	state_description.
	* cupshelpers/cupshelpers.py: Don't import rhpl.translate.
	* po/POTFILES.in: Don't translate cupshelpers.py.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* ppds.py: Moved...
	* cupshelpers/ppds.py: ...here.  Use implicit relative path to
	import parseDeviceID.
	(PPDs._main): Renamed self_test.
	* Makefile.am (test-ppd-module.sh): Adjusted.
	* cupshelpers/__init__.py: Import ppds module.

	* system-config-printer.py (NewPrinterGUI.init): The ppds module
	is now part of cupshelpers.
	(NewPrinterGUI.getPPDs_thread): Likewise.
	(NewPrinterGUI.nextNPTab): Likewise.
	(NewPrinterGUI.getNetworkPrinterMakeModel): Likewise.
	* applet.py (NewPrinterNotification.NewPrinter): Likewise.
	* Makefile.am (nobase_pkgdata_SCRIPTS): Track file move.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py: Moved...
	* cupshelpers/cupshelpers.py: ...here.
	* cupshelpers/__init__.py: New module.
	* Makefile.am (EXPORT_MODULES): Export cupshelpers.
	* POTFILES.in: Track file move.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Add AM_PATH_PYTHON.
	* Makefile.am (pythondir_SCRIPTS): Install exported modules.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (EXPORT_MODULES): New variable.
	(html): New rule.  Build API documentation for exported modules
	using epydoc.
	(distclean-local): Clean documentation.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* ppds.py: Better docstrings throughout.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (getDriverType): Made this function private as it is not
	part of the API for this module.
	(show_help): Likewise.
	(main): Likewise.

2008-06-23  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: New global PYSMB_AVAILABLE.
	(NewPrinterGUI.__init__): Make SMB browse button insensitive if
	pysmb is not available.  Removed legacy pysmb code.
	(NewPrinterGUI.browse_smb_hosts): Removed legacy pysmb code.
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Likewise.
	(NewPrinterGUI.on_btnSMBBrowseOk_clicked): Likewise.
	(NewPrinterGUI.on_btnSMBVerify_clicked): Likewise.

	* pysmb.py (get_wins_server): Removed.
	(get_domain_list): Removed.
	(get_host_list): Removed.
	(get_host_list_from_domain): Removed.
	(get_host_info): Removed.
	(get_printer_list): Removed.
	(printer_share_accessible): Removed.

	Fixes https://fedorahosted.org/system-config-printer/ticket/35.

2008-06-24  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Remove expander
	arrow when there are no sub-entries.

2008-06-23  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.populateList): Better icon
	fallbacks.  Fixes traceback seen in bug #452371 comment #2.

2008-06-20  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (DISTCLEANFILES): Clean up PPDs cache file.
	* Makefile.am (test-ppd-module.sh): Use top_srcdir.
	Now 'make distcheck' passes again.

2008-06-20  Tim Waugh  <twaugh@redhat.com>

	* ui: Renamed to glade to avoid intltool bug #452255.
	* Makefile.am: Updated.
	* po/POTFILES.in: Updated.
	* glade.py (GtkGUI.getWidgets): Updated.
	
2008-06-20  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (ppdMakeModelSplit): Don't strip " Printer" from the end
	of the ppd-make-and-model string.  Generic printers should be
	named like "Generic XYZ Printer".
	Fixes https://fedorahosted.org/system-config-printer/ticket/33.

2008-06-20  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (main): Check the results of the test suite against
	maximum permissable status code and regular expression for
	expected ppd-make-and-model string.
	* Makefile.am (test-ppd-module.sh): Create shell script to run
	PPDs test suite.
	* Makefile.am (TESTS): Run it.
	* Makefile.am (DISTCLEANFILES): Clean it up.

2008-06-20  Tim Waugh  <twaugh@redhat.com>

	* pysmb.py (AuthContext.initial_authentication): Pre-fill SMB
	workgroup from smbc.Context.workgroup.
	Fixes https://fedorahosted.org/system-config-printer/ticket/30.

2008-06-20  Till Kamppeter  <till.kamppeter@gmail.com>

	* ppds.py: Case-insensitive sorting of printer model list.

2008-06-19  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.browse_ipp_queues_thread): More informative dialog
	when queue list cannot be fetched.
	Part of https://fedorahosted.org/system-config-printer/ticket/26.

2008-06-19  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.browse_ipp_queues_thread): Hide browse window if
	there was a problem browsing.
	Part of https://fedorahosted.org/system-config-printer/ticket/26.

2008-06-19  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.browse_smb_hosts): If no
	hosts are found, advise user to check firewall.
	Part of https://fedorahosted.org/system-config-printer/ticket/26.

2008-06-19  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (TEXT_start_firewall_tool): Moved this
	translatable string to a global variable.
	(GUI.save_serversettings): Use the global variable.

2008-06-19  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (PrinterURIIndex): New class, for mapping printer
	URIs to printer names.
	(JobViewer.printer_event): New method.  Update printer URI index.
	(JobViewer.printer_removed): New method.  Update printer URI
	index.
	(JobViewer.current_printers_and_jobs): Instantiate printer URI
	index, and use it to look up printer names by job-printer-uri.
	(JobViewer.job_added): Look up printer names by job-printer-uri.
	(JobViewer.job_event): Likewise.
	Fixes https://fedorahosted.org/system-config-printer/ticket/29.

2008-06-19  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Give names to the separators in
	the printer context menu.
	* contextmenu.py (PrinterContextMenu.__init__): Fetch named
	separator widgets from glade file.
	(PrinterContextMenu.__init__.popup): Show separators only when
	there is something to separate.
	Fixes https://fedorahosted.org/system-config-printer/ticket/31.

2008-06-17  Tim Waugh  <twaugh@redhat.com>

	* options.py (OptionAlwaysShown.reinit): Support use_supported for
	combobox_map-using options such as finishings.
	* system-config-printer.py (GUI.__init__): Set use_supported true
	for the finishings options.
	Fixes https://fedorahosted.org/system-config-printer/ticket/32.

2008-06-17  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Printer.getAttributes): Work around a pycups
	bug fixed in 1.9.40: finishings-supported should be a list.

2008-06-16  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.populateList): Remove unused
	select_path local variable.

2008-06-16  Tim Waugh  <twaugh@redhat.com>

	* pysmb.py (AuthContext.perform_authentication): Use
	STOCK_DIALOG_AUTHENTICATION instead of literal string.

	* optionwidgets.py (Option.__init__): Use STOCK_DIALOG_WARNING and
	ICON_SIZE_SMALL_TOOLBAR instead of literal strings and ints.

	* authconn.py (AuthDialog.__init__): Use
	STOCK_DIALOG_AUTHENTICATION instead of literal string.

	* errordialogs.py (show_info_dialog): Use STOCK_DIALOG_INFO
	instead of literal string.
	(show_error_dialog): Use STOCK_DIALOG_ERROR instead of literal
	string.
	* jobviewer.py (JobViewer.job_event): Likewise.

	* userdefault.py (UserDefaultPrompt.__init__): Use
	STOCK_DIALOG_QUESTION instead of a literal string.

2008-06-16  Tim Waugh  <twaugh@redhat.com>

	* userdefault.py (UserDefaultPrompt): New class, implementing a
	user/system default printer dialog.
	* system-config-printer.py
	(GUI.set_system_or_user_default_printer): New method.  Display
	dialog.
	(PrinterContextMenu.on_printer_context_set_as_default_activate):
	Use new method.
	(GUI.on_set_as_default_activate): Likewise.

2008-06-16  Tim Waugh  <twaugh@redhat.com>

	* contextmenu.py (PrinterContextMenu.popup): Show the Set As
	Default menu item for the system default printer except when no
	user default is set.

2008-06-16  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.populateList): Display emblem for
	user default printer.

2008-06-16  Tim Waugh  <twaugh@redhat.com>

	* userdefault.py: New module.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.

2008-06-13  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Printer.update): Work-around pycups bug.  The
	printer-uri-supported attribute should always be a list.

2008-06-13  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (nobase_pkgdata_DATA): Replaced applet.glade with
	ui/job_popupmenu.glade, ui/JobsWindow.glade,
	ui/PrinterStatusWindow.glade, and ui/statusicon_popupmenu.glade.
	Added missing ui/PrintersWindow.glade.
	* po/POTFILES.in: Likewise.
	Fixes https://fedorahosted.org/system-config-printer/ticket/27.

2008-07-07  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* ui/PrintersWindow.glade: Added a Group menu item to the
	menubar. The attached menu is built programatically.
	* contextmenu.py (PrinterContextMenu.popup): Protect potential
	NoneType object access.
	* GroupsPaneModel.py (StaticGroupItem): Implemented reading and
	saving queues.
	* system-config-printer.py (GUI.populateList): Use an unreadable
	emblem on printer icons for queues which are no longer available.
	* system-config-printer.py (GUI): Protect several potential
	NoneType object accesses. Certainly there are a lot more.
	* system-config-printer.py (GUI.dests_iconview_drag_data_get): New
	method for D&D.
	* system-config-printer.py (GUI.dests_iconview_selection_changed):
	Reorganized the code a bit to update the GroupsPane.
	* system-config-printer.py (GUI.__init__): Add the GroupsPane
	UIManager's accelerator group to the main window.
	Build a menu for the Group menubar item.
	* GroupsPane.py (GroupsPane): Added various methods for D&D.
	Reorganized the popup menu around gtk.Actions and gtk.UIManager.
	Implemented an action to create a group from the main window's
	current iconview queue selection.

2008-07-02  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.__init__): Small code shuffle.
	* XmlHelper.py (XmlHelper): New file implementing a class to
	handle the low level xml processing. Instantiates a global
	singleton handler so that all modules have access to it.
	* GroupsPaneModel.py (GroupsPaneModel): Added some utility
	methods.
	* GroupsPaneModel.py: Abstracted some common functionality in
	common base classes for the several groups pane item types.
	* GroupsPane.py: Implemented group adding, renaming and
	deletion. Also a popup menu to access that functionality.

2008-06-24  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane.__init__): Receive the first groups
	item as a contructor parameter.
	* system-config-printer.py (GUI.populateList): Rework filtering
	and current groups item selection to do all their work here. This
	way everything is kept in sync. Thanks to Tim Waugh for helping
	with this.

2008-06-24  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py: Make GroupsPane a proper widget. It's now a
	ScrolledWindow containing a TreeView and taking care of all the
	TreeView's functionality.
	* GroupsPaneModel.py: New file containing a ListStore subclass to
	implement the GroupsPane item list and several classes
	implementing such item types.
	* ToolbarSearchEntry.py (ToolbarSearchEntry.get_text): Added this
	method for convenience.
	* system-config-printer.py (GUI.__init__): Use the GroupsPane
	widget.
	* system-config-printer.py (GUI.filter_iconview): New method to
	allow filtering not just from the search signal handler. We now
	filter from the current iconview model instead of from canonical
	printers list.
	* system-config-printer.py (GUI.on_groups_pane_item_activated):
	New signal handler to change the iconview's model when a different
	group pane item is selected. Just a sketch for now.
	* system-config-printer.py (GUI.populateList): Don't update the
	iconview's model from here for now.
	* ui/PrintersWindow.glade: Don't build a TreeView from glade. It's
	done on code now.

2008-06-18  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.on_search_entry_search): Use a
	regular expression to ignore case while searching.

2008-06-18  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.__init__): Moved the search and
	printer groups setup code earlier since we will need to access the
	search entry in ...
	* system-config-printer.py (GUI.populateList): ... here. This
	allows the refresh button to work properly.

2008-06-18  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* ToolbarSearchEntry.py (ToolbarSearchEntry.on_activate): It makes
	more sense to emit the search signal here too.

2008-06-18  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py (GroupsPane): Add a separator.
	* GroupsPane.py (GroupsPane): Change selection changes order.
	* system-config-printer.py
	(GUI.on_groups_treeview_selection_changed): Catch the treeview's
	selection 'changed' signal.

2008-06-17  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.on_search_entry_search): Do the
	filtering on the search signal handler.
	* system-config-printer.py (GUI.populateList): Moved the part of
	this function that updates the icon view...
	* system-config-printer.py (GUI.reset_icon_view_model): ... into
	here to be reusable.

2008-06-17  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* ToolbarSearchEntry.py (ToolbarSearchEntry.__init__): Change the
	label to "Filter" since it better describes what we do here.
	* GroupsPane.py (GroupsPane): Add a "Current search" item when
	filtering is active.

2008-06-17  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* ToolbarSearchEntry.py (ToolbarSearchEntry): Remove the clearing
	variable since there aren't multiple threads accessing the UI.

2008-06-17  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* ToolbarSearchEntry.py (ToolbarSearchEntry): Reimplemented based
	on Rhythmbox's C version.

2008-06-16  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.populateList): Remove unused
	select_path local variable.

2008-06-16  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* GroupsPane.py: Initial implementation.
	* ui/PrintersWindow.glade: Removed the height request from the
	GtkWindow. Removed horizontal scrolling from the printer groups
	treeview's GtkScrolledWindow.
	* system-config-printer.py (GUI.__init__): Use GroupsPane. Moved
	GUI.setup_toolbar_for_search_entry before the icon_view resizing
	block.

2008-06-15  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* ui/PrintersWindow.glade: Make the window have a minimum size so
	that the user can't resize to the point of making the search entry
	disappear. There might be a better way to do this.

2008-06-15  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* ui/PrintersWindow.glade: Added a HPaned widget with a TreeView
	to hold printer groups.

2008-06-15  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* system-config-printer.py (GUI.setup_toolbar_for_search_entry):
	Put the search entry widget into place.

2008-06-15  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* ToolbarSearchEntry.py: Initial widget implementation.

2008-06-15  Rui Tiago Cação Matos  <tiagomatos@gmail.com>

	* HIG.py: New module to hold definitions usefull when applying
	GNOME HIG rules programatically.

2008-06-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.openprinting_printers_found): Set the combobox
	sensitive.
	(NewPrinterGUI.on_btnNPDownloadableDriverSearch_clicked): Set the
	combobox insensitive.
	(NewPrinterGUI.on_rbtnNPFoomatic_toggled): Set the combobox
	insensitive if the search is cancelled.
	Part of https://fedorahosted.org/system-config-printer/ticket/25.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.__init__): Use glade.GtkGUI.

	* applet.glade: Split into...
	* ui/JobsWindow.glade, ui/PrinterStatusWindow.glade,
	ui/job_popupmenu.glade, ui/statusicon_popupmenu.glade: ...new
	files.
	
2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* ui/MainWindow.glade:  Renamed to...
	* ui/PrintersWindow.glade: ...this, to avoid collisions with
	the applet's glade XML.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (help): Added help for run-applet.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* contextmenu.py (PrinterContextMenu.__init__): Use glade.GtkGUI.

	* glade.py (GtkGUI.getWidgets): Adapted.

	* Makefile.am (run): Point to ui directory.
	(run-applet): Likewise.

	* system-config-printer.py (GtkGUI.getWidgets): Adapted.

	* ui/AboutDialog.glade, ui/ConnectDialog.glade,
	ui/ConnectingDialog.glade, ui/InstallDialog.glade,
	ui/IPPBrowseDialog.glade, ui/NewPrinterName.glade,
	ui/NewPrinterWindow.glade, ui/printer_context_menu.glade,
	ui/PrinterPropertiesDialog.glade, ui/ServerSettingsDialog.glade,
	ui/SMBBrowseDialog.glade, ui/WaitWindow.glade: New files.
	* system-config-printer.glade: Removed.

	* Makefile.am (nobase_pkgdata_DATA): Ship separate glade files
	instead of all-in-one glade file for main application.
	* POTFILES.in: Translate them.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GtkGUI): Moved...
	* glade.py (GtkGUI): ...here.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GtkGUI.moveClassMembers): Moved...
	(moveClassMembers): ...here.
	(GtkGUI.getCurrentClassMembers): Moved...
	(getCurrentClassMembers): ...here.
	(GUI.save_printer): Use function, not method.
	(GUI.on_btnClassAddMember_clicked): Likewise.
	(GUI.on_btnClassDelMember_clicked): Likewise.
	(NewPrinterGUI.on_btnNCAddMember_clicked): Likewise.
	(NewPrinterGUI.on_btnNCDelMember_clicked): Likewise.
	(NewPrinterGUI.setNPButtons): Likewise.
	(NewPrinterGUI.on_btnNPApply_clicked): Likewise.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* applet.glade (PasswordDialog): Removed.

	* system-config-printer.glade (ApplyDialog): Removed.
	(PrinterContextMenu): Removed.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 1.0.2.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.getPPDs_thread):
	Propagate all exceptions.
	(NewPrinterGUI.fetchPPDs): Likewise.
	(NewPrinterGUI.init): Handle exceptions here to some degree.
	(GUI.cups_connection_error): New method.  Watch for connection
	errors.
	(GUI.dests_iconview_item_activated): Watch for connection errors.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnRefresh_clicked): Update
	status bar with connection status if we tried to connect.

2008-06-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_btnSMBVerify_clicked): Fixed typo causing
	traceback.  Was introduced by 'transient for parent' change
	yesterday.

2008-06-09  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 1.0.1.

2008-06-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnPrintTestPage_clicked): Use
	show_info_dialog.
	(GUI.maintenance_command): Likewise.
	(NewPrinterGUI.on_btnSMBVerify_clicked): Likewise.
	(NewPrinterGUI.on_btnIPPVerify_clicked): Likewise.
	* system-config-printer.glade (InfoDialog): Removed.

2008-06-09  Tim Waugh  <twaugh@redhat.com>

	(NewPrinterGUI.on_btnSMBVerify_clicked): Set verification failure
	dialog transient for parent.

2008-06-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.on_btnSMBVerify_clicked):
	Better error dialog for SMB verification failure.

2008-06-09  Tim Waugh  <twaugh@redhat.com>

	* pysmb.py (AuthContext.__init__): New variable, cancel.  Clear
	it.
	(AuthContext.perform_authentication): Set it when Cancel button
	pressed.
	(AuthContext.failed): Raise exception if operation is canceled;
	also if operation failed due to some error unrelated to
	authentication.

2008-06-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.__init__): Removed smb_lock.
	(NewPrinterGUI.browse_smb_hosts_thread): Removed.
	(NewPrinterGUI.browse_smb_hosts): Do top-level browsing here.

2008-06-08  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_connect_activate): Save
	encryption state.
	(GUI.connect): Restore encryption state.
	Fixes https://fedorahosted.org/system-config-printer/ticket/21.

2008-06-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.populateList): Save/restore
	selection of printers.
	(GUI.printer_added_or_removed): No longer need to do this here.

2008-06-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Initialise
	server_is_publishing variable.
	(GUI.fillPrinterTab): Update it from server-is-sharing-printers
	attribute if available (CUPS 1.4).
	(GUI.fillServerTab): Update it from CUPS_SERVER_SHARE_PRINTERS
	setting.
	(GUI.advise_publish): New method.
	(GUI.on_shared_activate): Use it.

2008-06-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: New Shared checkbox menu item, both
	for the menu bar and the context menu.

	* system-config-printer.py (GUI.on_shared_activate): New method.
	(GUI.dests_iconview_selection_changed): Update Shared checkbox
	state.

	* contextmenu.py
	(PrinterContextMenu.on_printer_context_shared_activate): New
	method.
	(PrinterContextMenu.popup): Update Shared checkbox state.

	Fixes https://fedorahosted.org/system-config-printer/ticket/1.

2008-06-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Changed Enable/Disable menu items
	to a single Enabled checkbox menu item, both for the menu bar and
	the context menu.

	* system-config-printer.py (GUI.on_enable_activate): Renamed...
	(GUI.on_enabled_activate): ...to this.  Use checkbox.
	(GUI.on_disable_activate): Removed.
	(GUI.dests_iconview_selection_changed): Update Enabled checkbox
	state.

	* contextmenu.py
	(PrinterContextMenu.on_printer_context_enable_activate):
	Renamed...
	(PrinterContextMenu.on_printer_context_enabled_activate): ...to
	this.  Use checkbox.
	(PrinterContextMenu.on_printer_context_disable_activate):
	Removed.
	(PrinterContextMenu.popup): Update Enabled checkbox state.

2008-06-06  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Printer.update): Work around pycups bug with
	printer-uri-supported.

2008-06-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Better menu layout.  Fixes
	https://fedorahosted.org/system-config-printer/ticket/2.
	* system-config-printer.py (GUI.__init__): Set View->Discovered
	Printers menu item insensitive for now (not implemented).

2008-06-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.populateList): Better
	classification of available printers.  Fixes
	https://fedorahosted.org/system-config-printer/ticket/7.

2008-06-06  Tim Waugh  <twaugh@redhat.com>

	* applet.glade: Remove treeview signal connection for
	button_press_event.
	* jobviewer.py (JobViewer.__init__): Connect treeview's
	button_release_event and popup-menu signals.
	(JobViewer.show_treeview_popup_menu): New method, to adjust the
	visible menu items of the job context menu and show it.
	(JobViewer.on_treeview_button_press_event): Renamed...
	(JobViewer.on_treeview_button_release_event): ...to this.  Use
	show_treeview_popup_menu.
	(JobViewer.on_treeview_popup_menu): New method.  Fixes
	https://fedorahosted.org/system-config-printer/ticket/5.

2008-06-05  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Ship translation template file.

2008-06-05  Tim Waugh  <twaugh@redhat.com>

	(NewPrinterGUI.browse_ipp_queues_thread): Fixed typo (bug
	#450120).

2008-06-05  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.browse_ipp_queues_thread): Better exception
	handling.
	(NewPrinterGUI.browse_smb_hosts_thread): Likewise.
	(NewPrinterGUI.openprinting_printers_found): Likewise.

2008-06-05  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.browse_ipp_queues_thread): IPP errors are fine
	here.

2008-06-05  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.save_serversettings): Show a
	dialog advising the user to review the firewall if sharing has
	been enabled.

2008-06-05  Tim Waugh  <twaugh@redhat.com>

	* errordialogs.py (show_dialog): New function.
	(show_error_dialog): Use it.
	(show_info_dialog): New function.

2008-06-04  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.connect): Always show traceback
	for unhandled exceptions if debugging.
	(NewPrinterGUI.getDevices_thread): Likewise.

2008-06-04  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Don't fetch
	InstallDialog widget here...
	(NewPrinterGUI.__init__): ...fetch it here instead (bug #449860).
	(NewPrinterGUI.checkDriverExists): Fixed traceback.

2008-06-03  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Adjust left hpane width in the
	printer properties dialog to be slightly wider.

2008-06-03  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnPrintTestPage_clicked):
	Don't automatically try authenticating as root if asked for a
	password when printing a test page, as the authentication is
	likely to be needed for the remote print server.

	* authconn.py (Connection.__init__): New optional parameter
	try_as_root.
	(Connection._perform_authentication): Only try as root if allowed
	to.

2008-06-03  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (run-applet): New target.

2008-06-03  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.__init__): Initialise set of stopped job
	IDs for which we are showing a dialog.
	(JobViewer.job_event): Don't show stopped-job dialog if we are
	already showing one for this job.
	(JobViewer.job_event): Add job ID to set before showing dialog.
	(JobViewer.print_error_dialog_response): Remove job ID from set.

2008-06-02  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.job_event): Ignore stopped jobs when
	they have been stopped due to the printer being paused.

2008-06-02  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.init): Handle exceptions
	when fetching PPDs.

2008-05-31  Tim Waugh  <twaugh@redhat.com>

	* applet.py (WaitForJobs): Harden against races.

2008-05-30  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckUSBPermissions.py: New module.
	* troubleshoot/__init__.py (QUESTIONS): Run it.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.

2008-05-30  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.populateList): No longer needs
	change_ppd argument.
	(GUI.__init__): Don't give change_ppd argument to populateList.
	(GUI.printer_properties_response): New method.
	(GUI.__init__): Connect the response signal to it.
	(GUI.dests_iconview_item_activated): Just show the dialog, don't
	call its run method.
	(GUI.__init__): Click the Change PPD... button if the change_ppd
	argument was given.

2008-05-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Renamed start_printer
	argument to configure_printer.  Activate the relevant item.
	(GUI.populateList): No longer needs start_printer argument.
	(GUI.connect): Likewise.
	(GUI.on_connect_activate): Don't give start_printer argument to
	new thread.
	(GUI.on_copy_activate): Omit start_printer argument.
	(NewPrinterGUI.on_btnNPApply_clicked): Likewise.
	(main): Renamed start_printer argument to configure_printer.

	* system-config-printer.py (GUI.__init__): Connect IconView's
	popup-menu signal to...
	(GUI.dests_iconview_popup_menu): ...this new signal handler.
	* contextmenu.py (PrinterContextMenu.popup): Allow event to be
	None, for the case of the gtk.Widget popup-menu signal.

	* troubleshoot/PrintTestPage.py (PrintTestPage.update_jobs_list):
	Mark jobs as test jobs by default so that people who don't realise
	they need to click the check-box still get sufficient information
	in the troubleshoot.txt file.

	* jobviewer.py (JobViewer.update_job): If the job's
	auth-info-required attribute indicates Kerberos negotiation, try
	to authenticate the job without providing an auth-info attribute.

2008-05-28  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckPrinterSanity.py (CheckPrinterSanity.display):
	Make the cups_printer_remote answer a Boolean.

	* troubleshoot/DeviceListed.py (DeviceListed.collect_answer):
	Return all answers, including any set during the display method.
	(DeviceListed.display): Set cups_device_dict answer if the queue
	already exists, to make it easier to determine IEEE 1284 strings
	of devices that already have queues set up.
	* troubleshoot/DeviceListed.py (DeviceListed.display): Don't fetch
	devices if the selected queue is remote.

	* troubleshoot/ErrorLogCheckpoint.py
	(ErrorLogCheckpoint.enable_clicked): Set MaxLogSize to 0 to avoid
	cupsd rotating the log while the test page is printed.
	* troubleshoot/ErrorLogFetch.py (ErrorLogFetch.button_clicked):
	Reset MaxLogSize.

	* troubleshoot/CheckNetworkServerSanity.py
	(CheckNetworkServerSanity.display): Split output lines from
	traceroute.

2008-05-27  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 1.0.0.

2008-05-27  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Allow directory
	containing glade files to be overridden.
	* jobviewer.py (JobViewer.__init__): Likewise.
	Get pkgdatadir from config module.
	(JobViewer.__init__): Set window title appropriately.

	* Makefile.am (run): Give path to directory containing glade
	files, not to specific glade file.

	* system-config-printer.glade: Added 'Create Class' menu item to
	printer context menu.
	* contextmenu.py
	(PrinterContextMenu.on_printer_context_create_class): New method.

	* system-config-printer.py (GUI.__init__): Set toolbar buttons at
	runtime instead of using glade, in order to have a MenuToolButton
	for New Printer/New Class.
	* system-config-printer.glade: Removed toolbar buttons.

	* errordialogs.py (show_IPP_Error): Fixed typo.

	* system-config-printer.py (NewPrinterGUI.setNPButtons): Don't
	allow Forward button to be pressed on the downloadable driver
	screen if no driver is selected.

	* openprinting.py (OpenPrinting.searchPrinters): This is a search
	term, not a manufacturer's name.

	* system-config-printer.py (NewPrinterGUI.__init__): Don't disable
	OpenPrinting widgets, as only the PPD downloading part currently
	work.
	(NewPrinterGUI.getNPPPD): Use mkstemp here.
	(NewPrinterGUI.init): Set 'Select printer from database' radio
	button active.

	* system-config-printer.py (NewPrinterGUI.fillMakeList): Pre-fill
	the OpenPrinting.org search box.

2008-05-25  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Set default window icon
	name (Ubuntu #234750).
	* applet.py: Likewise.

2008-05-23  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.browse_smb_hosts_thread): Remove the 'Scanning...'
	label when browsing is unsuccessful.

	* configure.in: Version 0.9.93.

2008-05-23  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.__init__): Added User column to job
	view.
	(JobViewer.update_job_creation_times): Updated Time column ID.
	(JobViewer.add_job): Fill User column.  Updated Name column ID.
	(JobViewer.update_job): Updated other column IDs.

	* system-config-printer.py
	(GUI.populateList): New keyword parameter prompt_allowed.
	(GUI.printer_added_or_removed.maybe_select): Don't allow auth
	prompting when re-populating the printer list.

	* contextmenu.py
	(PrinterContextMenu.on_printer_context_set_as_default_activate):
	Use GUI.set_default_printer so that we handle errors correctly,
	and in case the server needed to reload.
	(PrinterContextMenu.on_printer_context_enable_activate): Handle
	IPP errors.

	* applet.glade (ErrorDialog): Removed.
	* jobviewer.py (JobViewer.show_IPP_Error): Use errordialogs
	module.

	* system-config-printer.glade (ErrorDialog): Removed.
	* system-config-printer.py: Use show_error_dialog() instead of the
	glade ErrorDialog widget.

	* system-config-printer.py (GUI.show_HTTP_Error): Moved...
	* errordialogs.py (show_HTTP_Error): ...here.

	* system-config-printer.py (GUI.show_IPP_Error): Moved...
	* errordialogs.py (show_IPP_Error): ...here.

	* troubleshoot/__init__.py (Troubleshooter.get_window): New
	method.
	* troubleshoot/PrintTestPage.py (PrintTestPage.print_clicked): Use
	it.

	* troubleshoot/PrintTestPage.py: Import errordialogs.

	* troubleshoot/base.py (show_error_dialog): Moved...
	* errordialogs.py (show_error_dialog): ...here.  New module.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.
	* po/POTFILES.in: Translate it.

2008-05-22  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection._authloop): Move some initial variable
	settings...
	(Connection._perform_authentication): ...here, for the first
	pass.
	(Connection._perform_authentication): If no prompting is allowed,
	set _cancel and return non-zero so that we break out of the
	authentication loop.
	(Connection._perform_authentication): Likewise if we are about to
	prompt the user but never got a password callback from libcups.

2008-05-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_btnSMBVerify_clicked): Set cursor busy during
	verify.

	* system-config-printer.py
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Don't remove row
	expansion arrow unless authentication was successful.
	(NewPrinterGUI.browse_smb_hosts_thread): Likewise.
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Likewise.

	* system-config-printer.py: Set gettext function for monitor
	module.

	* system-config-printer.py
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Create a new context
	here.

	* system-config-printer.py
	(NewPrinterGUI.browse_smb_hosts_thread): Set the auth function
	directly to the AuthContext callback.
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Likewise.
	(NewPrinterGUI.on_btnSMBVerify_clicked): Likewise.
	(NewPrinterGUI.browse_smb_hosts_thread_auth_callback): Removed.

	* system-config-printer.py
	(NewPrinterGUI.browse_smb_hosts_thread): Made more robust in the
	face of SMB errors.
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Likewise.

2008-05-20  Tim Waugh  <twaugh@redhat.com>

	* authconn.py (Connection._perform_authentication): Reconnect
	after prompting.

	* cupshelpers.py (Printer.getAttributes): Avoid losing SMB
	authentication details.

	* system-config-printer.py (NewPrinterGUI.on_entSMBURI_changed):
	Don't reset authentication radio button if not necessary.

2008-05-20  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.9.92.

2008-05-20  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_tvSMBBrowser_row_activated): Double-clicking on
	a share selects it.

	* system-config-printer.py
	(GUI.dests_iconview_button_release_event): Fix right-click
	behaviour.

	* system-config-printer.glade: Removed user entry box in the
	connection dialog.
	* system-config-printer.py (GUI.on_connect_activate): Removed
	references to user entry box.

	* system-config-printer.py
	(NewPrinterGUI.on_btnSMBVerify_clicked): Don't use
	pysmb.printer_share_accessible for access checks unless we are
	using the old browsing code.

	* pysmb.py (AuthContext.__init__): Allow initial credentials to be
	set.

	* system-config-printer.py
	(NewPrinterGUI.browse_smb_hosts_thread): Fixed 'scanning...'
	message for new SMB browse code.

2008-05-19  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.browse_smb_hosts_thread): Don't set no-anon-login
	flag as it seems to break browsing.

	* pysmb.py (AuthContext.failed): Raise exception if authentication
	details were not asked for.

	* system-config-printer.py
	(NewPrinterGUI.browse_smb_hosts_thread): Better exception
	handling.
	(NewPrinterGUI.on_tvSMBBrowser_row_expanded): Likewise.

2008-05-18  Tim Waugh  <twaugh@redhat.com>

	* pysmb.py (AuthContext.perform_authentication): More debugging.

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Better parsing of
	socket: URIs (Ubuntu bug #222616).
	(iconpath): Fixed icon search path.
	(GUI.populateList): Fail if an icon is not available.
	(NewPrinterGUI.browse_smb_hosts_thread): Enable smbc debugging if
	debugging is enabled.

2008-05-16  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.9.91.

2008-05-16  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_rbtnChangePPDasIs_toggled): Removed.
	(NewPrinterGUI.nextNPTab): Fetch the PPD before the copy-settings
	page and avoid showing an empty installable options page.
	(NewPrinterGUI.setNPButtons): Set buttons appropriately on the
	copy-settings page.

	* system-config-printer.py (NewPrinterGUI.setNPButtons): Initial
	value for radio button should be set in init...
	(NewPrinterGUI.init): ...here.

	* system-config-printer.py (NewPrinterGUI.__init__,
	NewPrinterGUI.browse_smb_hosts_thread,
	NewPrinterGUI.on_tvSMBBrowser_row_activated,
	NewPrinterGUI.on_btnSMBBrowseOk_clicked): Start of new SMB code.

	* system-config-printer.glade: Adjusted SMB authentication
	screen.
	* system-config-printer.py (NewPrinterGUI.on_entSMBURI_changed,
	NewPrinterGUI.on_btnSMBVerify_clicked,
	NewPrinterGUI.getDeviceURI): User interface adjustment.

	* system-config-printer.py (NewPrinterGUI.smbbrowser_cell_share):
	New method.
	(NewPrinterGUI.smbbrowser_cell_comment): New method.
	(NewPrinterGUI.browse_smb_hosts_thread_auth_callback): New method.

	* pysmb.py: Try to import smbc module.
	(AuthContext): New class.

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Removed debugging.

	* system-config-printer.glade: Removed default printer parts from
	the printer properties dialog, as this is now done in the main
	window.
	* system-config-printer.py (GUI.fillPrinterTab): Removed
	references to printer properties default printer widgets.
	(GUI.on_btnPMakeDefault_clicked): Likewise.

	* system-config-printer.py (GUI.fillPrinterTab): Moved some
	code...
	(GUI.updatePrinterProperties): ...here.
	(GUI.printer_event): Update state etc.

	* cupshelpers.py (Printer.__init__): Moved some code...
	(Printer.update): ...here.
	(Printer.getAttributes): Update state etc.

	* system-config-printer.py (GUI.setTestButton): Removed.
	(GUI.fillPrinterTab): Don't call setTestButton.
	(GUI.on_btnPrintTestPage_clicked): Likewise, and don't ever
	cancel.
	(GUI.setDataButtonState): Removed cancellation handling.

2008-05-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.init): Only set location
	to current hostname if the added printer is directly connected.
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Don't set location
	of remote printers to the local hostname.

	* troubleshoot/base.py (show_error_dialog): New method.
	* troubleshoot/PrintTestPage.py (PrintTestPage.print_clicked): Use
	it.
	(PrintTestPage.print_clicked): Try printing a text/plain file if
	application/postscript is not accepted.

	* authconn.py (AuthDialog.__init__): Set alignment for icon.

2008-05-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Better
	translatable string.
	(NewPrinterGUI.getNPPPD): Likewise.

	* system-config-printer.py (NewPrinterGUI.getNPPPD): Finish
	writing the file before trying to parse it.  Patch from George
	Liu.

	* system-config-printer.desktop.in, manage-print-jobs.desktop.in,
	print-applet.desktop.in, my-default-printer.desktop.in: Just exec
	binary name, not path name.

	* system-config-printer-applet: Generate this with autoconf so
	that configured paths can be used.
	* my-default-printer: Likewise.
	* system-config-printer: Likewise.
	* configure.in: Generate above scripts.

	* config.py.in: Get DATADIR from autoconf.
	* config.py.in (Paths): New class to handle pathname expansion.
	* system-config-printer.py: Use config.Paths to get pkgdatadir.

2008-05-13  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.dests_iconview_selection_changed):
	Better logic for sensitivity.
	(GUI.on_enable_activate): New method.
	(GUI.on_disable_activate): New method.

	* system-config-printer.py (GUI.on_set_as_default_activate): New
	method.

	* system-config-printer.py (GUI.printer_name_edit_cancel): Moved
	from...
	* contextmenu.py (PrinterContextMenu.printer_name_edit_cancel):
	...here.
	* system-config-printer.py (GUI.printer_name_edited): Moved
	from...
	* contextmenu.py
	(PrinterContextMenu.printer_name_edited): ...here.
	* system-config-printer.py (GUI.on_rename_activate): New method,
	from...
	* contextmenu.py
	(PrinterContextMenu.on_printer_context_rename_activate): ...here.
	Call main class's handler.

	* system-config-printer.glade: Add 'Copy' entry to printer context
	menu.
	* contextmenu.py
	(PrinterContextMenu.on_printer_context_copy_activate): New
	method.

	* troubleshoot/ErrorLogCheckpoint.py (ErrorLogCheckpoint.display):
	Clear 'done' label on page display.
	* troubleshoot/ErrorLogFetch.py (ErrorLogFetch.display):
	Likewise.

2008-05-12  Tim Waugh  <twaugh@redhat.com>

	* applet.py (NewPrinterNotification.collect_exit_code): New
	method.  Collect exit code of child (bug #446055).

	* jobviewer.py (JobViewer.notify_new_printer): Fixed new printer
	notifications.

	* applet.py: Set locale.

	* system-config-printer.py (GUI.makeNameUnique): Use dash instead
	of underscore when replacing disallowed characters (bug #445790).

	* system-config-printer.py (GUI.save_printer): Display any IPP
	error caught while refreshing printer information (Ubuntu
	#224021).

	* monitor.py (collect_printer_state_reasons): Ignore IPP errors
	here (Ubuntu #225241).

	* troubleshoot/PrintTestPage.py (PrintTestPage.print_clicked):
	Handle failure to connect to CUPS and failure to submit the test
	page (Ubuntu #222494).
	(PrintTestPage.cancel_clicked): Record failure reason instead of
	raising exception.

2008-05-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.printer_added): Fixed typo calling
	base function.
	(GUI.printer_removed): Likewise.
	(GUI.printer_event): New method.  Handle printer state updates so
	that enabled/disabled printers are shown correctly.

2008-05-08  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Don't flip
	to the next page if there is an error obtaining the PPD.

2008-05-07  Tim Waugh  <twaugh@redhat.com>

	* openprinting.py (OpenPrinting.__init__): Default to only Free
	downloads.

	* system-config-printer.py (NewPrinterGUI.getNPPPD): Implemented
	PPD download.  Use urlopen to download PPD file from
	openprinting.org.  Patch from George Liu.

	* system-config-printer.glade: Re-worked some of the downloadable
	PPD interface.  Patch from George Liu.

	* openprinting.py (OpenPrinting.searchPrinters): Replaced web
	query filter printer=(searchterm) with make=(make).  All models by
	the printer manufacturer will be returned.  Patch from George
	Liu.
	(OpenPrinting.listDrivers): Changed search term onlydownloads to
	onlyppdfiles.  Patch from George Liu.

	* system-config-printer.py
	(NewPrinterGUI.on_cmbNPDownloadableDriverFoundPrinters_changed):
	Fixed typo (patch from George Liu).

2008-05-06  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.glade: More fixes to make the properties
	dialog smaller.

	* applet.py (NewPrinterNotification.wake_up, check_for_jobs): Fixed
	crash on waitloop.quit().

2008-05-02  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnPrintTestPage_clicked):
	Connect as the current user to print the test page (bug #444306).

	* Makefile.am: Install main script in bindir, not sbindir.

2008-05-01  Tim Waugh  <twaugh@redhat.com>

	* my-default-printer.py: Guard against locale errors (bug
	#417951).
	* openprinting.py (OpenPrinting.__init__): Likewise.
	* system-config-printer.py (show_help): Likewise.

2008-04-30  Tim Waugh  <twaugh@redhat.com>

	* applet.py (NewPrinterNotification.NewPrinter): Only include
	Install button if we are able to install packages.

2008-04-29  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/CheckPPDSanity.py (CheckPPDSanity.display): Provide
	null stdin.
	* troubleshoot/CheckNetworkServerSanity.py
	(CheckNetworkServerSanity.display): Likewise. Catch exceptions.

	* troubleshoot/CheckPrinterSanity.py (CheckPrinterSanity.display):
	Try hp-info for hp-scheme device URIs.

2008-04-21  Tim Waugh  <twaugh@redhat.com>

	* configure.in (ALL_LINGUAS): Added sr@latin.  Removed sr@Latn.
	* po/sr@Latn.po: Removed.
	* Makefile.am: Check for missing languages in update-po.

2008-04-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.init): Don't empty the
	JetDirect hostname text entry widget here, as it might have been
	pre-filled for a selected device (Ubuntu #220041).

2008-04-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-prnter.py (NewPrinterGUI.init): Fix model
	pre-selection when changing PPD.

	* system-config-printer.py (NewPrinterGUI.on_btnNPApply_clicked):
	Reset 'media' default job option if it becomes invalid (bug
	#441836).

2008-04-17  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (ppdMakeModelSplit): Fix display of Generic PostScript
	model, which was getting set to the empty string.

	* system-config-printer.py (NewPrinterGUI.on_btnNPApply_clicked):
	Update printer properties when dialog is finished.

2008-04-16  Tim Waugh  <twaugh@redhat.com>

	* applet.py (WaitForJobs): Cancel the deferral timer.

2008-04-16  Till Kamppeter  <till.kamppeter@gmail.com>

	* applet.py (main): Fixed Ubuntu crash bug #195508.

2008-04-16  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.copy_printer): New method.
	(GUI.on_copy_activate): Use it.
	(GUI.rename_printer): New method.

	* cupshelpers.py (Printer.jobsQueued): New method.
	(Printer.testsQueued): Use it.

	* contextmenu.py
	(PrinterContextMenu.on_printer_context_rename_activate): New
	method.
	(PrinterContextMenu.printer_name_edited): New method.
	(PrinterContextMenu.printer_name_edit_cancel): New method.

	* system-config-printer.py (CUPS_server_hostname): New function.
	(GUI.setConnected): Use it.
	(GUI.dests_iconview_item_activated): Set printer properties dialog
	title to show printer and hostname.

	* system-config-printer.glade (PrinterPropertiesDialog): Use a
	TreeView to display option groupings instead of Notebook tabs.
	* system-config-printer.py (GUI.__init__): Set tree view column,
	selection mode and signals.
	(GUI.dests_iconview_item_activated): Select first page of the
	properties notebook.
	(GUI.on_tvPrinterProperties_selection_changed): Prevent selection
	from being de-selected.
	(GUI.on_tvPrinterProperties_cursor_changed): Flip notebook to
	correct page.
	(GUI.fillPrinterTab): Fill in tree view rows according to notebook
	tabs.
	(GUI.setDataButtonState): Display conflicts using bold markup in
	the tree view.

2008-04-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.save_printer): Avoid copied queue
	having extra job options set.
	(GUI.on_copy_activate): Set transient for main window.  Fixed typo
	in comment.

	* probe_printer.py (LpdServer._probe_queue): Better error handling
	so as to prevent tracebacks as in Ubuntu #213624.

	* system-config-printer.py (NewPrinterGUI.setNPButtons): Set
	sensitivity of Forward button when in ppd dialog mode (Ubuntu
	#211867).

	* po/pt.po: Mark bad translation fuzzy.

	* jobviewer.py: Don't import pynotify twice.

2008-04-13  Tim Waugh  <twaugh@redhat.com>

	* statereason.py (StateReason.get_description): Don't crash on
	incorrect translations (Ubuntu #214732).

2008-04-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_server_settings_activate): Set
	transient for main window.
	(GUI.on_troubleshoot_activate): Set transient for main window.

	* troubleshoot/__init__.py (Troubleshooter.__init__): Allow parent
	window to be specified.

	* system-config-printer.py (GUI.populateList): Use
	gtk.icon_size_lookup.

	* monitor.py (Monitor.handle_dbus_signal): Fixed typo.

	* applet.py (show_version): Correct comment.
	(WaitForJobs.handle_dbus_signal): New method.
	(WaitForJobs): Better deferral.

2008-04-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_quit_activate): Clean up
	monitor instance so we don't leak CUPS subscriptions.

	* monitor.py (Monitor.get_notifications): Update after
	notify-get-interval period if we haven't ever had a D-Bus signal
	from CUPS.
	(Monitor.__init__): Initialise flag.
	(Monitor.handle_dbus_signal): Set flag.

2008-04-09  Tim Waugh  <twaugh@redhat.com>

	* my-default-printer.py (Dialog.selection_changed): New method.
	Prevent selected item being de-selected.
	(Dialog.__init__): Connect TreeSelection changed signal to
	selection_changed method.
	This fixes Ubuntu #214579.

2008-04-08  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: No separator for the properties dialog.

	* jobviewer.py (JobViewer.__init__): Set transient for parent, if
	appropriate.
	* contextmenu.py
	(PrinterContextMenu.on_printer_context_view_print_queue_activate):
	Indicate parent window.

	* system-config-printer.py (GUI.on_about_activate): Make the About
	dialog appear in the right place.

2008-04-03  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.9.90, on the way to 1.0.0.

2008-04-03  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Ship monitor.py.

	* jobviewer.py (JobViewer.update_job): Don't dispay an
	authentication dialog if pycups doesn't provide
	authenticateJob().

	* system-config-printer.py (GUI.printer_added_or_removed): New
	method.
	(GUI.printer_added): New method.
	(GUI.printer_removed): New method.
	(GUI.__init__): Start a monitor to watch for added and removed
	printers.
	(GUI.dests_iconview_item_activated): If the printer is discovered,
	don't allow the OK button to be clicked in the properties dialog.

	* monitor.py (Watcher.cups_connection_error): New API method.
	(Watcher.cups_ipp_error): New API method.
	(Monitor.get_notifications): Add cups_connection_error and
	cups_ipp_error hooks.
	(Monitor.refresh): Likewise.

	* jobviewer.py (JobViewer.current_printers_and_jobs): Fetch full
	job attributes for each job initially.
	(JobViewer.update_job): If proxy authentication is necessary,
	prompt for authentication information.
	(JobViewer.auth_info_dialog_response): Collect authentication
	information and perform proxy authentication.
	(JobViewer.job_added): Prevent traceback when there are no printer
	state reasons.
	(JobViewer.job_event): Display a print error dialog when a job
	stops for any reason other than authentication required (rescued
	from applet.py revision 2145).

	* authconn.py (AuthDialog): New class.
	(Connection._perform_authentication): Use it.

2008-04-01  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Printer.setAsDefault): Try specifying the file
	descriptor for getFile (requires pycups >= 1.9.38).
	(PrintersConf.fetch): Likewise.

	* monitor.py (Monitor.__init__): Allow caller to opt out of
	monitoring jobs.
	(Monitor.refresh): If not monitoring jobs, don't subscribe to job
	events.
	(Monitor.refresh): Only fetch jobs if we are monitoring them.

	* troubleshoot/CheckPrinterSanity.py (CheckPrinterSanity.display):
	Determine remote server name for smb URIs by parsing nmblookup
	output.

	* troubleshoot/CheckNetworkServerSanity.py
	(CheckNetworkServerSanity.display): Only try IPP connection for
	ipp URI schemes.

	* smburi.py (SMBURI.__init__): Accept full URIs.

	* troubleshoot/CheckPrinterSanity.py (CheckPrinterSanity.display):
	Treat http scheme the same as ipp.

	* system-config-printer.py (GUI.busy): Make more robust.
	(GUI.ready): Likewise.

	* my-default-printer.py (Dialog.__init__): Sort printers by name
	(bug #439804).

2008-03-31  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillPrinterTab): If supported
	values are not known but the value is a Boolean, we can work out
	the supported values (Ubuntu #207338).
	(GUI.fillPrinterOptions): Initialise inputslot/manualfeed
	variables regardless of whether there are option groups.

	* system-config-printer.glade (PrinterPropertiesDialog): Fixed
	expand/fill flags in the job options tab (Ubuntu #208304).

2008-03-26  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (fatalException): Moved...
	* debug.py (fatalException): ...here.
	* system-config-printer.py (nonfatalException): Moved...
	* debug.py (nonfatalException): ...here.
	* jobviewer.py (JobViewer.get_icon_pixbuf): Use it.

	* jobviewer.py (JobViewer.__init__): Removed dead code.
	(JobViewer.update_status): Renamed.  Update statusbar.
	(JobViewer.add_state_reason_emblem): Moved worst reason search...
	(JobViewer.update_status): ...here.
	(JobViewer.current_printers_and_jobs): Set 'job-printer-name'.

	* jobviewer.py (JobViewer.set_statusicon_tooltip): New method.
	(JobViewer.update_statusicon): New method.
	(JobViewer.current_printers_and_jobs): Use it.
	(JobViewer.job_added): Likewise.
	(JobViewer.job_removed): Likewise.
	(JobViewer.state_reason_added): Likewise.
	(JobViewer.state_reason_removed): Likewise.

	* jobviewer.py (JobViewer.job_added): Set 'job-printer-name'.
	(JobViewer.job_event): Likewise.
	(JobViewer.add_state_reason_emblem): Use it.
	(JobViewer.update_job): Likewise.
	(JobViewer.state_reason_added): Likewise.

	* jobviewer.py (JobViewer.get_icon_pixbuf): New method.
	(JobViewer.current_printers_and_jobs): Use it.
	(JobViewer.job_added): Likewise.
	(JobViewer.job_removed): Likewise.
	(JobViewer.job_is_active): New method.
	(JobViewer.job_added): Use it.
	(JobViewer.state_reason_added): Likewise.
	(JobViewer.current_printers_and_jobs): Build active jobs list.
	(JobViewer.job_added): Maintain it.
	(JobViewer.job_event): Likewise.
	(JobViewer.job_removed): Likewise.
	(JobViewer.state_reason_added): Update status icon.
	(JobViewer.state_reason_removed): Likewise.
	(JobViewer.state_reason_removed): Don't return early if a
	notification for the removed state reason was closed.

2008-03-25  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Removed dead code (passwd_retry).

2008-03-24  Till Kamppeter  <till.kamppeter@gmail.com>

	* ppds.py (PPDs.orderPPDNamesByPreference): For HP LaserJet
	12xx/13xx prefer HPIJS over PostScript, as they do not have enough
	memory to render complex graphics with their on-board PostScript
	interpreter. This is a workaround for the time being until HP fixes
	this in the HPLIP-generated PPDs.

2008-03-22  Till Kamppeter  <till.kamppeter@gmail.com>

	* ppds.py (ppdMakeModelSplit): Improved filtering of driver information
	from the printer model name, added missing product names "PSC" and
	"Edgeline" to manufacturer guessing for HP.

2008-03-21  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Support that
	HP has now two fax PPDs ("HP Fax" and "HP Fax 2").
	(NewPrinterGUI.fillDeviceTab): Likewise.
	(NewPrinterGUI.get_hpfax_device_id): New method. Get device ID for
	an HPLIP fax URI, so that correct PPD ("HP Fax" or "HP Fax 2") can
	get selected.
	(NewPrinterGUI.get_hplip_uri_for_network_printer): Strip newline
	from device URI.

2008-03-20  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_copy_activate): Adapted to
	iconview.

	* monitor.py (Monitor.get_notifications): Small fix for
	job_removed calls.
	(Monitor.get_notifications): Call state_reason_removed for each
	reason associated with a removed printer.
	(Watcher.current_printers_and_jobs): Provide printers as well.
	(Monitor.refresh): Fetch list of printers.
	(Monitor.get_notifications): Track added and removed printers.
	(Watcher.printer_added): New method.
	(Watcher.printer_removed): New method.

	* jobviewer.py (JobViewer.current_printers_and_jobs): Adjusted.

	* monitor.py (Watcher.current_jobs): New Watcher interface
	method.
	(Monitor.refresh): Call it.
	* jobviewer.py (JobViewer.current_jobs): Implement it.
	(JobViewer.refresh): Removed.
	(JobViewer.__init__): Start with icon hidden; removed dead code.

	* applet.py (show_version.any_jobs): Just check for jobs, not
	errors.
	* jobviewer.py (worst_printer_state_reason): Removed.

	* monitor.py (Monitor.sort_jobs_by_printer): Better error
	checking.
	(Monitor.check_state_reasons): Don't only process
	connecting-to-device when it is a newly added state reason.

	* jobviewer.py (JobViewer.state_reason_added): Mark state reason
	as not notified.
	(JobViewer.notify_printer_state_reason): Mark state reason as
	notified.
	(JobViewer.state_reason_added): Only send a notification if the
	user has a job on this printer.
	(JobViewer.job_added): Notify user of current state reasons on
	this printer.

2008-03-19  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): If a network
	printer is chosen from the auto-detected printers in the "New
	Printer" dialog and the printer is an HP MF device with both
	printer and fax, the user can choose by a pop-up dialog whether he
	wants to set up a queue for the printer or for the fax.
	
2008-03-19  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.add_job): New method.
	(JobViewer.update_job): New method.
	(JobViewer.refresh): Use add_job
	(JobViewer.update_job_creation_times): Better timer handling.
	(JobViewer.job_added): New method, part of Watcher interface.
	(JobViewer.job_event): Likewise.
	(JobViewer.job_removed): Likewise.
	(JobViewer.still_connecting): Likewise.
	(JobViewer.now_connected): Likewise.
	(JobViewer.state_reason_added): Likewise.

	* cupshelpers.py (Printer.setAsDefault): New method.
	* system-config-printer.py (GUI.set_default_printer): Use it.

2008-03-18  Tim Waugh  <twaugh@redhat.com>

	* statereason.py (StateReason.__repr__): New method.

	* system-config-printer.py (GUI.reconnect): Use
	authconn.Connection._connect() to reconnect.

	* jobviewer.py (JobViewer.__init__): Removed password dialog
	bits.
	(JobViewer.cupsPasswdCallback): Removed.

	* contextmenu.py (PrinterContextMenu.popup): Show or hide context
	menu items.

	* system-config-printer.glade: Removed password dialog.
	* system-config-printer.py (GUI.__init__): Don't set CUPS password
	callback, as this is set in authconn.Connection.
	(GUI.connect): Likewise.
	(NewPrinterGUI.getPPDs_thread): Set password callback to empty
	function.
	(NewPrinterGUI.getDevices_thread): Likewise.
	(GUI.cupsPasswdCallback): Removed.
	(GUI.on_btnPasswdOk_clicked): Removed.
	(GUI.on_btnPasswdCancel_clicked): Removed.

	* system-config-printer.py (GUI.on_quit_activate): Clean up
	context menu and any jobviewers it has launched.

	* jobviewer.py (JobViewer.__init__): Optional exit_handler
	function.
	(JobViewer.cleanup): Call it.

	* contextmenu.py (PrinterContextMenu.__init__): Track jobviewers.
	(PrinterContextMenu.cleanup): New method.
	(PrinterContextMenu.on_jobviewer_exit): New method.

	* smburi.py: New module.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.

	* contextmenu.py: New module.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.

	* system-config-printer.py (GUI.populateList): Add default emblem.
	(PrinterContextMenu.popup): Don't include Set As Default in the
	context menu if the printer is already the default.
	(GUI.set_default_printer): New method.
	(GUI.on_btnPMakeDefault_clicked): Use it.
	(PrinterContextMenu.on_printer_context_set_as_default_activate):
	Likewise.
	(PrinterContextMenu.popup): Don't include Enable or Disable if not
	possible.
	(PrinterContextMenu.on_printer_context_enable_activate): New
	method.
	(PrinterContextMenu.on_printer_context_disable_activate): New
	method.
	(GUI.on_btnApply_clicked): Removed.
	(GUI.apply): Removed.
	(GUI.on_delete_activate): Handle the Icon View.
	(PrinterContextMenu.on_printer_context_delete_activate): New
	method.
	(PrinterContextMenu.popup): Disallow actions on discovered
	printers that require a remote connection.

2008-03-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Set initial window size
	appropriately.
	(GUI.fillServerTab): Removed old code.
	(GUI.on_tvMainList_row_activated): Removed.
	(GUI.on_btnRevert_clicked): Removed.
	(GUI.fillServerTab): Propagate the exception.
	(GUI.on_server_settings_activate): Catch the exception and
	return.
	(GUI.__init__): Simpler method for setting initial window size.

	* system-config-printer.glade: Removed unnecessary button box
	buttons.
	* system-config-printer.py (GUI.dests_iconview_selection_changed):
	Only allow copying of a	single destination.

	* system-config-printer.py (main): New option --debug.
	* man/system-config-printer.xml: Document it.
	* Makefile.am (run): Run with debugging enabled.

	* system-config-printer.py (GUI.__init__): Use authconn.Connection.
	(GUI.on_connect_activate): Pass in the parent window widget.
	(GUI.connect): Use authconn.Connection.
	(GUI.reconnect): Likewise.
	(GUI.on_btnRefresh_clicked): Likewise.

	* jobviewer.py (JobViewer.on_job_cancel_activate): Use
	authconn.Connection.
	(JobViewer.on_job_hold_activate): Likewise.
	(JobViewer.on_job_release_activate): Likewise.
	(JobViewer.on_job_reprint_activate): Likewise.

	* troubleshoot/ErrorLogCheckpoint.py
	(ErrorLogCheckpoint.enable_clicked): No need to work around
	adminGetServerSettings weirdness.
	* troubleshoot/ErrorLogFetch.py (ErrorLogFetch.button_clicked):
	Likewise.

	* troubleshoot/base.py: Use debug module.
	* troubleshoot/__init__.py (run): Likewise.

	* troubleshoot/ErrorLogFetch.py (ErrorLogFetch.display): Reconnect
	in case cupsd has restarted.

	* authconn.py (Connection._authloop): Raise IPPError if
	adminGetServerSettings returns no settings.

	* troubleshoot/ErrorLogFetch.py (ErrorLogFetch.button_clicked):
	Changed to use authconn.Connection.

	* authconn.py (Connection.__init__): Initialise _use_user correctly.
	(Connection._set_prompt_allowed): Allow caller to disallow
	prompting.
	(Connection._authloop): Handle cups.HTTPError.

	* troubleshoot/ErrorLogCheckpoint.py
	(ErrorLogCheckpoint.enable_clicked): Changed to use
	authconn.Connection.

	* troubleshoot/Welcome.py (AuthenticationDialog): Removed.  Use
	authconn.Connection instead.

	* authconn.py: New file.
	* po/POTFILES.in: Translate it.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.

2008-03-16  Tim Waugh  <twaugh@redhat.com>

	* jobviewer.py (JobViewer.__init__): Default trayicon to False.
	(JobViewer.on_delete_event): Cancel subscriptions when run from
	main applications.

	* system-config-printer.py
	(PrinterContextMenu.on_printer_context_view_print_queue_activate):
	No need to specify trayicon=False.

	* jobviewer.py: Moved JobManager here and renamed as JobViewer.
	* po/POTFILES.in: Translate jobviewer.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.
	* system-config-printer.py
	(PrinterContextMenu.on_printer_context_view_print_queue_activate):
	Updated.

	* debug.py: New module.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.
	* applet.py: Use it.
	* system-config-printer.py: Likewise.
	* cupshelpers.py: Likewise.

2008-03-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.populateList): Set tooltips.

2008-03-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Import applet.
	(PrinterContextMenu.on_printer_context_view_print_queue_activate):
	Use JobManager to display jobs for selected printers.

	* applet.py (JobManager.__init__): Add my_jobs and specific_dests
	arguments.
	(JobManager.refresh): Use my_jobs argument.
	(JobManager.get_notifications): Likewise.
	(JobManager.refresh): Ignore jobs not matching specific_dests.
	(JobManager.get_notifications): Likewise.

	* icons/i-network-printer.png: New file.
	* Makefile.am (nobase_pkgdata_DATA): Ship icon.
	* system-config-printer.py (GUI.populateList): Use different icon
	for remote printers.
	(GUI.dests_iconview_button_release_event): Allow multiple
	destinations to be selected.

	* system-config-printer.py (GUI.on_btnApplyApply_clicked):
	Removed.
	(GUI.on_btnApplyCancel_clicked): Likewise.
	(GUI.on_btnApplyDiscard_clicked): Likewise.
	(GUI): No need to check for unapplied changes.
	(GUI.on_quit_activate): Likewise.
	(GUI.on_copy_activate): Likewise.
	(GUI.setDataButtonState): Only set Installable Options tab
	weight.
	(GUI.dests_iconview_button_release_event): Display printer context
	menu.
	(PrinterContextMenu): New class.

	* cupshelpers.py (getPrinters): Avoid fetching printers.conf when
	not needed.

	* system-config-printer.py (GUI.dests_iconview_item_activated):
	Apply changes.
	(GUI.on_server_settings_activate): New method.

2008-03-13  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Some changes to cope with the new UI.
	* system-config-printer.glade: Switch to icon view.

	* applet.py (JobManager.get_notifications): Ignore jobs that are
	not owned by the current user.

2008-03-10  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.get_notifications): Distinguish between
	failed jobs and jobs that require authentication.

2008-03-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: 'Goto' isn't a word.

	* system-config-printer.py (GUI.populateList): Fix default printer
	detection.

	* troubleshoot/__init__.py (QUESTIONS): Run it.
	* troubleshoot/CheckPPDSanity.py: New module.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.
	* po/POTFILES.in: Translate it.

	* troubleshoot/CheckLocalServerPublishing.py: New module.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.
	* po/POTFILES.in: Translate it.
	* troubleshoot/__init__.py (QUESTIONS): Run it.

	* troubleshoot/SchedulerNotRunning.py
	(SchedulerNotRunning.display): Deal with being run before a
	printer is chosen.

	* troubleshoot/__init__.py (QUESTIONS): Check that the scheduler
	is running very first thing.

2008-03-06  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/DeviceListed.py: New module.
	* po/POTFILES.in: Translate it.
	* Makefile.am: Ship it.
	* troubleshoot/__init__.py (QUESTIONS): Run it.

2008-03-05  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Printer.getAttributes): Store all other
	attributes.

	* system-config-printer.py (GUI.fillPrinterTab): Use
	server-is-sharing-printers attribute if present.

	* applet.py (collect_printer_state_reasons): Fix work-around.
	(JobManager.get_notifications): Likewise.

	* system-config-printer.py
	(NewPrinterGUI.on_btnIPPVerify_clicked): Prevent traceback when
	failing to fetch printer attributes.

2008-03-03  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.get_notifications): The notify-printer-uri
	attribute may not be set.
	(JobManager.get_notifications): If the printer has been disabled
	as a result of a failed job, say so.

2008-02-29  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.update): Make a list of active jobs
	indexed by printer name.
	(JobManager.check_state_reasons): Only display a
	connecting-to-device warning if we have a job processing on that
	device.
	(JobManager.toggle_window_display): New force_show parameter.
	(JobManager.get_notifications): Handle job-stopped event by
	displaying a dialog when running as a tray icon.
	(JobManager.print_error_dialog_response): New method.  Invoke the
	troubleshooter if user selects 'Diagnose'.
	(JobManager.on_troubleshoot_quit): New method.

2008-02-28  Tim Waugh  <twaugh@redhat.com>

	* applet.py (debugprint): New function.
	(JobManager.__init__): No longer need will_refresh or
	last_refreshed attributes.
	(JobManager.__init__): Initialise subscription ID.
	(JobManager.refresh): Cancel existing subscription and create new
	subscription.  No longer need throttling.
	(JobManager.cleanup): New method.  Cancel subscription.
	(JobManager.get_notifications): New method.
	(JobManager.handle_dbus_signal): Use get_notifications instead of
	refresh.
	(JobManager.check_still_connecting): Use get_notifications, not
	refresh.
	(JobManager.check_state_reasons): Don't take a CUPS connection as
	argument.  For now, open a new connection, although this should
	not be needed really.
	(JobManager.update): New method, split out from old refresh
	method.  Don't fetch job list again; we already have enough
	information.
	(JobManager.on_job_reprint_activate): Don't need to call refresh
	now.
	(JobManager.handle_dbus_signal): Schedule a call to
	get_notifications.
	(top level): New --debug option.
	(state_reason_is_harmless): New function, split out from
	collect_printer_state_reasons.
	(collect_printer_state_reasons): Collate reasons by printer name.
	(worst_printer_state_reason): Handle reasons collation.
	(JobManager.update_connecting_devices): Likewise.
	(JobManager.check_state_reasons): Likewise.
	(JobManager.check_still_connecting): No longer need to connect to
	CUPS here.
	(JobManager.check_state_reasons): Likewise.
	(JobManager.get_notifications): Remove state reasons for deleted
	printers, and update state reasons for printers whose state has
	changed.
	(JobManager.get_notifications): Don't update when the
	notify-get-interval tells us to; instead, rely on D-Bus for this.
	(JobManager.refresh): Add printer-deleted and
	printer-state-changed to the list of interesting events.
	(JobManager.refresh): Fetch printer state reasons.

	* troubleshoot/PrintTestPage.py (PrintTestPage.connect_signals):
	Connect to the system D-Bus.
	(PrintTestPage.disconnect_signals): Disconnect from D-Bus.
	(PrintTestPage.handle_dbus_signal): Schedule a refresh.
	(PrintTestPage.update_jobs_list): Schedule the next refresh
	according to notify-get-interval.

	* troubleshoot/ErrorLogParse.py (ErrorLogParse.display): Use log
	severity indicator.

2008-02-26  Tim Waugh  <twaugh@redhat.com>

	* statereason.py (StateReason.get_description): Handle 'offline'
	state reason.
	(StateReason.get_description): Handle 'other' state reason.

2008-02-25  Tim Waugh  <twaugh@redhat.com>

	* applet.py (show_version.monitor_session): Correct comment.

2008-02-20  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/ErrorLogCheckpoint.py (ErrorLogCheckpoint.display):
	Remember CUPS server settings for diagnostic output.
	(ErrorLogCheckpoint.enable_clicked): Likewise.

	* troubleshoot/Welcome.py (AuthenticationDialog.callback): Don't
	remember a password if the dialog was cancelled.

	* troubleshoot/__init__.py (Troubleshooter.answers_as_text): Don't
	display answers whose tags begin with an underscore.

	* troubleshoot/ErrorLogCheckpoint.py
	(ErrorLogCheckpoint.enable_clicked): Don't create a new
	AuthenticationDialog instance.

	* troubleshoot/Welcome.py (Welcome.collect_answer): Instantiate
	AuthenticationDialog.

	* troubleshoot/base.py (AuthenticationDialog): Moved...
	* troubleshoow/Welcome.py (AuthenticationDialog): ...here.

2008-02-19  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.82.

2008-02-19  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/PrintTestPage.py
	(PrintTestPage.collect_answer.collect_jobs.each): Try to use
	getJobAttributes if available.

	* applet.py (JobManager.on_notification_closed): Reset connecting
	timer when notification is closed.
	(JobManager.check_state_reasons): Use printer icon in notification
	bubble.
	(NewPrinterNotification.NewPrinter): Likewise.

	* troubleshoot/Shrug.py (Shrug.on_save_clicked): Save as
	troubleshoot.txt by default.

	* troubleshoot/ErrorLogParse.py (ErrorLogParse.display): Don't
	trigger on error_log fetch.

	* troubleshoot/ErrorLogFetch.py (ErrorLogFetch.__init__): Disable
	debug logging if we enabled it.
	(ErrorLogFetch.display): Fetch error_log here instead of in
	collect_answer.
	(ErrorLogFetch.connect_signals): New method.
	(ErrorLogFetch.disconnect_signals): New method.
	(ErrorLogFetch.button_clicked): New method.  Disable debug
	logging.

	* troubleshoot/ErrorLogCheckpoint.py
	(ErrorLogCheckpoint.__init__): Enable debug logging if not set.
	(ErrorLogCheckpoint.display): Fetch server settings.
	(ErrorLogCheckpoint.connect_signals): New method.
	(ErrorLogCheckpoint.disconnect_signals): New method.
	(ErrorLogCheckpoint.enable_clicked): New method.  Enable debug
	logging.

	* troubleshoot/base.py (AuthenticationDialog): Added some fixes.

	* troubleshoot/PrintTestPage.py (PrintTestPage.update_jobs_list):
	Work around old pycups bug.
	(PrintTestPage.__init__): Allow other documents to be printed and
	tracked using a check-box in each job row.
	(PrintTestPage.update_job): Update columns IDs.
	(PrintTestPage.display): Update store column types, and initialise
	check-boxes.
	(PrintTestPage.test_toggled): New method.
	(PrintTestPage.connect_signals): Connect toggle signal.
	(PrintTestPage.disconnect_signals): Disconnect it.
	(PrintTestPage.collect_answer.collect_jobs.each): Include job
	attributes for selected jobs.
	(PrintTestPage.update_jobs_list): Initialise check-box.

2008-02-18  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot/ErrorLogFetch.py: New module.
	* troubleshoot/ErrorLogCheckpoint.py: New module.
	* troubleshoot/ErrorLogParse.py: New module.
	* troubleshoot/__init__.py (QUESTIONS): Run them.
	* Makefile.am: Ship them.
	* po/POTFILES.in: Translate them.

	* troubleshoot/PrinterStateReasons.py
	(PrinterStateReasons.collect_answer): Fixed traceback.
	(PrinterStateReasons.display): Use saved state message and
	reasons.

	* troubleshoot.py: Moved...
	* troubleshoot/__init__.py: ...here.
	* troubleshoot/base.py: Split out from troubleshoot.py.
	* troubleshoot/CheckNetworkServerSanity.py: Likewise.
	* troubleshoot/CheckPrinterSanity.py: Likewise.
	* troubleshoot/ChooseNetworkPrinter.py: Likewise.
	* troubleshoot/ChoosePrinter.py: Likewise.
	* troubleshoot/LocalOrRemote.py: Likewise.
	* troubleshoot/NetworkCUPSPrinterShared.py: Likewise.
	* troubleshoot/PrinterStateReasons.py: Likewise.
	* troubleshoot/PrintTestPage.py: Likewise.
	* troubleshoot/QueueNotEnabled.py: Likewise.
	* troubleshoot/QueueRejectingJobs.py: Likewise.
	* troubleshoot/RemoteAddress.py: Likewise.
	* troubleshoot/SchedulerNotRunning.py: Likewise.
	* troubleshoot/ServerFirewalled.py: Likewise.
	* troubleshoot/Shrug.py: Likewise.
	* troubleshoot/Welcome.py: Likewise.
	* Makefile.am: Ship new files.
	* po/POTFILES.in: Translate them.

	* po/de.po: Updated (bug #433230).

2008-02-17  Tim Waugh  <twaugh@redhat.com>

	* po/fr.po: Updated (bug #433193).

2008-02-14  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot.py (CheckPrinterSanity.display): Don't display
	unless queue is listed.
	(ServerFirewalled.display): Likewise.
	(QueueNotEnabled.display): Likewise.
	(QueueRejectingJobs.display): Likewise.
	(PrinterStateReasons.display): Likewise.
	(PrinterNotListed.display): Don't display if queue is listed.
	(LocalOrRemote.display): Likewise.
	(RemoteAddress.display): Likewise.
	(ChooseNetworkPrinter.display): Likewise.
	(NetworkCUPSPrinterShared.display): Better restrictions.
	(NetworkCUPSPrinterEnabled.display): Tighter exception handling.
	(NetworkCUPSPrinterAccepting.display): Likewise.

	* applet.py (StateReason): Moved...
	* statereason.py (StateReason): ...here.  New file.
	* Makefile.am (nobase_pkgdata_DATA): Ship it.

2008-02-13  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot.py (CheckNetworkPrinterSanity.display): Fetch
	printer attributes if we know the queue name.
	(ChoosePrinter.cursor_changed): Don't the
	CheckNetworkPrinterSanity test twice.

2008-02-13  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.81.

2008-02-13  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot.py: Detect CUPS servers that have their TCP port
	firewalled.

	* troubleshoot.py (QueueNotEnabled.display): More explanation.
	(ChooseNetworkPrinter.display): Skip over default entry.
	(ChoosePrinter.display): Likewise.

	* my-default-printer.py (Server.getUserDefault): Fixed breakage
	caused by pycups change.
	(Server.getSystemDefault): Use getDefault if available.

2008-02-12  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Moved remote
	CUPS test to the right place (Ubuntu #178727).

2008-02-07  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot.py (PrintTestPage.__init__): Add a 'Cancel All
	Jobs' button.
	(PrintTestPage.cancel_clicked): New method.
	(PrintTestPage.update_jobs_list): Display all jobs on that
	printer, not just our test pages.
	(PrintTestPage.update_job): New method.
	(PrintTestPage.display): Use it.
	(PrintTestPage.update_jobs_list): Likewise.
	(AuthenticationDialog): New class.
	(PrintTestPage.update_jobs_list): Record test page completion
	notify-text messages for diagnostic output.

2008-02-06  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot.py (ChoosePrinter.display): Handle CUPS connection
	failure.
	(PrinterNotListed.can_click_forward): No more questions to ask.
	(PrinterStateReasons.display): Fetch the printer-state-message and
	printer-state-reasons fresh from the server.
	(PrinterStateReasons.display): Work around a pycups bug.
	(PrinterStateReasons.collect_answer): Record state message and
	reasons for diagnostic output.

	* system-config-printer.glade: Align widgets on the Policies tab.

2008-02-05  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot.py (PrintTestPage): Improvements to the job
	display.

2008-02-04  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.80.

2008-02-04  Tim Waugh  <twaugh@redhat.com>

	* troubleshoot.py (Troubleshooter.answers_as_text): Don't
	translate this.

	* po/POTFILES.in: Added troubleshoot.py.

	* system-config-printer.py (GUI.on_troubleshoot_activate): Run the
	trouble-shooter.

	* troubleshoot.py: New file.
	* Makefile.am: Ship it.

2008-02-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.browse_ipp_queues_thread): Fix enumeration of
	classes.

2008-01-31  Tim Waugh  <twaugh@redhat.com>

	* config.py.in: Set DOWNLOADABLE_DRIVER_SUPPORT.
	* system-config-printer.py: Remove downloadable driver support if not
	enabled in config module.

	* ppds.py (PPDs._findBestMatchPPDs): Fixed thinko.

	* system-config-printer.py
	(NewPrinterGUI.on_tvNPDownloadableDrivers_cursor_changed): Fixed
	typo.

	* system-config-printer.glade: Line wrap long label.

2008-01-30  Tim Waugh  <twaugh@redhat.com>

	* openprinting.py (OpenPrinting.listDrivers.parse_result): Don't
	normalize space in licensetext.

	* system-config-printer.py (NewPrinterGUI.fillDeviceTab): Disabled
	slow HPLIP URI look-ups until they are moved to the right place.

	* system-config-printer.py
	(NewPrinterGUI.openprinting_drivers_found): Display traceback for
	debugging.
	(NewPrinterGUI.on_tvNPDownloadableDrivers_cursor_changed): Fill in
	driver properties.

	* openprinting.py (OpenPrinting.listDrivers.parse_result): File's
	url attribute was missing.
	(QueryThread.run): Print query URL for debugging.
	(OpenPrinting.listDrivers.parse_result): Re-work data type for XML
	format change.
	(OpenPrinting.listDrivers.parse_result): Include functionality
	elements.
	(normalize_space): New function.
	(OpenPrinting.listDrivers.parse_result): Normalize space.

2008-01-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_rbtnNPFoomatic_toggled): Better logic for search
	widget sensitivity.
	(NewPrinterGUI.openprinting_printers_found): Use
	threads_enter/threads_leave.
	(NewPrinterGUI.on_cmbNPDownloadableDriverFoundPrinters_changed):
	Start a query for drivers.
	(NewPrinterGUI.openprinting_drivers_found): New method.
	(NewPrinterGUI.nextNPTab): Display wait window if driver query is
	still in progress.
	(NewPrinterGUI.on_rbtnNPFoomatic_toggled): Properly cancel out the
	search operation.
	(NewPrinterGUI.openprinting_drivers_found): Populate downloadable
	drivers list and hide wait window.
	(NewPrinterGUI.on_tvNPDownloadableDrivers_cursor_changed): New
	method.
	(NewPrinterGUI.on_cmbNPDownloadableDriverFoundPrinters_changed):
	Cancel any driver query in progress.
	(NewPrinterGUI.fillDownloadableDrivers): Avoid traceback when
	there are no drivers returned.
	(NewPrinterGUI.on_btnNPDownloadableDriverSearch_clicked): Cancel
	out the driver search operation if a new printer search is
	performed.

	* openprinting.py (QueryThread.__init__): Set query thread as
	daemon to prevent open queries from keeping the application
	running.

	* system-config-printer.py
	(NewPrinterGUI.openprinting_printers_found): Simplified code.

2008-01-28  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Import the openprinting module.
	(NewPrinterGUI.__init__): Additional set-up for OpenPrinting
	widgets.
	(NewPrinterGUI.setNPButtons): If downloading a driver, check that
	a model is selected before proceeding.
	(NewPrinterGUI.on_btnNPDownloadableDriverSearch_clicked): New
	method.
	(NewPrinterGUI.openprinting_printers_found): New method.
	(NewPrinterGUI.on_cmbNPDownloadableDriverFoundPrinters_changed):
	New method.
	(NewPrinterGUI.__init__): Initialise search handle.
	(NewPrinterGUI.on_NPCancel): Cancel search.
	(NewPrinterGUI.openprinting_printers_found): Clear search handle.
	(NewPrinterGUI.init): Initialise search widgets.
	(NewPrinterGUI.openprinting_printers_found): When only one printer
	is found from the search, select it automatically.
	(NewPrinterGUI.init): Set search button label.
	(NewPrinterGUI.on_btnNPDownloadableDriverSearch_clicked): Update
	search button label.
	(NewPrinterGUI.openprinting_printers_found): Reset search button
	label.

	* openprinting.py (OpenPrinting.searchPrinters.parse_result):
	Don't call the callback twice on error; instead display a
	useful traceback.

2008-01-25  Tim Waugh  <twaugh@redhat.com>

	* openprinting.py (OpenPrinting): Fixed test app threading.

2008-01-25  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.79.

2008-01-25  Tim Waugh  <twaugh@redhat.com>

	* openprinting.py: New module.

	* Makefile.am: Ship it and install it.

	* system-config-printer.py (NewPrinterGUI.__init__): No need to
	fetch labels we aren't going to do anything with.
	(NewPrinterGUI.on_rbtnNPFoomatic_changed): Set sensitivity of
	downloadable driver widgets as a group.
	(NewPrinterGUI.__init__): Disable downloadable driver support
	until it's working.

2008-01-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.reconnect): Better reconnection
	method.
	(GUI.save_serversettings): Really refresh server settings after
	applying changes.
	(NewPrinterGUI.get_hplip_uri_for_network_printer): Add debugging
	output.
	(NewPrinterGUI.getNetworkPrinterMakeModel): Likewise.

2008-01-17  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.glade: Added search button and printer
	list combo box to the search term input field for finding
	drivers. So the user can select his printer first and then see the
	downloadable drivers.

2008-01-16  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.on_treeview_button_press_event): Use
	job-preserved to control whether reprint is allowed, as with the
	CUPS web interface (bug #423441).

	* system-config-printer.py (GUI.save_serversettings): Refresh
	server settings after applying changes (bug #421431).

	* applet.py (NewPrinterNotification.install_driver): New method.
	(NewPrinterNotification.NewPrinter): Prompt for driver
	installation if needed (bug #379321).

2008-01-11  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py (pollDownloadableDrivers): Added code
	for querying the OpenPrinting database for downloadable drivers.

2008-01-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnRefresh_clicked): Try to
	reconnect if not connected.

2008-01-10  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Started on the code to make the new GUI
	elements for the automatic driver download working.

	* system-config-printer.glade: Added GUI for automatic driver download
	from the OpenPrinting web site.
	Updated list of authors in the "About" dialog.

2008-01-08  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.update_job_creation_times): Fill in number
	of hours.

2008-01-07  Till Kamppeter  <till.kamppeter@gmail.com>

	* cupshelpers.py: If the device discovery output of a CUPS backend
	has "Unknown" for make and model but something useful in the info
	field, copy the info field into the make-and-model field.

	* ppds.py: Derive manufacturer name from model name if the manufacturer
	name is missing in the Nickname or make-and-model string.
	Remove "(Bluetooth)" from model name for more reliable matching.
	Handle the manufacturer name "KONICA MINOLTA" correctly (Ubuntu
	#64046). 
	Use case-insensitive when cleaning model names.
	For "recommended" Foomatic PPDs give higher priority than a vendor PPD
	in case of the recommended driver being not "Postscript" and lower
	priority otherwise. So if using the printer in PostScript mode is
	recommended, the vendor PPD will be preferred, if another mode of
	the printer is recommended (like PCL on HP LaserJet 12xx/13xx) the
	appropriate non-PostScript PPD will be used (Ubuntu #172550).

	* system-config-printer.py: Allow listing of all files in file
	chooser dialog for selecting a custom PPD file. This way also PPDs
	without the ".ppd" extension can be selected (Ubuntu #153585).
	
2008-01-04  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py, ppds.py: Make automatic recognition
	of make and model of Bluetooth-connected printers working.

2007-12-20  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Make the Wait window a top-level
	window not a pop-up (Ubuntu #175766).

	* system-config-printer.py (GUI.populateList): Only try to fetch
	the default printer if we have a CUPS connection (Ubuntu
	#159212).
	(GUI.on_tvMainList_cursor_changed): Set data button state when no
	CUPS connection.

	* system-config-printer.py (NewPrinterGUI.on_entSMBURI_changed):
	SMB browser is no longer in the same window as the editable URI
	(Ubuntu #173115).

	* system-config-printer.py (debugprint): New function.
	(nonfatalException): Use it.
	(GUI.on_btnPMakeDefault_clicked): Likewise.
	(GUI.on_btnPrintTestPage_clicked): Likewise.
	(NewPrinterGUI.queryPPDs): Likewise.
	(NewPrinterGUI.getPPDs_thread): Likewise.
	(NewPrinterGUI.fetchPPDs): Likewise.
	(NewPrinterGUI.queryDevices): Likewise.
	(NewPrinterGUI.getDevices_thread): Likewise.
	(NewPrinterGUI.fetchDevices): Likewise.
	(NewPrinterGUI.on_btnIPPVerify_clicked): Likewise.
	(NewPrinterGUI.getNPPPD): Likewise.

	* cupshelpers.py (debugprint): New function for printing without
	propagating print exceptions (Ubuntu #175500).
	(copyPPDOptions): Use it.
	(setPPDPageSize): Likewise.
	(missingPackagesAndExecutables.pathcheck): Likewise.
	(missingPackagesAndExecutables): Likewise.

2007-12-14  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (missingPackagesAndExecutables): Moved this
	function here...
	* system-config-printer.py (NewPrinterGUI.checkDriverExists):
	...from here.

2007-12-14  Tim Waugh  <twaugh@redhat.com>

	* applet.py (StateReason.__cmp__): Fixed use of __cmp__ (Ubuntu
	#149393).

2007-12-12  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_btnIPPVerify_clicked): Fixed typo.

2007-12-03  Till Kamppeter  <till.kamppeter@gmail.com>

	* cupshelpers.py (getPrinters): Determine via printers.conf whether
	an IPP queue was locally defined or whether it appears induced by
	a broadcasted remote queue.
	* system-config-printer.py (nextNPTab): If an IPP queue from a remote
	CUPS server gets auto-detected create a local raw queue, so that the
	driver from the server gets used. Such CUPS queues are queues which
	are advertised by the server only via DNS-SD/mDNS/Bonjour/ZeroConf
	as for example from Mac OS X servers. They can be detected via the
	dnssd backend from http://www.linuxprinting.org/download/printing/dnssd
	(on_tvMainList_cursor_changed, fillPrinterTab): Allow deleting/editing 
	of local raw IPP queues which point to a remote CUPS queue.
	(checkNPName): Do not allow silent overwriting of locally defined
	raw IPP queues pointing to a remote CUPS queue.
	(on_tvNPDevices_cursor_changed): Fixed bug of IPP printer setup
	GUI not showing the printer parameters when selecting an
	auto-detected IPP printer
	(getNPPPD): Fixed traceback when creating a raw queue.
	(nextNPTab): When stepping back with the "Previous" button in the
	"New printer" wizard the empty "Installed Options" screen was not
	skipped.
	
2007-11-30  Tim Waugh  <twaugh@redhat.com>

	* applet.py: Fixed New Printer notifications after they got broken
	by the icon hiding changes.

2007-11-29  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (PPDs.__init__): For C/POSIX locale, filter PPDs by
	American English.

	* system-config-printer.py (NewPrinterGUI.fillDriverList): Include
	PPD language in driver description (Ubuntu #161037).

	* applet.py (JobManager.refresh): If there are no jobs but there
	is a printer warning/error indicated by the icon, set the icon
	tooltip to the reason description.
	(JobManager.__init__): Fix printer status window columns so that
	the full printer name can be seen.

2007-11-27  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Set printer icon in Connect dialog.

	* system-config-printer.py (GUI.__init__): Set AboutDialog logo by
	icon name, set URL and email hooks, set icon (Ubuntu #165101).

	* applet.glade: Set Ctrl+R accelerator for Refresh menu
	entry (Ubuntu #137984).

	* system-config-printer.py (GUI.fillPrinterTab): Fetch attributes
	on demand.

	* cupshelpers.py (Printer.getAttributes): Make this method
	public.
	(Printer.__init__): Don't fetch attributes automatically.

	* system-config-printer.py
	(NewPrinterGUI.browse_ipp_queues_thread): Handle exceptions other
	than RuntimeError and cups.IPPError (bug #252304).
	(NewPrinterGUI.on_btnIPPVerify_clicked): Get printer attributes by
	printer URI not name, to prevent pycups constructing a CUPS URI
	(bug #252304).

2007-11-22  Till Kamppeter  <till.kamppeter@gmail.com>

	* print-applet.desktop.in: Removed the last printer.png (Ubuntu package
	did not build with Icon=printer.png in the .desktop file).

2007-11-22  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.78.

2007-11-22  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.check_state_reasons): Emblems and
	notifications make the icon useful.  For notifications, make the
	icon visible if it was not previously visible.  For emblems, do
	not hide the icon if currently visible (Ubuntu #151360).
	(JobManager.on_icon_hide_activate): When hiding the icon, allow it
	to become visible next time a job is submitted.
	(JobManager.__init__): Attach signal receiver after everything is
	correctly initialised.

2007-11-21  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (activateNewPrinter): Use getDefault (or, failing
	that, getDests) to find whether a default printer is set.
	* system-config-printer.py (GUI.populateList): Likewise.

	* system-config-printer.py (GUI.on_btnPrintTestPage_clicked):
	Better check for whether the CUPS server is local.

2007-11-19  Tim Waugh  <twaugh@redhat.com>

	* applet.py (NewPrinterNotification.any_jobs_or_errors): Fixed
	typo (bug #390431).

	* system-config-printer.py (NewPrinterGUI.on_btnNPApply_clicked):
	Handle unexpected exceptions a little bit better.
	(fatalException): New function.

2007-11-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.getSelectedItem): Decode GtkStore
	value from UTF-8.

2007-11-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Add a blank page to the main
	window's right-pane notebook for occasions when there is a problem
	fetching information about the printer.
	* system-config-printer.py (GUI.on_tvMainList_cursor_changed):
	When cupsGetPPD2() fails this is not fatal (bug #382031).

2007-11-13  Tim Waugh  <twaugh@redhat.com>

	* applet.py (WaitForJobs): New class to throttle the rate of
	checking for jobs or error messages when in start-up mode.  This
	prevents the applet being a nuisance when a large number of CUPS
	administration operations are performed in a batch.

2007-11-11  Tim Waugh  <twaugh@redhat.com>

	* manage-print-jobs.desktop.in, my-default-printer.desktop.in,
	system-config-printer.desktop.in: Don't require PNG format
	icon (Ubuntu #152634).

2007-11-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Better widget layouts for JetDirect
	and IPP device types in the New Printer dialog.

	* system-config-printer.py (NewPrinterGUI.update_IPP_URI_label):
	Show the IPP queue name widget and update the forward/backward
	buttons.
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Set the queue to a
	sensible CUPS template.

2007-10-31  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (main): Allow stand-alone Device ID testing.

2007-10-30  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.77.

2007-10-30  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Removed reference to applet.png.

	* system-config-printer.glade: Tooltips for the button bar
	buttons (bug #335601).

2007-10-23  Tim Waugh  <twaugh@redhat.com>

	* applet.py (StateReason): Better state reason icon names.

2007-10-18  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.check_state_reasons): Reverted testing
	change.

2007-10-17  Tim Waugh  <twaugh@redhat.com>

	* print-applet.desktop.in: Removed reference to applet.png.

	* applet.png: Removed.
	* inspecting-printer.png: Removed.
	* Makefile.am: Removed references to shipped icons.

	* applet.py (ICON, JobManager.__init__): Use 'printer' named icon
	from theme (Ubuntu #152634).

	* applet.py (StateReason): Use named icons for state reason
	severities (part of Ubuntu #152634).
	(JobManager.check_state_reasons): Load them from the theme.
	(JobManager.set_printer_status_icon): Likewise.

	* manage-print-jobs.desktop.in (Icon): Likewise.
	* applet.py (JobManager.set_special_status_icon,
	NewPrinterNotification.GetReady): Use 'document-print-preview'
	named icon from theme (Ubuntu #152634).

2007-10-16  Tim Waugh  <twaugh@redhat.com>

	* applet.py: Reverted mistaken commit (Ubuntu #149572).

2007-10-15  Tim Waugh  <twaugh@redhat.com>

	* po/no.po: Removed (bug #332381).
	* configure.in (ALL_LINGUAS): Removed 'no'.

	* Makefile.am (fix-glade): Remove toolbar_style property so as not
	to over-ride the session preferences (Ubuntu #135844).

2007-10-15  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.76.

2007-10-15  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.__init__): Set text domain for Glade
	(Ubuntu #149572).

2007-10-05  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (PPDs._findBestMatchPPDs): Efficiency improvement (don't
	run lower() on the loop-constant string).
	(PPDs._findBestMatchPPDs): The model search should be performed in
	model order.

2007-10-05  Till Kamppeter  <till.kamppeter@gmail.com>

	* ppds.py (_findBestMatchPPDs): Do case-insensitive match when
	matching "most important" word. Especially important for matching
	Canon printers (Ubuntu #149264).

2007-10-05  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: SMB device screen padding changes.

	* system-config-printer.py (NewPrinterGUI.update_IPP_URI_label):
	New method.
	(NewPrinterGUI.on_entNPTIPPHostname_changed): Use it.
	(NewPrinterGUI.on_entNPTIPPQueuename_changed): New method.
	(NewPrinterGUI.on_btnIPPVerify_clicked): New method.
	(NewPrinterGUI.browse_ipp_queues_thread): Display a different
	message when the IPP request failed.

	* system-config-printer.glade: Another IPP browse change.

	* pysmb.py: More consistency and care in building command lines.

2007-10-03  Till Kamppeter  <till.kamppeter@gmail.com>

	* my-default-printer.py: Corrected gettext domain (Ubuntu #147788).

2007-10-02  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_server_changed): Fixed change
	tracking.
	(GUI.fillServerTab): Set sensitivity of 'Allow printing from the
	Internet' (Ubuntu #146471).
	(GUI.save_printer): Fetch server settings if printer was saved.
	This allows us to update the 'not published' label earlier.

	* applet.py (StateReason.__cmp__): Fixed typo (Ubuntu #148022).

	* system-config-printer.glade: Wrap explanation text for other job
	options (Ubuntu #148010).

2007-10-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_server_changed): Fixed
	traceback (Ubuntu #139192).

	* my-default-printer.py (Dialog.run): Disable the Set Default
	button when there are no printers available (Ubuntu #146925).

	* system-config-printer.glade: Give a proper name to the Connect
	button.
	* system-config-printer.py (GUI.on_connect_servername_changed):
	Disable the Connect button when the server name is
	empty (Ubuntu #147450).

2007-09-28  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py: Removed shebang.
	(Printer.setOption): Convert floating point values to strings in a
	locale-safe manner (Ubuntu #145693).
	(Printer._getAttributes): Avoid mis-interpreting '1,2'-type
	values.

	* system-config-printer.py (GUI.fillPrinterTab): Handle strange
	options a little bit more gracefully.

	* system-config-printer.py: Don't import cupsd module.

	* cupsd.py: Removed.
	* Makefile.am: Don't ship cupsd.py.

	* system-config-printer.glade: Alignment fixes for SMB device
	page.

2007-09-27  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (PPDs.__init__): CUPS sets the 'raw' model's
	ppd-make-and-model to 'Raw Queue' which unfortunately then appears
	as manufacturer Raw and model Queue.  Use 'Generic' for this
	model.

2007-09-26  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.browse_smb_hosts_thread): This is a translatable
	string.

	* system-config-printer.py (GUI.on_entNPTDevice_changed): Set
	button sensitivity.
	* system-config-printer.glade: Added 'changed' handler for URI
	text entry.

	* system-config-printer.py (NewPrinterGUI.__init__): New widgets.
	(NewPrinterGUI.on_entNPTIPPHostname_changed): New method.
	(NewPrinterGUI.__init__): Set up IPP browser.
	(NewPrinterGUI.on_btnIPPFindQueue_clicked): Display IPP browser.
	(NewPrinterGUI.browse_ipp_queues): Start IPP browse thread.
	(NewPrinterGUI.browse_ipp_queues_thread): Browse for IPP queues.
	(NewPrinterGUI.on_btnIPPBrowseRefresh_clicked): Fixed typo.

	* system-config-printer.glade: IPP browse dialog and re-worked IPP
	device page.

	* system-config-printer.py (GUI.on_tvMainList_row_activated): Just
	selecting printer type headings should not expand or collapse the
	list, but activating them (double-clicking) should.  Part of
	Ubuntu #144106.

	* system-config-printer.py (GUI.setDataButtonState): Don't allow
	test pages for raw queues (Ubuntu #145098).

	* ppds.py (PPDs._findBestMatchPPDs): Rather than just looking for
	the longest initial match in model order, sort our model name into
	the available models and look at the immediate neighbours.  Pick
	the longest initial match from them (bug #244546).
	(main): New ID matching test case.

2007-09-25  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (getDriverType): Fix foomatic recommended driver
	discovery (requires CUPS patch to prevent '(recommended)' string
	getting stripped).
	(PPDs.getDriverTypeWithBias): Let getDriverType have access to the
	PPDs object.

2007-09-23  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Added missing argument to call of the
	  set_transient_for() method of ErrorDialog.
	
2007-09-21  Tim Waugh  <twaugh@redhat.com>

	* po/ko.po: Updated (from 0.7.32.x POT; needs further updating).

2007-09-20  Tim Waugh  <twaugh@redhat.com>

	* options.py (OptionAlwaysShownSpecial): New class to handle
	orientation-requsted.
	* system-config-printer.py (GUI.__init__): Use it.

2007-09-19  Tim Waugh  <twaugh@redhat.com>

	* options.py (OptionAlwaysShown.__init__): Handle IPP_TAG_NOVALUE
	by treating the option as not set (i.e. Reset button is not
	sensitive).

	* system-config-printer.py: Require pycups-1.9.27 so that
	IPP_TAG_NOVALUE attributes have Python value None instead of a
	string.

	* options.py (OptionAlwaysShown.__init__): Handle IPP_TAG_NOVALUE
	by translating it to a valid default value.

2007-09-18  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.75.

2007-09-18  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py, system-config-printer.glade: When
	changing the PPD lets the user's settings stay conserved. This is
	the behaviour expected more by the user and it is also the default
	behavior of CUPS.

2007-09-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.nextNPTab): Show the
	'No installable options' label when we can't fetch the PPD.

2007-09-18  Florian Festi  <ffesti@redhat.com>

	* system-config-printer.py: Show Installable Options when changing 
	PPD without accepting old settings
	* system-config-printer.glade: rename Installable Options to Installed Options
	
2007-09-18  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Remove duplicate URIs from the list of
	auto-discovered printers. This way one can use more than one
	network printer auto-discovery CUPS backend using different
	methods.

2007-09-18  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (PPDs.getPPDNameFromDeviceID): Fixed typo.

2007-09-17  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Avoid duplicate "(recommended)" marks
	  in the list of available drivers/PPDs for a given printer
	* ppds.py: Fixed typo.
	
2007-09-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: A little more descriptive text in
	the Installed Options page.

	* system-config-printer.py (NewPrinterGUI.__init__): Share error
	display functions with the main class.
	(NewPrinterGUI.on_btnNPApply_clicked): Hide wait window before
	displaying error.

2007-09-17  Florian Festi  <ffesti@redhat.com>

	* system-config-printer.py (NewPrinterGUI.on_btnNPApply_clicked):
	Add changes to Installable Options to the PPD
	(fillNPInstallableOptions): fix invisible Installable Options

2007-09-17  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (PPDs.getMakes): Use strcoll to sort manufacturer's
	names.

	* system-config-printer.py (show_help): Better help message.

2007-09-15  Tim Waugh  <twaugh@redhat.com>

	* po/fi.po: Updated.

2007-09-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (SMBURI): New class for manipulating
	SMB URIs.
	(GUI.fillPrinterTab): Use it.
	(NewPrinterGUI.on_entSMBURI_changed): Likewise.
	(NewPrinterGUI.on_btnSMBBrowseOk_clicked): Likewise.
	(NewPrinterGUI.on_btnSMBVerify_clicked): Likewise.
	(NewPrinterGUI.getDeviceURI): Likewise.
	(NewPrinterGUI.__init__): Fetch chkSMBAuth widget.
	(NewPrinterGUI.nextNPTab): Sanitize SMB URIs (remove passwords)
	before giving them to the PPD matcher; otherwise debug messages
	might show passwords.
	(NewPrinterGUI.fillDeviceTab): Don't print current URI.
	(NewPrinterGUI.on_entSMBURI_changed): Set authentication check-box
	inactive when not needed.
	(NewPrinterGUI.getDeviceURI): No user and password when the
	authentication check-box is not checked.
	(NewPrinterGUI.on_btnSMBVerify_clicked): Use get_active on the
	check-box rather than looking at the table's sensitivity.
	(GUI.fillPrinterTab): Set device URI sensitive when there is no
	needed for an ellipsis.
	(NewPrinterGUI.on_entSMBURI_changed): Always set username and
	password fields, even when empty.
	(NewPrinterGUI.on_btnSMBBrowseOk_clicked): Clear SMB username and
	password fields.
	(NewPrinterGUI.on_tvNPDevices_cursor_changed): Likewise.
	(NewPrinterGUI.on_entSMBURI_changed): Removed redundant code.
	(GUI.populateList): Select newly added printer instead of
	previously selected printer.

2007-09-13  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (NewPrinterGUI.__init__): Fetch the
	InfoDialog and lblInfo widgets from the Glade XML.
	(GUI.__init__): Fetch the widgets for the 'copy printer' dialog.
	(GUI.on_copy_activate): Select newly-copied printer.
	(GUI.populateList): When deleting a printer, select the default
	printer again.
	(NewPrinterGUI.getNPPPD): It is non-fatal for getServerPPD to fail
	here.
	(NewPrinterGUI.nextNPTab): Don't try to show installable options
	when the PPD cannot be fetched due to (a) lack of pycups support,
	(b) lack of libcups support, or (c) lack of support in the CUPS
	server.
	(NewPrinterGUI.nextNPTab): Only try to fill in Installable Options
	page if it's the next page (Change PPD currently doesn't have such
	a page).

2007-09-12  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py
	(NewPrinterGUI.on_btnSMBBrowseOk_clicked): Don't ignore 'changed'
	signal from Entry widget; otherwise the Verify button never gets
	set sensitive.
	(NewPrinterGUI.__init__): Fetch the ErrorDialog and lblError
	widgets from the Glade XML.

	* system-config-printer.glade: Prevent GTK+ warning about
	non-scrollable widgets.

	* system-config-printer.py (GUI.save_printer): When a class is
	removed on the server, remove it from the user interface.

2007-09-12  Florian Festi  <ffesti@redhat.com>

	* system-config-printer.py: Split out NewPrinterWindow into an own 
	class and move all kind of code arround.
	* system-config-printer.glade: Add a Installable Options tab to the
	New Printer Dialog.

	* still missing: 
	 - Installable Options are not set yet. 
	 - Installable Options are not shown when changing the PPD

2007-09-11  Till Kamppeter  <till.kamppeter@gmail.com>

	* Makefile.am: Let "make install" also install the new file
	gtk_treeviewtooltips.py

2007-09-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.maintenance_command): Set MIME
	type for command file.
	(GUI.setDataButtonState): Set maintenance buttons insensitive when
	not possible to submit maintenance jobs.
	(GUI.populateList): Don't select the default printer after changes
	to another printer have been made.
	(GUI.get_PPD_but_handle_errors): Always construct URI from input
	fields (bug #281551).
	(GUI.fillDeviceTab): No need to browse for SMB servers when
	changing device now; a separate Browse button handles that.

2007-09-05  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Moved state widget code to a sane place.
	(GUI.maintenance_command): New method implementing maintenance
	commands.

	* system-config-printer.glade: Button text changes.

2007-09-05  Florian Festi  <ffesti@redhat.com>

	* system-config-printer.glade: Adjusted spacing for small dialogs
	* system-config-printer.py(on_server_changed, fillServerTab):
	Set unsupported Server Settings insensitve instead of hidden
	Make SMBBrowseDialog transient to the New Printer Dialog
	Disable Verify SMB URI button if URI is empty
	Make sure new default Class names are unique
	Start counting from 2 when creating unique names
	Remove Apply New Printer/Class tab
	Added buttons for "Print Self Test" and "Clean Print Head"
	
2007-09-04  Florian Festi  <ffesti@redhat.com>

	* system-config-printer.glade, system-config-printer.py:
	Remove inactive PPD comments in the New Printer Dialog
	Show human readable name in the driver list
	Added tooltips to driver list

	* system-config-printer.py: Fix locking problems in PPD and Devices fetching code
	
2007-09-04  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.setConnected): Set sensitivity for
	new check-box.
	(GUI.fillServerTab): Show setting for new check-box.
	(GUI.on_server_changed): Set sensitivity for new check-box.
	(GUI.save_serversettings): Set server setting from check-box.

	* system-config-printer.glade: New check-box for 'Allow printing
	from the Internet'.

2007-09-03  Tim Waugh  <twaugh@redhat.com>

	* po/pl.po: Updated (bug #263001).

	* system-config-printer.py (GUI.on_tvSMBBrowser_cursor_changed):
	Prevent traceback when iter is None.

2007-09-03  Florian Festi  <ffesti@redhat.com>

	* system-config-printer.glade, system-config-printer.py:
	Move SMB browser into an own dialog that is filled in a separate thread.

	* pysmb.py: Remove signal.signal to allow usage in sub thread

2007-08-31  Tim Waugh  <twaugh@redhat.com>

	* my-default-printer.py (handle_sigchld): Ignore OSError
	(Ubuntu	#136403).

2007-08-30  Florian Festi  <ffesti@redhat.com>

	* system-config-printer.glade: 
	 - Use gtk.AboutDialog
	 - Make sub dialogs center on parent
	
2007-08-30  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.74.

2007-08-30  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Added 'help' target.

2007-08-30  Florian Festi  <ffesti@redhat.com>

	* system-config-printer.py (on_new_printer_activate): call 
	on_rbtnNPFoomatic_toggled after initNewPrinterWindow to avoid 
	trace back 
	
2007-08-30  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Applied patch from Florian Festi to
	fix widget padding in the dialogs.

2007-08-29  Tim Waugh  <twaugh@redhat.com>

	* po/fr.po: Updated (bug #264281).

	* system-config-printer.py (__init__): Developer can use
	environment variable SYSTEM_CONFIG_PRINTER_GLADE to override the
	location of the XML file to read.
	(GUI.connect): When connecting to a new server, try to select the
	printer we already had selected.  This is useful when selecting a
	remote printer and then clicking 'Go to...'.
	(GUI.initNewPrinterWindow): Fixed New Class dialog.
	(GUI.populateList): Expand list in order to select specified
	printer.

	* Makefile.am: New target 'run'.

	* system-config-printer.py: Expand/collapse printer lists.  Patch
	from Florian Festi.

	* system-config-printer.glade: Applied patch from Florian Festi to
	fix widget padding in the main window.

	* po/pl.po: Updated (bug #263001).

2007-08-24  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.73.

2007-08-24  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (main): Use CUPS_USER if set in the
	environment.

	* Makefile.am: New 'fix-glade' target for fixing glade XML produced
	by the glade-2 program; for instance, removing 'invisible_char'
	attributes.

2007-08-24  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.glade: Removed superfluous
	scrolledwindow+viewport set around the printer list. Thanks
	to Ryan Lovett for this patch. Fixes Ubuntu bug 134427.

2007-08-23  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Fixed display of warning message that
	a shared printer is not really published due to the CUPS server
	settings. The message was not removed when turning on printer
	sharing in the CUPS server setting. This fixes Ubuntu bug 132735.
	Set decent default selection in the main window when
	system-config-printer is started without options. If there is a
	default printer, select it, if not select the first printer in
	the list, and if there are no printers, select the server
	settings. Fixes Ubuntu bug 132652.

2007-08-22  Till Kamppeter  <till.kamppeter@gmail.com>

	* pysmb.py: Added new function get_host_list_from_domain() which
	lists all hosts belonging to a given domain using the command
	"nmblookup -R '<DOMAIN>'" and getting the SMB names of the hosts
	via "nmblookup -A <IP>". This is more reliable than the old
	function get_host_list() which uses "smbclient -N -L //<DOMAIN IP>".
	See Ubuntu bug 127152.
	Modified the test procedure to use the new function.

	* system-config-printer.py: Look up the hosts in a domain with the
	new get_host_list_from_domain() function. Make also sure that all
	items in the tree list of SMB domains/servers/shares have the little
	triangle to show the sub-tem list, even before the sub-items were
	scanned. These two fixes should fix Ubuntu bug 127152.
	Quote/Unquote all elements of the SMB device URIs, as spaces are
	also allowed in SMB host and share names. Should fix Ubuntu bug
	128261.
	Scan SMB host list when in the main window the "Change" button for
	the URI is clicked and the URI is an SMB URI. This way the list
	of SMB domains/servers/shares in the dialog for setting the URI
	does not stay empty.
	Handle exceptions raised by the browse_smb_hosts() function if it
	is called before the add-printer wizard window is open. Should fix
	Ubuntu bug 133573.
	
2007-08-21  Till Kamppeter  <till.kamppeter@gmail.com>

	* pysmb.py: "nmblookup -M -- -" not always gives a result. If not,
	fall back to "nmblookup '*'". This should fix Ubuntu bug 127152.
	If a printer share name has spaces, it got truncated at its first
	space this is fixed now and should fix Ubuntu bug 128261.

	* system-config-printer.py: Extract make and model name from the
	PPD file for positioning the cursor in the make/model selection
	whenever a PPD file was found, also with STATUS_NO_DRIVER.
	If there is no device ID information at all call PPD search with
	a non-existing device ID to get a fallback PPD (like textonly.ppd or
	postscript.ppd). This way the model selection cursor is never simply
	set onto the first entry of the "Generic" printers.
	This two changes fix Ubuntu bug 102389.

	* ppds.py: Let the PPDs coming with CUPS have higher priority than the
	"Generic" PPDs of Foomatic, but lower priority than model-specific
	Foomatic PPDs.
	(PPDs._findBestMatchPPDs): This function raised an exception on model
	names without digits.

2007-08-16  Till Kamppeter  <till.kamppeter@gmail.com>

	* ppds.py: Allow textonly.ppd and postscript.ppd (for fallback on
	unknown printer models) to be at any arbitrary place in the PPD
	file directories
	
2007-08-16  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (PPDs.getPPDNameFromDeviceID): Better fall-back if no
	textonly.ppd is available.
	(PPDs._findBestMatchPPDs): If no match is found at all, try
	searching for the model ID word, with decreasing significant
	figures.

2007-08-15  Till Kamppeter  <till.kamppeter@gmail.com>

	* system-config-printer.py: Added support for custom
	page-size-specific test pages. When clicking "Test Page"
	system-config-printer looks at first for a file
	/usr/share/system-config-printer/testpage-<PageSize>.ps where
	<PageSize> is the current page size setting of the printer
	(case-insensitive matching). If such a file is there, it will be
	printed, otherwise the standard CUPS test page. This allows
	distributions to place custom test pages (Thanks to Martin Pitt
	from Ubuntu/Debian).

	* system-config-printer.py: Made system-config-printer more
	flexible for special situations:
          - system-config-printer can be started and used by users in
	    the lpadmin group now
	  - system-config-printer can be started on systems without local CUPS
	    deamon (with client.conf pointing to a remote server)
	This should not break running system-config-printer as root.
	
2007-08-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.populateList): New optional
	argument for selecting an initial printer after connection (Ubuntu
	#132652).
	(GUI.populateList): Initially select default/first printer/class.

	* system-config-printer.py (GUI.save_serversettings): Handle
	RuntimeError from cups.adminSetServerSettings (Ubuntu #131848).
	(GUI.makeNameUnique): New method, for creating unique queue
	names (Ubuntu #132227).
	(GUI.nextNPTab): Use it.
	(GUI.on_btnNPApply_clicked): Show the Wait window when adding
	a new printer.
	(GUI.cupsPasswdCallback): Hide the Wait window while asking for
	password.

	* ppds.py (PPDs._findBestMatchPPDs): Don't try to match 'series'
	in Device ID MDL fields.

	* system-config-printer.glade (WaitWindow): New window.
	* system-config-printer.py: Responsiveness improvements.  Call
	into the main GTK+ loop when waiting for threads to finish, and
	index PPDs in the PPD thread.

	* system-config-printer.py (GUI.nextNPTab): Ask for name, location
	and description after model selection (Ubuntu #132227).
	(GUI.nextNPTab): Choose printer name based on selected model if no
	Device ID was available.

2007-08-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.initNewPrinterWindow): Set
	location as the hostname.
	(GUI.get_hplip_uri_for_network_printer): Protect hostname against
	shell expansion.
	(GUI.fillDeviceTab): Catch non-fatal exceptions when fetching make
	and model information from network printers.

	* system-config-printer.py (GUI.nextNPTab): Switch the first two
	pages of the New Printer wizard around, so that the device is
	chosen first and then the name.
	(GUI.initNewPrinterWindow): Likewise.
	(GUI.__init__): Query devices as soon as the application is
	started.
	(GUI.on_new_printer_activate): Fill device tab first when
	displaying the New Printer wizard.
	(GUI.nextNPTab): Choose an appropriate name for the new queue if
	possible.
	(GUI.setNPButtons): Adjust which pages get forward/back buttons.

	* ppds.py (PPDs.getPPDNameFromDeviceID): Unbreak HPLIP made-up
	Device IDs.

	* system-config-printer.py (GUI.on_tvNPDevices_cursor_changed):
	Update wizard buttons in device selection screen, to allow for
	validation.
	(GUI.setNPButtons): Validate device URI.
	(validDeviceURI): New function for validating device URIs.
	(GUI.fillDeviceTab): Fix display of current URI.

2007-08-14  Till Kamppeter  <till.kamppeter@gmail.com>

	* ppds.py: Strip version numbers from model name (ex: "ML-1610,
	1.0")

2007-08-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnNPApply_clicked): Select
	newly-created printer.

	* system-config-printer.glade: Connect dialog user name field
	activates default.

	* system-config-printer.py (GUI.on_btnNPApply_clicked): Set cursor
	busy while adding queue.
	(GUI.cupsPasswdCallback): Wait for main loop to hide dialog before
	returning from callback.

	* cupshelpers.py (activateNewPrinter): New function.
	* system-config-printer.py (GUI.on_btnNPApply_clicked): Use it.

	* system-config-printer.py (GUI.getPPDs_thread): Store IPP error
	for collection by main thread.
	(GUI.fetchPPDs): Propagate exception.
	(GUI.nextNPTab): Handle IPP error while fetching PPDs.
	(GUI.fillDeviceTab): More error handling for failure to fetch
	device list.

2007-08-09  Tim Waugh  <twaugh@redhat.com>

	* optionwidgets.py (OptionWidget): Treat incorrect Boolean options
	as PickOne (bug #241809).

2007-08-08  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.72.

2007-08-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.getNetworkPrinterMakeModel):
	Prevent traceback (sys.environ -> os.environ).
	(GUI.on_tvMainList_cursor_changed): Allow copying of remote
	queues.
	(GUI.connect): If connection via the UNIX domain socket fails,
	fall back to local loopback.

2007-08-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_new_printer_activate): Remember
	that PPDs and devices have not yet been loaded.
	(GUI.nextNPTab): Only load PPDs and devices if not already
	loaded.
	(GUI.getNetworkPrinterMakeModel): Protect hostname from shell
	expansion.
	(GUI.on_tvMainList_cursor_changed): Only allow Delete/Copy for
	locally-defined printers (bug #250384).

	* probe_printer.py (LpdServer.probe): Try leaving queue name blank
	when probing.  This should work for e.g. HP LaserJet 3390.

	* system-config-printer.py: Integrated add-printer wizard patch
	from Till Kamppeter:

	o If an auto-detected device (USB, network) is supported by HPLIP
	  only the HPLIP URIs are shown, to assure that the user gets it
	  correctly set up to get access to the complete functionality
	o For auto-detected network MF devices from HP also an entry
	  for setting up the fax queue is shown
	o Make and model info of auto-detected network printers is used to
	  direct the user to the correct PPD/driver
	o For manually entered printers make and model are determined via
	  SNMP. It is also checked whether the printer is supported by
	  HPLIP
	o No "HP Fax" entry any more when no Fax-capable HP printer is
	  connected.
	o When selecting an auto-detected non-HPLIP network printer the
	  fields of the form on the right are correctly prefilled now.
	o Improved sorting of the device list entries.

	Very important changes for that are:

	o Improved filtering of the detected devices when building the
	  device list for the second page of the wizard
	o Moved assignment of the PPD to the device from the stage of
	  initializing the forms on the right on the second page of
	  the wizard to the stage of clicking "Forward" for getting from
	  the second to the third page (after the user has manually entered
	  an IP address for a network printer)
	o Used "/usr/lib/cups/backend/snmp <host name or IP>" to obtain
	  make and model for a manually entered network printer
	o Used "hp-makeuri" to determine whether a network printer is
	  supported by HPLIP.

2007-08-04  Tim Waugh  <twaugh@redhat.com>

	* my-default-printer.py (Dialog.response): The method name is
	iter_next, not get_iter_next (patch from Till Kamppeter).

2007-08-03  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.71.

2007-08-03  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_tvNPDevices_cursor_changed):
	Handle socket: URIs (Ubuntu #127074).

	* system-config-printer.glade: Moved default printer label below
	make-default button because some translation strings are very
	long (Ubuntu #128263).

	* my-default-printer.py (error_out): New function.
	(Dialog.response): Catch exceptions and error out (Ubuntu
	#129901).
	(*top-level*): Likewise.

	* ppds.py (PPDs.getPPDNameFromDeviceID): Initialise the make/model
	list when an ID match failed (patch from Till Kamppeter).
	(PPDs.getPPDNameFromDeviceID): Fixed fallback if no text-only
	driver is available (patch from Till Kamppeter).
	(PPDs.getPPDNameFromDeviceID): Don't discard make/model-matched
	devices when there are ID-matched devices found (patch from Till
	Kamppeter).

2007-07-09  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.70.

2007-07-09  Tim Waugh  <twaugh@redhat.com>

	* inspecting-printer.png: Added.

	* print-applet.desktop.in: Fixes for KDE (bug #247299).

2007-07-06  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.checkDriverExists): Only show
	install dialog is system-install-packages is available.

	* ppds.py (PPDs.__init__): Don't list PPDs removed due to language
	mismatch or else we end up with far too much output.

2007-07-04  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.checkDriverExists): Run
	system-install-packages to install missing drivers (bug #246726).

	* system-config-printer.py (GUI.checkDriverExists): More binary
	names mapped to package names.

	* applet.py (NewPrinterNotification.GetReady): Increased
	GetReady->NewPrinter timeout.

2007-06-28  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.69.

2007-06-28  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (PPDs.__init__): Filter PPDs by natural language (bug
	#244173).

	* system-config-printer.py (GUI.loadPPDs): Give PPDs constructor
	the natural language we expect.

	* foomatic.py: Removed.
	* nametree.py: Removed.
	* system-config-printer.py: Removed commented-out code that used
	nametree.
	* gtk_html2pango.py: Removed.

2007-06-25  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Use HardwareSettings category for the
	my-default-printer app (bug #244935).

2007-06-15  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.68.

2007-06-15  Tim Waugh  <twaugh@redhat.com>

	* my-default-printer.py: New file.
	* my-default-printer.desktop.in: New file.
	* my-default-printer: New file.
	* po/POTFILES.in: Translate it.
	* Makefile.am: Ship it and install it.

2007-06-15  Tim Waugh  <twaugh@redhat.com>

	* applet.py (NewPrinterNotification.NewPrinter): Keep the
	notification object around so it knows which action callback to
	call (bug #241531).

2007-06-08  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Don't use the TrayIcon category in the applet desktop
	file since that is reserved now.  Use HardwareSettings and Printing
	categories for the admin tool's desktop file.

2007-06-08  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.67.

2007-06-08  Tim Waugh  <twaugh@redhat.com>

	* ppds.py (PPDs.orderPPDNamesByPreference): Prefer HPIJS for HP
	devices.
	(getDriverType): New function.

	* system-config-printer.py (GUI.on_tvNPDevices_cursor_changed):
	Use PPDs class for ID matching.
	(GUI.fillMakeList): Use PPDs class.
	(GUI.fillModelList): Likewise.
	(GUI.on_tvNPModels_cursor_changed): Likewise.
	(GUI.on_tvNPDrivers_cursor_changed): Likewise.
	(GUI.getNPPPD): Likewise.
	(GUI.loadPPDs): New method, replacing loadFoomatic().
	(GUI.dropPPDs): New method, replacing unloadFoomatic().
	(GUI.on_btnChangePPD_clicked): Load PPDs on demand.
	(GUI.on_btnChangePPD_clicked): Don't drop PPDs each time.
	(GUI.on_tvNPModels_cursor_changed): Order PPD names by preference.
	(GUI.getPPDs_thread): Fetch PPDs from the correct server.
	(GUI.getDevices_thread): Fetch devices from the correct server.

	* ppds.py (PPDs.getPPDNameFromDeviceID): Display message to stdout
	when the ID was not matched.

	* applet.py (NewPrinterNotification.NewPrinter): Use
	ppdMakeModelSplit from the new ppds module, not the old foomatic
	module.

	* Makefile.am: Ship ppds.py as a script.  Running it on its own
	gives statistics on the installed PPDs, and runs some ID tests.

	* foomatic.py (Foomatic.getPrinterFromCupsDevice): Don't split the
	CMD field: it is already split.
	* cupshelpers.py (parseDeviceID): Always split the CMD field.

	* manage-print-jobs.desktop.in (_Name): Use capital letters at the
	start of each word for the Name field (bug #242859).

2007-06-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.save_printer): Don't call
	populateList() after saving printer, just update the printer we
	changed.  This prevents a GTK+ crash (bug #242961).
	(GUI.maySelectItem): Only clear the changed set when the cursor is
	going to change.
	(GUI.on_tvMainList_cursor_changed): Don't update when unapplied
	changes remain.

2007-06-06  Tim Waugh  <twaugh@redhat.com>

	* print-applet.desktop.in: Fixed Name field to start each word with
	a capital letter (bug #242859).

2007-05-30  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.66.

2007-05-30  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (_ppdMakeModelSplit): Don't require ppdname when
	stripping foomatic driver information.

	* applet.py (NewPrinterNotification): Use the system bus not the
	session bus.

	* newprinternotification.conf: D-Bus configuration file.
	* Makefile.am: Ship it.

2007-05-28  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (nobase_pkgdata_DATA): Ship 'inspecting' icon.

	* applet.py (NewPrinterNotification): Implemented.

2007-05-25  Tim Waugh  <twaugh@redhat.com>

	* man/system-config-printer.xml: Document new options.

	* system-config-printer.py (GUI.populateList): Now
	--configure-printer=x automatically selects that printer on
	start-up, and --choose-driver=x invokes the "Change PPD" dialog
	as well.  Needed for "new printer" notifications in the applet.

2007-05-23  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.set_special_statusicon): New method.
	(JobManager.unset_special_statusicon): New method.
	(JobManager.set_statusicon_from_pixbuf): New method.
	(JobManager.refresh): Use it.

	* system-config-printer.py (GUI.__init__): Added 'Hold until:'
	control to Job Options screen (bug #239776).
	* cupshelpers.py (Printer._getAttributes): Allow job-hold-until to
	be set (bug #239776).

2007-05-22  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.65.

2007-05-21  Tim Waugh  <twaugh@redhat.com>

	* man/system-config-printer.xml: New file.
	* Makefile.am: Ship it.  Create man files and install them.

	* Makefile.am: Not all of the Python modules are scripts.  Mark
	the ones that are and aren't so that the executable permissions
	are set correctly on install.

2007-05-16  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnSelectDevice_clicked): Start
	fetching the device list in a separate thread.
	(GUI.loadFoomatic): Start fetching the PPD list while we parse the
	XML database.
	(GUI.on_new_printer_activate): Start fetching PPD and device lists
	while the user picks a name for the printer.

	* applet.py (JobManager.refresh): Limit refresh frequency.
	Sometimes several D-Bus events will occur in quick succession, and
	we do not want a full refresh every single time.

2007-05-15  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am (DISTCLEANFILES): Don't removed intltool .in files
	on distclean.

2007-05-09  Tim Waugh  <twaugh@redhat.com>

	* configure.in (ALL_LINGUAS): Added kn.

2007-04-29  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.__init__): Prevent traceback.

2007-04-26  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.update_job_creation_times): Split out
	creation time text into separate function, and update it every
	minute when there are jobs.

2007-04-25  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.refresh): Fix relative time description.

2007-04-13  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.update_connecting_devices): New method.
	Be a bit smarter about connecting-to-device, to make sure it
	really has been in that state for as long as we think.

2007-04-11  Tim Waugh  <twaugh@redhat.com>

	* applet.py (StateReason.get_description): Fixed typo.
	(JobManager.check_still_connecting): New method.
	(JobManager.check_state_reasons): Add a timed callback to check
	for connecting-to-device after a minute's time.
	(StateReason.get_description): Messages for connecting-to-device.

2007-04-10  Tim Waugh  <twaugh@redhat.com>

	* applet.py: Don't connect to the session bus if we don't need to,
	and exit if connecting to D-Bus fails for any reason (Ubuntu #102992).
	(JobManager.check_state_reasons): Put warning/error symbol at the
	bottom right of the icon instead of the top right.

	* system-config-printer.py (GUI.parse_SMBURI): Use urllib for
	quoting/unquoting (Val Henson, Ubuntu #105022).
	(GUI.construct_SMBURI): Likewise.
	(percentEncode, percentDecode): Removed.

2007-04-06  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.check_state_reasons): Clear the status bar
	when there is no warning/error to report.
	(JobManager.refresh): Check status reasons when running without a
	tray icon.
	(JobManager.check_state_reasons): Only check for notifications to
	close if we are running with a tray icon.

2007-04-05  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.64.

2007-04-05  Tim Waugh  <twaugh@redhat.com>

	* applet.py (StateReason): New class.
	(JobManager.__init__): Set up printer state treeview.
	(JobManager.on_printer_status_delete_event): New method.
	(JobManager.on_show_printer_status_activate): New method.
	(JobManager.check_state_reasons): Update printer state display
	window.
	(JobManager.check_state_reasons): Send notifications for printer
	errors on our jobs.
	(JobManager.check_state_reasons): Set statusbar.

	* applet.glade: Added windows for printer state display.

	* applet.py (JobManager.__init__): Set rules hint for the
	treeview.

2007-04-04  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.check_state_reasons): New method.
	(worst_printer_state_reason): Helper function.
	(collect_printer_state_reasons): Helper function.

2007-04-05  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.63.

2007-04-05  Tim Waugh  <twaugh@redhat.com>

	* po: Updated translations pulled in.
	* manage-print-jobs.desktop.in: This file had not been checked in.

2007-04-02  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.62.

2007-04-02  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_tvSMBBrowser_cursor_changed):
	Prevent a traceback (bug #225351).  Patch from Jani Monoses.

	* manage-print-jobs.desktop.in: New file.
	* po/POTFILES.in: Translate it.
	* Makefile.am: Ship it.

	* applet.py (monitor_session): Stop running when the session
	ends.

2007-03-30  Tim Waugh  <twaugh@redhat.com>

	* applet.py, cupsd.py, cupshelpers.py, foomatic.py,
	  system-config-printer.py: Use /usr/bin/env instead of /bin/env.

	* system-config-printer.desktop.in: Use printer.png as the icon.

2007-03-30  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.61.

2007-03-30  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (PrintersConf): Reinstated (bug #203539).
	(getPrinters): Fetch and parse printers.conf if needed for SMB
	authentication details (bug #203539).

	* applet.py: Added support for --help, --version and
	--no-tray-icon.
	(show_help): Implemented.
	(show_version): Likewise.

2007-03-27  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.60.

2007-03-27  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.refresh): Use job state constants (requires
	pycups 1.9.19).
	(JobManager.on_treeview_button_press_event): Likewise.

	* applet.py: No need to check for --sm-client-id now that the
	applet has a different name.

	* Makefile.am: Better desktop-file categories.

	* print-applet.desktop.in: Remove 'eggcups' name from the
	applet.
	* Makefile.am: Install the autostart file in the correct
	location, and install the applet.
	* system-config-printer-applet: New file.

	* system-config-printer.py (GUI.reconnect): Handle reconnection
	failure (Ubuntu #95629).

2007-03-26  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.59.

2007-03-26  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.58.

2007-03-26  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.on_icon_hide_activate): Hide icon when
	requested (bug #233899).  If the service is not running, quit.

	* applet.glade: Icon pop-up menu.
	
	* applet.glade: Removed status bar (bug #233899).

	* applet.py (JobManager.__init__): Ellipsize the document name
	(bug #233899).
	(PrintDriverSelection.PromptPrintDriver): Handle failure to start
	the service.
	(JobManager.__init__): Set a window icon (bug #233899).

2007-03-23  Tim Waugh  <twaugh@redhat.com>

	* applet.py (JobManager.refresh): Fixed '1 document queued'
	string.

2007-03-21  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.57.

2007-03-21  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Ship the applet icon.

	* applet.py: Put the PrintDriverSelection service on the system
	bus not the session bus.
	Exit immediately if --sm-client-id is seen (bug #233261).

	* print-applet.desktop.in: New file.
	* po/POTFILES.in: Translate it.
	* Makefile.am: Merge translations and ship it.

	* applet.py, applet.glade: New files.
	* po/POTFILES.in: Translate them.

2007-03-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnPMakeDefault_clicked):
	Prevent traceback when removing temporary file (Ubuntu #92914).

2007-03-16  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.56.

2007-03-16  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Printer._getAttributes): Removed always-shown
	options from the possible_attributes list.

	* cupshelpers.py (Printer._getAttributes): Handle 'sides'.
	* system-config-printer.py (GUI.__init__): Likewise.

	* options.py (OptionAlwaysShown.set_default): New method.
	(OptionAlwaysShown.__init__): Use it.
	* system-config-printer.py (GUI.fillPrinterTab): Likewise.

	* options.py (OptionAlwaysShown.set_widget_value): Handle str-type
	IPP enums.
	(OptionAlwaysShown.get_widget_value): Likewise.

2007-03-13  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Printer._getAttributes): Handle 'media'.
	* system-config-printer.py (GUI.fillPrinterTab): Pass supported
	values through to the option widget, if supplied.
	* options.py (OptionAlwaysShown.reinit): Fit the supported list,
	if supplied, to	the combobox.

	* cupshelpers.py (Printer._getAttributes): Handle 'job-priority'.
	* system-config-printer.py (GUI.__init__): Likewise.

	* cupshelpers.py (Printer._getAttributes): Handle 'finishings'.
	* system-config-printer.py (GUI.__init__): Likewise.

	* cupshelpers.py (PrintersConf): Removed (bug #231826).
	(Printer._getAttributes): Removed set_attributes parameter.
	(Printer.__init__): Likewise.
	(Printer._getAttributes): For the time being ignore finishings,
	job-priority, media, document-format, job-hold-until, sides and
	notify-lease-duration defaults.

2007-03-12  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.checkDriverExists): Updated
	filter-to-driver map.

2007-03-12  Tim Waugh  <twaugh@redhat.com>

	* probe_printer.py (LpdServer._open_socket): Handle hostname
	look-up failures (Ubuntu #87115).

2007-03-02  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Foomatic.getPrinterFromCupsDevice): Make
	commandsets into a list instead of a string (seen in bug
	#230665).

2007-02-27  Tim Waugh  <twaugh@redhat.com>

	* options.py (OptionAlwaysShown.bool_type): Parse Boolean strings
	correctly.

2007-02-27  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.55.

2007-02-27  Tim Waugh  <twaugh@redhat.com>

	* options.py (OptionAlwaysShown.reinit): Use converted value.

2007-02-27  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.54.

2007-02-27  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Disable debugging code (oops).

2007-02-27  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.53.

2007-02-26  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Added 'scaling'
	option.
	(GUI.__init__): Added 'saturation', 'hue' and 'gamma' options.
	(GUI.__init__): Added 'cpi', 'lpi', 'page-left', 'page-right',
	'page-top', 'page-bottom', 'prettyprint', 'wrap' and 'columns'
	options.
	(GUI.fillPrinterOptions): 6 pixels row spacings for PPD options.
	(GUI.draw_other_job_options): No job options are editable for
	remote queues (although might not be a bad idea for implementing
	lpoptions edits..).

2007-02-23  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Added 'mirror' option.

	* system-config-printer.glade: "Other" job options.
	* system-config-printer.py (GUI.draw_other_job_options): New
	function to redraw the other job options table.
	(GUI.add_job_option): Implemented for new UI.
	(GUI.on_btnJOOtherRemove_clicked): Likewise.
	(GUI.on_btnNewJobOption_clicked): Likewise.
	(GUI.on_entNewJobOption_changed): Likewise.
	(GUI.on_entNewJobOption_activate): Pressing Return in the new
	option text entry widget adds the option.
	(GUI.fillPrinterTab): Added support for "Other" job options.

	* options.py (OptionAlwaysShown.set_widget_value): Make
	combobox_map optional.
	(OptionAlwaysShown.get_current_value): Likewise.
	(OptionAlwaysShown.set_widget_value): Handle CheckButtons.
	(OptionAlwaysShown.get_widget_value): Likewise.
	(OptionAlwaysShown.is_changed): Explicitly check original_value
	against None to protect against false bools.

2007-02-22  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_job_option_reset): New
	function.
	(GUI.on_job_option_changed): New function.

	* options.py (OptionInterface): Interface class for Option.
	(Option): Inherit OptionInterface.
	(OptionAlwaysShown): New class for always-shown job options
	widgets.

2007-02-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillPrinterTab): Make the text
	entry boxes sensitive but not editable for remote printers (bug
	#229381).

	* cupshelpers.py (Printer.testsQueued): Handle failure gracefully
	(bug #229406).

	* system-config-printer.py (GUI.fillPrinterTab): Display an error
	dialog if we get a RuntimeError trying to get the PPD, instead of
	just a traceback (bug #229406).

	* cupshelpers.py (Printer.getPPD): Only IPP_NOT_FOUND means the
	queue is raw; anything else needs to be handled as an error (bug
	#229406).

	* system-config-printer.py (GUI.maySelectItem): Handle applying
	changes here rather than...
	(GUI.on_tvMainList_cursor_changed): ...here, after the new item
	has been selected (bug #229378).

	* system-config-printer.glade: Added scrollbars to main printer
	list (bug #229453).
	Set maximum width of default printer label (bug #229453).

2007-02-20  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillPrinterOptions): Better
	layout.

2007-02-14  Tim Waugh  <twaugh@redhat.com>

	* optionwidgets.py: Use gettext instead of rhpl.translate.
	* system-config-printer.py (domain): Likewise.

2007-02-13  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.52.

2007-02-13  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Foomatic.getPrinterFromDeviceID): Sort models using
	cups.modelSort before scanning for a close match (bug #228505).
	(Foomatic.getPrinterFromDeviceID): Fixed matching logic (bug #228505).

2007-02-09  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.51.

2007-02-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_tvNPMakes_cursor_changed):
	Handle interactive search a little better (bug #227935).
	(GUI.on_tvNPModels_cursor_changed): Likewise.

	* system-config-printer.py (GUI.on_btnPMakeDefault_clicked): Fixed
	typo (bug #227936).

2007-02-08  Tim Waugh  <twaugh@redhat.com>

	* optionwidgets.py (OptionWidget): Remember the tab label.
	* system-config-printer.py (GUI.setDataButtonState): Embolden the
	tab containing options in conflict (bug #226368).

	* system-config-printer.py (GUI.fillPrinterTab): Prevent display
	glitch in job options list when clicking on printer repeatedly.
	(GUI.on_btnConflict_clicked): List conflicting options (bug
	#226368).

2007-02-07  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.50.

2007-02-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillPrinterTab): Handle unknown
	job options (bug #225538).
	(GUI.on_btnPMakeDefault_clicked): Don't throw exception if
	getFile() already removed the temporary file (bug #226703).
	(GUI.get_PPD_but_handle_errors): Get the arguments the right way
	round.
	(GUI.get_PPD_but_handle_errors): Likewise.
	(GUI.fillPrinterTab): Point to the server settings if a printer is
	shared but the server is not publishing shared printers (bug
	#225081).
	(GUI.setConnected): Clear out remembered server settings when
	connecting to a new server.

	* cupshelpers.py (Printer._getAttributes): cpi, lpi and scaling
	are floats (bug #224651).

	* options.py (OptionWidget): Handle floating point options.
	(OptionNumeric.get_current_value): Allow floating point values
	(bug #224651).

	* system-config-printer.py (GUI.checkDriverExists): If there are
	unreplaced HTML entities, give up checking (bug #225104).
	(GUI.save_printer): Don't write an ellipsis in the actual device
	URI we set (bug #227643).

	* configure.in (ALL_LINGUAS): Added bs.

2007-01-24  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (percentDecode): Fix hex digits list so
	we get A-F right (bug #223770).

2007-01-16  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.49.

2007-01-16  Tim Waugh  <twaugh@redhat.com>

	* optionwidgets.py (Option.__init__): Maintain 'enabled' state.
	(Option.enable): Method for enabling.
	(Option.disable): Method for disabling.
	(Option.is_enabled): Method for discovering whether enabled.
	(Option.writeback): Only mark PPD option if enabled.

	* system-config-printer.py (GUI.fillPrinterOptions): Take
	references to InputSlot and ManualFeed widgets.
	(GUI.option_changed): Enable/disable InputSlot option based on
	ManualFeed state (bug #222490).

2007-01-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (on_btnConflict_clicked): Fixed typo in
	string.

	* system-config-printer.py (GUI.checkDriverExists): Fixed another
	traceback.

2007-01-15  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.48 (only translations updated).

2007-01-12  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.47.

2007-01-12  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.get_PPD_but_handle_errors): Fixed
	typo.
	(GUI.checkDriverExists): Handle multiple commands better.
	(GUI.pathcheck): Handle shell builtins (bug #222413).

2007-01-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Updated copyright
	notice.
	(GUI.__init__): Fixed incorrect nouns-with-capitals in
	translatable text.
	(GUI.on_connect_activate): Likewise.
	(GUI.on_btnPrintTestPage_clicked): US spelling for 'cancelling'.
	(GUI.on_delete_activate): Fixed incorrect nouns-with-capitals in
	translatable text.

2007-01-08  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.46.

2007-01-08  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Printer.getPPDDrivers): Removed some dead code.

	* cupshelpers.py (setPPDPageSize): New function.
	* system-config-printer.py (GUI.on_btnNPApply_clicked): Use it
	for user-provided PPD.
	(GUI.on_btnNPApply_clicked): Use it for new printers (bug
	#221702).

	* configure.in (ALL_LINGUAS): Added ro.

2007-01-03  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.45.

2007-01-03  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.checkDriverExists): Fixed
	traceback.

2007-01-02  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.44.

2007-01-02  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Foomatic.getPrinterFromDeviceID): Preserve case in
	model string when dumping debug output.

2006-12-28  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.get_PPD_but_handle_errors): Fixed
	traceback in error display.

2006-12-21  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.43.

2006-12-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.checkDriverExists): Stop checking
	for binaries if we already discovered one missing (bug #220347).
	(GUI.on_btnNPApply_clicked.get_PPD_but_handle_errors): Distinguish
	between PPD and Foomatic errors, and for PPD errors show the
	output of the cupstestppd command to help pinpoint the
	problem (bug #220136).

2006-12-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnApply_clicked): Use
	nonfatalException() if exception caught.

2006-12-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (nonfatalException): New function.
	(GUI.on_tvNPDevices_cursor_changed): Use it when trying to
	auto-match printer model.

	* foomatic.py (Foomatic.getPrinterFromDeviceID): New function.
	(Foomatic.getPrinterFromCupsDevice): Use it.
	(Foomatic.getPPD): Likewise (bug #219518).

2006-12-12  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Foomatic.getPrinterFromCupsDevice): Don't check
	against DES field at all; if the make and model strings don't
	match, the description field isn't helpful.  Example: '6543' which
	is the same between two unrelated devices.

	* Makefile.am: New target missing-languages.

2006-12-11  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.42.

2006-12-11  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Foomatic.getPrinterFromCommandSet): Fixed typo.
	(Foomatic.getPrinterFromCupsDevice): Case-insensitive matching
	when Device ID not known to database.

	* configure.in (ALL_LINGUAS): Added mr.

2006-12-07  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.41.

2006-12-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_about_activate): hpfax backend
	should set empty/description tab.
	(GUI.on_tvNPDevices_cursor_changed): Set description label to
	reflect backend type.

	* system-config-printer.glade: Added label to describe devices
	with no optional parameters.

2006-11-30  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Printer.setEnabled): Optional 'reason'
	argument.
	(Printer.setAccepting): Likewise.

	* system-config-printer.glade: Centre Connecting dialog on
	parent.
	* system-config-printer.py (GUI.on_connect_activate): Set
	Connecting dialog transient for main window.
	(GUI.reconnect): Provoke libcups into reconnecting.
	(GUI.populateList): Keep Server Settings selected if it was before.

2006-11-28  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.setNPButtons): Set Forward button
	sensitive on Device screen in new-printer dialog (bug #217515).
	(GUI.on_tvNPDevices_cursor_changed): Don't pre-select make and
	model when not discoverable for chosen device (bug #217518).
	(GUI.show_HTTP_Error): Fixed typo (bug #217537).
	(GUI.on_btnPMakeDefault_clicked): If the system-wide lpoptions
	file sets a default printer that conflicts with the new server
	default, alter lpoptions so that it no longer overrides
	it (bug	#217395).
	(GUI.show_HTTP_Error): Describe cups.HTTPError -1 as 'not
	connected'.
	(GUI.reconnect): Implemented.
	(GUI.apply): Reconnect after applying server settings.

2006-11-27  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.40.

2006-11-24  Tim Waugh  <twaugh@redhat.com>

	* configure.in (ALL_LINGUAS): Added lv and si.

2006-11-23  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Don't set button widths in
	new-printer dialog (bug #217025).

2006-11-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Removed username:password from
	hint string because we add that in afterwards.

2006-11-21  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.39.

2006-11-21  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Added SMB hint label on device
	screen (bug #212759).

2006-11-15  Tim Waugh  <twaugh@redhat.com>

	* configure.in (ALL_LINGUAS): Updated.

2006-11-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Make PPD NickName selectable.

	* system-config-printer.py (GUI.on_btnChangePPD_clicked): Busy
	cursor while loading foomatic and PPD list (bug #215527).
	(GUI.on_btnSelectDevice_clicked): Busy cursor while loading
	foomatic and device list (bug #215527).

2006-11-14  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.38.

2006-11-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.pathcheck): Fixed indentation so
	that IJS servers are checked to be in the path.

	* foomatic.py (Foomatic.addCupsPPDs): Fixed traceback in
	'ppd-device-id' parsing code.

2006-11-13  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.37.

2006-11-11  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnPrintTestPage_clicked): IPP
	Error dialog for any cancelling errors.

2006-11-10  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.setTestButton): New function for
	allowing user to cancel test jobs if there are some.
	(GUI.fillPrinterTab): Use it.
	(GUI.on_btnPrintTestPage_clicked): Cancel jobs if cancelling (bug
	#215054).

	* cupshelpers.py (Printer.testsQueued): New method for finding out
	if test pages are queued.
	(Printer.cancelJobs): New method for cancelling jobs.

2006-11-10  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.36.

2006-11-10  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Foomatic.addCupsPPDs): No need to remove foomatic
	PPDs now; this is handled in foomatic.

2006-11-09  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (parseDeviceID): New function.
	(Device.__init__): Use it.
	* foomatic.py (Foomatic._add_printer): Likewise.
	(Foomatic.addCupsPPDs): Parse IEEE 1284 Device IDs from CUPS PPDs
	and add them to the make/model look-up dictionary.
	(Foomatic._add_printer): Don't add empty fields to the look-up
	dictionary.
	(Foomatic.getPrinterFromCupsDevice): Fixed typo.
	(Foomatic.getPrinterFromCommandSet): New function.
	(Foomatic.getPPD): Use it.
	(Foomatic.getPrinterFromCupsDevice): Match against command sets.

	* foomatic.py (Foomatic.getPPD): Convert command sets to lower
	case for comparison.
	(Foomatic.getPPD): Match PCL6, PCL5e, PCL5c, ESCPL2 command sets.

	* foomatic.py (Foomatic._add_printer): Parse
	'autodetect/*/ieee1284' entries (bug #214761).

2006-11-08 Florian Festi  <ffesti@redhat.com>

	* foomatic.py (Foomatic.getPPD): now matches against 
	commandset (bug #214181), removed debug code and
	code commented out

	* cupshelpers.py: removed code commented out

2006-11-07  Tim Waugh  <twaugh@redhat.com>

	* configure.in: 0.7.35.

2006-11-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillModelList): Reset scroll.
	(GUI.fillMakeList): Likewise.
	(GUI.fillDriverList): Scroll to pre-selected driver.

	* foomatic.py (Foomatic.getPrinterFromCupsDevice): Handle bogus
	HPLIP Device IDs (bug #214434).

	* system-config-printer.py (GUI.pathcheck): Support absolute paths
	in foomatic command line.
	(GUI.pathcheck): Fixed typo.
	(GUI.on_tvNPDrivers_cursor_changed): Better PPD information
	display (bug #214365).

	* foomatic.py (_ppdMakeModelSplit): Merge CUPS and foomatic
	manufacturers when they differ in case.

	* system-config-printer.py (GUI.on_btnNPApply_clicked): Handle
	missing driver XML for drivers like Gutenprint.

	* system-config-printer.py (GUI.checkDriverExists): Check for
	'*cupsFilter' lines and verify filters are installed (bug
	#212139).

	* foomatic.py (_ppdMakeModelSplit):  Better display for models
	driven by Gimp-Print PPDs (bug #213862).

2006-11-06  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.34.

2006-11-06  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Foomatic.getPPD): Only match against description
	when it is valid (bug #206907).

	* cupshelpers.py (PrintersConf.parse): Handle invalid printers.conf
	file gracefully (bug #214134).

2006-11-04  Tim Waugh  <twaugh@redhat.com>

	* optionwidgets.py (OptionBool.__init__): Handle Boolean values
	with "On" and "Off" as choices (bug #213136).

	* system-config-printer.py (GUI.on_btnNPApply_clicked): Handle
	database errors gracefully (bug #213992).
	(GUI.on_btnNPApply_clicked): Only translate the strings once.

2006-11-03  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (_ppdMakeModelSplit): "EPSON" -> "Epson".

	* system-config-printer.py (GUI.checkDriverExists): Include
	gutenprint driver check.

	* foomatic.py (_ppdMakeModelSplit): Better display for models
	driven by Gutenprint PPDs (bug #213862).

2006-11-02  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.33.

2006-11-02  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.save_printer): Refresh after
	applying changes (bug #213692).

	* system-config-printer.py (GUI.on_btnNPApply_clicked): Set
	PageSize when uploading a new PPD as-is (bug #213680).

	* cupshelpers.py (copyPPDOptions): Skip 'PageRegion' since that's
	special (bug #213680).

	* system-config-printer.py (GUI.on_btnNPApply_clicked): Fix using
	the new PPD as-is (bug #203905).

	* system-config-printer.py (GUI.fillDeviceTab): Sort 'Other' last
	in the devices list (bug #213676).

	* system-config-printer.py (GUI.on_btnChangePPD_clicked): Fix
	auto-selection of current PPD when changing it (bug #213667).

	* optionwidgets.py (OptionPickOne.__init__): Handle enum values
	already set outside the range (bug #213136).

2006-11-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.checkDriverExists): New function
	to check that the driver exists.
	(GUI.on_btnNPApply_clicked): Use it (bug #212139).

2006-10-31  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Find '.PPD' files as
	well as '.ppd' files (bug #213223).

2006-10-25  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Printer.getPPD): Clean up temporary file.

2006-10-05  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Fix invisible_char in glade
	file (bug #209368).

2006-10-02  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.32.

2006-10-02  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.show_HTTP_Error): New function.
	(GUI.connect): Use it to handle HTTPError (bug #208824).
	(GUI.setConnected): Set 'server settings' widgets insensitive when
	not connected.
	(GUI.on_tvMainList_cursor_changed): Only set widget status when
	connected.
	(GUI.__init__): Handle error on initial connection (bug #208824).

2006-09-29  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.31.

2006-09-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Fixed automatic selection of recommended
	driver (bug #208606).

	* system-config-printer.glade: Better visibility for printer
	drivers (bug #203907).

2006-09-29  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.30.

2006-09-29  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Add a distcheck-hook for update-po.

	* system-config-printer.glade: Don't set width_request on buttons
	that don't need it (bug #208556).

2006-09-29  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.29.

2006-09-29  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (getPrinterFromCupsDevice): Fixed debug message.

	* system-config-printer.py (GUI.__init__): Set glade translation
	domain (bug #206622).

	* po/fr.po: Fixed vertext ('%' -> '%s').

2006-09-26  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.28.

2006-09-26  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Set CATOBJECT to fix bug #206622.

2006-08-30  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.27.

2006-08-30  Tim Waugh  <twaugh@redhat.com>

	Applied patch from Kjartan Maraas:
	* Makefile.am: Use intltool to translate desktop file.
	* bootstrap: Run intltoolize.
	* configure.in: Added intltool hook.
	* system-config-printer.desktop.in: New file.
	* po/POTFILES.in: Translate desktop file.

2006-08-24  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py: Removed special raw printer handling in favour of
	CUPS-provided 'Raw Queue' pseudo-PPD.

	* system-config-printer.py (GUI.on_btnChangePPD_clicked): Prevent
	traceback on raw queue.
	(GUI.on_btnNPApply_clicked): Cope with changing from a PPD-driven
	queue to a raw queue.

2006-08-23  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.26.

2006-08-23  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillPrinterTab): Use ellipsis to
	show authentication details are hidden.
	(percentDecode): New function.

2006-08-18  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (percentEncode): New function.
	(GUI.getDeviceURI): Use it (bug #203066).
	(GUI.fillNPApply): When authentication details are hidden in SMB
	URI, show this with an ellipsis.

2006-08-14 Florian Festi  <ffesti@redhat.com>

	* configure.in: Version 0.7.25.
	* cupshelpers.py (Printer.getPPD): fix for raw queues
	* system-config-printer.py (GUI.fillPrinterOptions): don't show 
	  option tabs for raw queues
	* system-config-printer.py (GUI.on_btnNPApply_clicked): fix for 
	  raw queues
2006-08-03  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.24.

2006-08-03  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.getDeviceURI): Fixed IPP URI
	generation.
	(GUI.on_tvNPDevices_cursor_changed): Parse IPP URIs correctly.

2006-07-28  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Device.__init__): Fixed traceback when handling
	non-conforming Device IDs.

2006-07-24  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.23.

2006-07-24  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.initNewPrinterWindow): Set JetDirect
	port number to 9100 by default (bug #197866).

2006-07-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.save_serversettings): Reconnect
	after adjusting server settings.

2006-07-07  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.22.

2006-07-07  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_tvNPDrivers_cursor_changed):
	Fix PPD description for PPDs from the CUPS foomatic driver.

	* foomatic.py (_ppdMakeModelSplit): Handle PPDs from the CUPS
	foomatic driver.

	* cupshelpers.py (PrintersConf.fetch): Handle classes.conf or
	printers.conf being asent.

2006-07-06 Florian Festi  <ffesti@redhat.com>

	* system-config-printer.py (GUI.fillPrinterOptions): Keep 
	"Installable Options" tab focused when Apply button is pressed.
	* system-config-printer.glade: hide "Installable Options" tab to 
	haveit redrawn on the first showall()
	* system-config-printer.py (GUI.on_btnNewOption_clicked, 
	GUI.removeOption_clicked, GUI.on_cmbentNewOption_changed): Don't offer
	options as new that are already set.
	
2006-07-05  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.21.

2006-07-05  Tim Waugh  <twaugh@redhat.com>

	* options.py (OptionSelectOne.__init__): Handle Booleans.
	(Option.is_changed): Compare strings not values.

	* cupshelpers.py (Printer._getAttributes): Fix case in Boolean
	options.

2006-07-05 Florian Festi  <ffesti@redhat.com>

	* cupshelpers.py (Printer._getAttributes, GUI.fillPrinterTab):
	fixed handling of server side settings
	
2006-07-04  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Printer.getPPD): Fix foomatic-provided PPD
	loading.

2006-07-03  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.20.

2006-07-03 Florian Festi  <ffesti@redhat.com>

	* system-config-printer.glade: Spacing (HIG)

2006-07-03 Florian Festi  <ffesti@redhat.com>

	* system-config-printer.py (GUI.populateList): Hide empty entries in
	the main list
		
2006-07-03  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (_ppdMakeModelSplit): Fixed indentation.
	(_ppdMakeModelSplit): Better commented explanations.
	(Foomatic.addCupsPPDs): Don't include foomatic-provided PPDs
	because we already know about them from foomatic.

2006-06-30  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.19.

2006-06-30  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Printer.parse_xml): There's no ppds node.  Handle
	lang/*/ppd.
	(_ppdMakeModelSplit): New function.

	* system-config-printer.py (GUI.on_tvNPDrivers_cursor_changed):
	More reliable PPD information.

	* foomatic.py: Use /var/cache/foomatic/foomatic.pickle for pickle
	file.
	(Foomatic.addCupsPPDs): Strip PS/PXL suffices from CUPS PPD
	nicknames.
	(Foomatic.addCupsPPDs): Add loaded PPD drivers to existing
	printers.
	(Printer.getPPDDrivers): Strip .gz when comparing file names.

2006-06-29  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_delete_activate): Clear any
	un-applied changes.

	* system-config-printer.glade: Make buttons on the new printer dialog
	all the same width.

2006-06-27  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.18.

2006-06-27  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.setDataButtonState): Print Test
	Page button is only sensitive when printer is enabled, accepting
	jobs, and no changes need to be applied.
	(GUI.fillPrinterTab): Likewise.
	(GUI.on_btnPrintTestPage_clicked): Tell the user that the test
	page was submitted, and which job number it was.
	(GUI.on_btnPrintTestPage_clicked): Handle test page failures due
	to the remote printer not being shared.  In theory it should be
	possible to print test pages there, but needs hackery.

2006-06-26 Florian Festi  <ffesti@redhat.com>
	* system-config-printer.glade, 
	system-config-printer.py (GUI.on_btnPrintTestPage_clicked): 
	Print test page button

2006-06-26  Tim Waugh  <twaugh@redhat.com>

	* po/POTFILES.in: Include the glade file.
	* po/Makevars: Bugzilla for reporting bugs.
	* system-config-printer.glade: Some translatable="no" fixes.

2006-06-25  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnNPApply_clicked): Set
	newly-created queue enabled and accepting jobs.

	* cupshelpers.py: Strings marked for translation.

2006-06-23  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.17.

2006-06-23  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_tvNPDrivers_cursor_changed):
	Provide PPD information.
	(GUI.busy, GUI.ready): New cursor functions.
	(GUI.on_entSMBURI_changed): Check whether to ignore this signal.
	(GUI.on_tvSMBBrowser_cursor_changed): Suppress signals from
	entSMBURI when we set its text.
	(GUI.on_btnSMBVerify_clicked): Implemented.
	(GUI.initNewPrinterWindow): Grab focus after setting text, so that
	it is highlighted.

2006-06-23  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.16.

2006-06-23  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillDeviceTab): Filter out
	hpfax:/no_device_found.
	(GUI.construct_SMBURI): New function.
	(GUI.on_tvSMBBrowser_cursor_changed): Use it.
	(GUI.fillNPApply): Don't reveal SMB authentication details.
	(GUI.initNewPrinterWindow): Clear out SMB screen.

2006-06-22  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI): Show SMB tab.
	(GUI.initNewPrinterWindow): Set up SMB browser columns.
	(GUI.on_tvSMBBrowser_row_activated): New function, ported from
	printconf.
	(GUI.on_tvSMBBrowser_row_expanded): Likewise.
	(GUI.on_tvSMBBrowser_select_cursor_row): New function.
	(GUI.getDeviceURI): Use constructed SMB URI.
	(GUI.nextNPTab): Load foomatic after getting the new queue name.
	This way the dialog appears as soon as you click 'New'.
	(GUI.on_btnSMBVerify_clicked): Added 'Verify' button.

	* pysmb.py: New file, imported from printconf.

2006-06-22  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.15.

2006-06-21  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py (Foomatic.getPrinterFromCupsDevice): Best matching.

	* system-config-printer.py (GUI.on_tvNPDevices_cursor_changed):
	Select make based on the selected device.

	* system-config-printer.py: Copyright and license header.
	* cupshelpers.py: Likewise.
	* foomatic.py: Likewise.
	* gtk_html2pango.py: Likewise.
	* nametree.py: Likewise.
	* options.py: Likewise.
	* optionwidgets.py: Likewise.
	* probe_printer.py: Likewise.

	* system-config-printer.py (GUI.show_IPP_Error): Tidied
	translatable strings.

	* po/*.po: msgmerged from printconf.

2006-06-20  Tim Waugh  <twaugh@redhat.com>

	* configure.in: Version 0.7.14.

2006-06-20  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Device.__cmp__): Fixed device sorting.

	* foomatic.py (Foomatic._write_pickle): Fixed typo.

	* Makefile.am: Ship config.py.

	* configure.in: Generate config.py.

	* config.py.in: New file, for any autoconf-generated variables
	such as VERSION.

	* system-config-printer.py (connect, main): Use gtk.gdk.threads_enter,
	because gtk.threads_enter is deprecated.
	(GUI.__init__): Set up "About" dialog strings (bug #192764).

2006-06-19  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.13.

2006-06-19  Tim Waugh  <twaugh@redhat.com>

	* Makefile.am: Added automake infrastructure.

	* foomatic.py (_write_pickle, _load_pickle): Don't use /tmp, even as
	a default.

	* po/*: Added i18n infrastructure using gettextize.

2006-06-09  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.12.

2006-06-09  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (PrintersConf.parse): Handle empty lines in
	printers.conf (bug #194217).

2006-06-01  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.on_btnNPApply_clicked): Fixed
	typo.

2006-05-31  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.11.

2006-05-30  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.getDeviceURI): Use correct widget
	names (bug #192764).

2006-05-26  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.10.

2006-05-26  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Set 'Job options' help text.

	* system-config-printer.py (GUI.__init__): Grab
	entNPTDirectJetHostname and entNPTDirectJetPort widgets from the
	XML (bug #192764).
	(GUI.getDeviceURI): Use them.

2006-05-25  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.9.

2006-05-25  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (PrintersConf.fetch): Handle IPP errors
	somewhat gracefully.

	* system-config-printer.py (GUI.__init__): Don't assume all LC_*
	variables are set to the same locale (bug #192807).

2006-05-18 Florian Festi  <ffesti@redhat.com>
	* cupshelpers.py (Printer._getAttributes): filter out "notify-events"
	because it is not (yet) supported by cups
	* foomatic.py (Foomatic.getPPD): new method used by new hal_lpadmin
	* system-config-printer.glade, system-config-printer.py 
	(GUI.on_btnRefresh_clicked): Refresh button

2006-05-17  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.connect): Turns out we need to set
	the password callback again when we start a new thread.

2006-05-16  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.removeOption_clicked): Actually
	remove the option from our list.
	(GUI.save_printer): Fixed debugging code.

2006-05-15  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.8.

2006-05-15 Florian Festi  <ffesti@redhat.com>
	* cupshelpers.py (Printer._getAttributes): Support more job options
	* system-config-printer.py: refining interface for job options
	
2006-05-05  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Ship options.py.

2006-05-04  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.7.

2006-05-04  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.desktop: New file.

2006-05-04 Florian Festi  <ffesti@redhat.com>
	* system-config-printer.py(GUI.fillPrinterTab, GUI.save_printer,
	GUI.add_option, ...) Support for job options
	
2006-04-28  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.6.

2006-04-28  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Make it actually run.

2006-04-20  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.5.

2006-04-20 Florian Festi  <ffesti@redhat.com>
	* system-config-printer.py (GUI.fillServerTab, 
	GUI.save_serversettings, GUI.on_server_changed): Handle server settings

2006-04-14  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py: Exit gracefully when DISPLAY is not
	set, and when '--help' is given (bug #168485).

2006-04-12  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.4.

2006-04-09  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.fillNPApply): Fill in name and
	uri.
	(GUI.loadFoomatic): New function to load foomatic database (and
	get CUPS PPDs) on demand, since this is an expensive process.
	(GUI.unloadFoomatic): New function.
	(GUI.on_connect_activate): Unload foomatic.
	(GUI.on_new_printer_activate): Load foomatic.
	(GUI.on_btnSelectDevice_clicked): Likewise.
	(GUI.on_btnChangePPD_clicked): Likewise.

2006-04-07  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.3.

2006-04-07  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Packaging fixes.

2006-04-07  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.2.

2006-04-06 Florian Festi  <ffesti@redhat.com>

	* system-config-printer.py (GUI.on_connect_activate, connect):
	Open connection to cups server in a new thread to avoid GUI freeze
	* system-config-printer.glade (ConnectingDialog): Shown while 
	connection to server

	* system-config-printer.py (GUI.save_printer, ...) Do error
	handling when communicationg with cups server.

	* system-config-printer.py (...) make GUI strings translatable
	
	* foomatic.py (copyPPDOptions): Migrate options settings between PPDs

	* foomatic.py (FoomaticXMLFile.getLangComment): search for language 
	fammilies
	
	* foomatic.py: "Generic Raw" printer for raw queues

	* system-config-printer.glade (NewPrinterDialog): Tab for applying 
	new PPD: Ask copy option settings or not?

	* system-config-printer.glade Commented out Server setting tab, allow
	no printer is selected, support not connected to cups server

2006-03-27 Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Always set
	self.conflicts, to prevent tracebacks in self.setDataButtonState()
	later.

2006-03-27 Florian Festi  <ffesti@redhat.com>
	* system-config-printer.glade, system-config-printer.py:
	New tab for Access Control, list with add/remove buttons for 
	user handling

2006-03-25 Florian Festi  <ffesti@redhat.com>

	* system-config-printer.glade, system-config-printer.py 
	(NewPrinterDialog): Reuse NewPrinterDialog for changing Device
	and PPD
	
2006-03-23 Florian Festi  <ffesti@redhat.com>
	
	* system-config-printer.glade (NewPrinterDialog)
	* system-config-printer.py (GUI): Redesigned PPD selection, added
	filechooser for providing own PPDs

	* gtk_label_autowrap.py: online fix for multiline gtk.Label to force
	adjustion to size changes

	* gtk_html2pango.py (HTML2PangoParser)
	* foomatic.py (FoomaticXMLFile): Convert HTML to pango markup
	
2006-03-20 Florian Festi  <ffesti@redhat.com>	

	* system-config-printer.glade (MainWindow)
	* system-config-printer.py: Removed Server CmbBox in Toolbar, make 
	Connect Window default to server of currently selected Printer.

	* system-config-printer.glade (NewPrinterDialog)
	* system-config-printer.py (GUI.fillNewClassMembers, 
	GUI.on_btnNC(Add|Del)Member_clicked): Change member handling in new 
	class dialog to the same way as the main window

	* system-config-printer.glade (NewPrinterName)
	* system-config-printer.py (GUI.save_printer): Copy printers and 
	classes
	

2006-03-17 Florian Festi  <ffesti@redhat.com>	

	* foomatic.py (Foomatic._add_printer): fixed bug: used printer.name
	insted of printer.model as keys in self.makes[make][model]

	* system-config-printer.glade (NewPrinterDialog): Visual improvements

	* system-config-printer.glade
	* system-config-printer.py (printer data handling): Changed Allow/Deny
	from ToggleButton to ComboBox

	* foomatic.py (Foomatic._load_pickle): If there are files with 
	newer mtime and discard pickle

	* system-config-printer.py (GUI.fillClassMembers): Support remote
	Printers as class members
	
	* system-config-printer.glade
	* system-config-printer.py: NewPrinterDialog also supports new classes 

2006-03-17  Tim Waugh  <twaugh@redhat.com>

	* foomatic.py: No need to adjust sys.path.

2006-03-16  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.1 (packaging test).

2006-03-16  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Don't forget to ship the glade files.

2006-03-16  Tim Waugh  <twaugh@redhat.com>

	* Makefile: Version 0.7.0 (for testing).

2006-03-16  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (pkgdata): Prepare for packaging.
	(GUI.fillPrinterOptions): Remove temporary file.
	(GUI.on_tvMainList_cursor_changed): Place-holder for handling
	remote queues that no longer exist.
	(GUI.fillPrinterOptions): Place-holder for handling raw queues.
	(GUI.initNewPrinterWindow): Better initialization.

2006-03-15  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.py (GUI.__init__): Fetch entNPTDevice
	widget.

	* foomatic.py (Foomatic.getPrinters): Use glob for this, so we
	only pick up XML files.  Foomatic has shipped DTD files here in
	the past, and may again.
	(Foomatic.getDrivers): Likewise.

2006-03-15 Florian Festi  <ffesti@redhat.com>	

	* foomatic.py (Foomatic.__init__): pickle printers' make, 
	model, name to disk
	* system-config-printer.glade, 
	* system-config-printer.py (GUI.fillPPDList): GUI for selecting 
	printers and drivers (no "give PPD file" yet)
	* system-config-printer.py (GUI.fillDeviceTab,
	GUI.on_cmbNPType_changed, GUI.getDeviceURI): 
	Use cups.Connection.getDevices() for DeviceURI GUI

2006-03-14  Tim Waugh  <twaugh@redhat.com>

	* cupshelpers.py (Printer.setShared): setPrinterPublished changed
	to setPrinterShared.

2006-03-14 Florian Festi  <ffesti@redhat.com>	
	* probe_printer.py: First code for probing queue names on remote 
	printers/printing servers.
	
	* cupshelpers.py (Printer._getAttributes): Read CUPS printer attributes
	* cupshelpers.py (Printer.set*): Methods for setting CUPS attributes
	* system-config-printer.glade: New tab for CUPS printer attributes
	* system-config-printer.py (GUI.fillPrinterTab, GUI.save_printer,
	GUI.on_printer_changed, GUI.on_tbtnPAllow_changed, 
	GUI.on_entPExceptUsers_changed): Handle CUPS printer attributes
	
2006-03-10 Florian Festi  <ffesti@redhat.com>

	* system-config-printer.py (GUI.__init__, GUI.populateList):
	Make main list a tree (remote/local printers/classes)

2006-03-09 Florian Festi  <ffesti@redhat.com>

	* cupshelpers.py (Printer.__init__): save cups.Connection within 
	Printer object
	* cupshelpers.py (Printer.set*): Methods for setting printer 
	enabled/disabled, accepting/rejecting, shared
	* system-config-printer.py (GUI.fillPrinterTab, GUI.savePrinter):
	support for the settings above

	* system-config-printer.glade: signals for printer settings 
	* system-config-printer.py (GUI.on_printer_changed) keep track if 
	printer settings got changed

	* system-config-printer.py (GUI.fillPrinterTab, GUI.fillServerTab,
	GUI.setCmbServers): fast goto server feature

	* system-config-printer.glade, system-config-printer.py 
	(GUI.fillPrinterOptions): polished MainWindow

	* system-config-printer.py (GUI.fillPrinterOptions)
	* optionswidgets.py (Option.__init__, Option.checkConflicts)
	* system-config-printer.py (GUI.fillPrinterOptions):
	Made conflict icon a button 
	
2006-03-08 Florian Festi  <ffesti@redhat.com>

	* cupshelpers.py:
	new Printer class, cups.Connection.getPrinters() replacement
	* system-config-printer.py (GUI.fill*, GUI.save_printer):
	change printers to new Printer class	

	* system-config-printer.py (GUI.fill*): don't allow changes 
	to remote printers
	
2006-03-07 Florian Festi  <ffesti@redhat.com>

	* system-config-printer.glade: Tab for members of printer classes 
	* system-config-printer.py (GUI.fill*, GUI.save_printer, ...): 
	support for printer classes
	
2006-03-06 Florian Festi  <ffesti@redhat.com>

	* optionswidgets.py (Option.__init__, Option.checkConflicts):
	Conflict handling
	* system-config-printer.py (GUI.fillPrinterTab) Calculate conflicts,
	add conflict icons to table
	* system-config-printer.py (GUI.option_changed, 
	GUI.setDataButtonState): disable Apply and Revert buttons on 
	conflicts and show Error icon

	* system-config-printer.py (GUI.on_btnApply*_clicked):
	ApplyDialog
	* system-config-printer.py (GUI.on_quit_activate, 
	GUI.on_tvMainList_cursor_changed, GUI.on_connect_activate):
	Run ApplyDialog if there are unapplied changes 

2006-03-03  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Make error dialog label selectable.

	* system-config-printer.py (GUI.on_btnApply_clicked): Some
	error-checking.

	* system-config-printer.glade: New ErrorDialog.

	* system-config-printer.py (GUI.cupsPasswdCallback): Set query
	label.
	(GUI.cupsPasswdCallback): Set transient for main window.
	(GUI.on_btnApply_clicked): Only set PPD options if they have
	changed.

	* system-config-printer.glade: Better PasswordDialog layout.

	* optionwidgets.py (Option.__init__): End option labels with ':'.

	* system-config-printer.py (GUI.fillPrinterTab): HIG spacing
	between labels and widgets.

2006-03-02  Tim Waugh  <twaugh@redhat.com>

	* system-config-printer.glade: Use a Dialog for
	Connect... dialog.
	* system-config-printer.py (GUI.on_connect_activate): Run the dialog.

	* optionwidgets.py (OptionBool.__init__): Use CheckButton's
	built-in label.

	* system-config-printer.py (GUI.fillPrinterTab): Textual
	printer-state description.
	(GUI.fillPrinterTab): More consistent layout.

	* system-config-printer.glade: Added 'items' property to
	cmbServername.

	* system-config-printer.py (GUI.on_connect_activate): Populate
	server-name combo-box from browsed queues.
	
